topic "Native MySql connection";
[2 $$0,0#00000000000000000000000000000000:Default]
[l288;i1120;a17;O9;~~~.1408;2 $$1,0#10431211400427159095818037425705:param]
[a83;*R6 $$2,5#31310162474203024125188417583966:caption]
[H4;b83;*4 $$3,5#07864147445237544204411237157677:title]
[i288;O9;C2 $$4,6#40027414424643823182269349404212:item]
[b42;a42;2 $$5,5#45413000475342174754091244180557:text]
[l288;b17;a17;2 $$6,6#27521748481378242620020725143825:desc]
[l321;C@5;1 $$7,7#20902679421464641399138805415013:code]
[b2503;2 $$8,0#65142375456100023862071332075487:separator]
[*@(0.0.255)2 $$9,0#83433469410354161042741608181528:base]
[C2 $$10,0#37138531426314131251341829483380:class]
[l288;a17;*1 $$11,11#70004532496200323422659154056402:requirement]
[i417;b42;a42;O9;~~~.416;2 $$12,12#10566046415157235020018451313112:tparam]
[b167;C2 $$13,13#92430459443460461911108080531343:item1]
[i288;a42;O9;C2 $$14,14#77422149456609303542238260500223:item2]
[*@2$(0.128.128)2 $$15,15#34511555403152284025741354420178:NewsDate]
[l321;*C$7;2 $$16,16#03451589433145915344929335295360:result]
[l321;b83;a83;*C$7;2 $$17,17#07531550463529505371228428965313:result`-line]
[l160;*C+117 $$18,5#88603949442205825958800053222425:package`-title]
[2 $$19,0#53580023442335529039900623488521:gap]
[C2 $$20,20#70211524482531209251820423858195:class`-nested]
[b50;2 $$21,21#03324558446220344731010354752573:Par]
[{_}%EN-US 
[s2; Using native connection to MySql&]
[s3; 1. Prologue&]
[s0; &]
[s0; There are two ways to connect to MySql database using U`+`+ 
`- either through the ODBC layer or directly using MySql libray. 
Using ODBC is the easier way. The direct connection is more tricky 
but is more reliable when database is very large and has a lot 
of records.&]
[s5; &]
[s3; 2. Database Schema&]
[s0; &]
[s7; TABLE`_(test`_table)&]
[s7; -|INT`_(id)PRIMARY`_KEY AUTO`_INCREMENT&]
[s7; -|STRING`_(value,50)&]
[s7; END`_TABLE&]
[s5; &]
[s3; 3. Example code&]
[s0; &]
[s7; #include <MySql/MySql.h>&]
[s7; &]
[s7; using namespace Upp;&]
[s7; &]
[s7; #define SCHEMADIALECT <MySql/MySqlSchema.h>&]
[s7; #define MODEL <NativeMySql/NativeMySql.sch>&]
[s7; #include <Sql/sch`_header.h>&]
[s7; #include <Sql/sch`_source.h>&]
[s7; #include <Sql/sch`_schema.h>&]
[s7; &]
[s7; CONSOLE`_APP`_MAIN`{&]
[s7; -|MySqlSession session;&]
[s7; -|// edit the connection parameters if necessary&]
[s7; -|if(session.Connect(`"root`",NULL,`"test`"))`{&]
[s7; -|-|Cout() << `"Connected`\n`";&]
[s7; -|-|SQL `= session;&]
[s7; -|-|&]
[s7; -|-|SqlSchema sch(MY`_SQL);&]
[s7; -|-|All`_Tables(sch);&]
[s7; -|-|// create the table if necessary&]
[s7; -|-|SqlPerformScript(sch.Upgrade());&]
[s7; -|-|SqlPerformScript(sch.Attributes());&]
[s7; -|-|SQL.ClearError();&]
[s7; -|-|&]
[s7; -|-|try `{&]
[s7; -|-|-|// insert some random data&]
[s7; -|-|-|SQL `& Insert(test`_table)(value, Uuid`::Create().ToString());&]
[s7; -|-|-|// fetch some data&]
[s7; -|-|-|SQL `& Select(id,value).From(test`_table)&]
[s7; -|-|-|                      .OrderBy(Descending(id))&]
[s7; -|-|-|                      .Limit(5);&]
[s7; -|-|-|while(SQL.Fetch())&]
[s7; -|-|-|-|Cout() << AsString(SQL`[0`]) << `": `" << AsString(SQL`[1`]) 
<< `"`\n`";&]
[s7; -|-|`}&]
[s7; -|-|catch(SqlExc `&ex) `{&]
[s7; -|-|-|Cerr() << `"ERROR: `" << ex << `"`\n`";&]
[s7; -|-|-|SetExitCode(1);&]
[s7; -|-|`}&]
[s7; -|`} else `{&]
[s7; -|-|Cerr() <<`"ERROR: Unable to connect to database`\n`";&]
[s7; -|-|SetExitCode(1);&]
[s7; -|`}&]
[s7; -|SetExitCode(0);&]
[s7; `}&]
[s0; &]
[s3; 4. Build Method setting&]
[s0; &]
[s0; You have to set correct paths in you build method. In Build 
methods dialog (Setup > Build methods...), choose your build 
method (e.g. MSC9) from the list on the left and then add the 
MySQL server installation paths into the three tabs on the right 
side of the dialog. &]
[s0; &]
[s0; On PATH tab add C:`\Program Files`\MySQL`\MySQL Server 5.5`\bin&]
[s0; 
@@PING:3954&3409
ǍȀҀȃ󀀀
ǝȦŒŤԟ¿Ã݉ڌӢ݇ຫѩſ
˶єˡΙܛϜ룏ͳտƾ
̡͂ۄܞѪ瘰̉ɸ
̘⦳՗Ö髮˿≔֕Ѩ֙ўҮĈ
Ђ̣դꁋՏإæ哛
ǷϞւęع蔾
؍ڟֆ孫欀֑቟فפܑǟٛùۇ͘
ܴ߳ͭފזɛ֗׹꨷لԎ񇚵ϝ
ݳԌ춵݋ܷբ烍ԻЧɓΊ
̻슫ͺ铏զبܥو찌ݵʁϔקΩ
Ɲ黌턷⏿嬹Ӛжς
ӛๆ۽Ӿǡ̀ʍ񀜱𘀘р
ΘƜﺕ٬مވ჎І
ݖ՝ӽǆËݗ񩎺́ӕȺߵꓗ誃Ł掆ƹ
Ҩݕ͗Ȼ̘ܲ໌˞¹ᥩ玉ӡ昦ץŜݦ
ڳܐŧϊފӮʝߡንˈģꚙ§
җۅ邀ӌűѻפ
έ匛ӄᘁĔʸೄΙ
ֲ𥔌䳦ϥ䋊ϰ٬⛀ř
Ş򳽶òɖ̸ܰͨשرՐјř
С܄☀㓐ߟچ˵埩ﻩݾ
ص󤣝耳ѝօϴ؞ɷʥʰؐ
эȑάʪ颩·ѢǜӸԜׁܢړՍƧ˻
醹ўιЍߪ޻逰ʘȅ昰
݆ЩƉ۽썱ߐ凉̬ǐ
ؘҽןܒл˶ȋ
ϓ߾ˠۅݼ֌ī쏢̱֯ג苒챊
ɠ喖թȳ͗ăΰ뙨ᡍ微׽ǦڳÐ
ƞțˍȟٔ²㨊ܴר
әˉʣ蛘Ĝ刂ė޷Ƒ׊憰ʱé
𳖔׻׎킔ð͡Ęˬ΅ӯ
͓ʁƞʱő悃꺜˗𗳓ø䳊٘ǎ欉
Ұ޻ܕ󮽾֞䛘꒩ӺҠп
ۇۊ¹ʡ®ʬ׮뱁啱Ӄܨ´
Ѹ݄ʀⶸައޕΰЬኽ݊
ųёµ⌰决ʉʃԣن򏠑ԗ
Δу֤ԛ縆ũкܙ䖁؆
ù񛊦ҽወǟ⠆ᚨȠᚼ懳٬ǎ
٪ϒ쳦߈ŇäՌ疗ՌÞىǘس
̞נߡޙ֗ـ୻ކŋզƑҌñ
唔Ʈԍ֔䕃ٛϷĻƨܐަب菬
π윦ܷ۸ƉܹƤÌաΣ茠
ڃ¶󬽟ɷ޴ػÃϦޏ۵ਓծީ
Ñՠݛ۝Ԥ̂˝ÌۋƒК«ڦ
๣ꛃйƅ֝͠ճ˗̿Ϟ
婰͓ܜ翅ʏѭܹβƘؼ×ߌ̆Ό쿇ʥ۾
ӗݷש͍Ґ݉дδώ꒷ǥƆӪ𹻐
傔Ś삼֤݆ԥ֕ьɚѯḺվԏ
ƗțǙ󢤪ʦ͹ۊûʋãݰăÝՈ
ͪ豃ۏ˕ƽԠռɻܪǱДݵ営ϊ
֟׾ӗљނƕȗꁓƠșʝ
ιÇÙ̪Ęǀꌸ̿﹛
άɂǍ÷邕ȻɊŵݨǇϗ⋯솀
ո摧ԏش޹恰
Ҽأ᥌뱽ٰ̹ಚ鈅
і㞤лҳۣ䥲ˣ̴̛򺋰ܷ֙Ҧ
ȷ蔒샽殻ح񄄊ՂÂ篸Čۨ㐖ˢӍ
̅Җ鄹ŕ˽ׂΟܛ޶ڭʽٗ󿓶
ﵨХ̦˳Ż܃ۯًñ
Ҭǀ׀Ӳև̓ګڛ󟯤Ӹ
ᗰͫݛƤМÐ瀾КطǓ؀ɀڛڭ
ⅺ쁪䑔卨ŵ̀褸䲹
ܫϞܿ쯇Ǳ᜺ժ᪯ԻȆߣ뺀ł
ћ޿ٞݫ薴שǙؓ۝篅鷧ݽ
Ь׾øΥڊއᆎˤꛣ˪ɹԘ
݀Ά҄ฤנᤌҫָʿ޳ﺘ嗗޽ʘܮˢ
듄֒껴𹜱ߺۧށۿåͽǙ򰐭
ܴ∈ș윏ϐÉ׹ڇȶæ彄Ύ氭ؑ
ҝ̾ùć񘴐爉鮑ˆÆ؜˃򶛢
۷кϣϡӾǣӁ٨ܓǚƹƑȳ
ԕ䢼䬪¼網ꓷĨԓ搿ӦߌکñϹ̀
Ѝè̎Ɵ؊ë߀܋ᗋɕͯ绒
ﻣ筿ƅÜʗ־Č
㑕߁މʠܽٴќ܆ʦ
񉳁ʊ߉މˆ⼥ӝȂÓĪʘŊɓ
՚抷ގƞƤΐާ躛˘
ػ邦ϚצɭůՖۤ꼹３ƟĹ
ɓ̓ؐΞϞϸ⋾ąμμ˱
сɑⶈ왡ܝƾЭيș勯ŵ
蚖ʋъܫჄՙރȑʛ
ʳддץ̥´Ђƀ
ç梞ӌ葔Ӧƍȡܵ閜ưť╕רԢ
ޢʉ̨̬͘Ё̨ҽ쀾췕ϱ
ⓦֹʰ˶ƣ֑ꐓьŗ߬Â
ʫӧݩͣ⦬ޅןɞ
ް渇׵魋㯀鋳֓ݍ箄څ
ؿꜝȞʿⱕݟɵ޴ҤÐɐ
霂±԰Щŏۑۙѷݬ捨đмʜ
՟ڑДդܯڞ⿆͋جјᬉۭ
ם۬ףʻ߫˳߫áĵ忲ґڽ˛紬ĉ҉
˜ԸˢǝǇ΄ě⵲˃᪪ǃ
ֆʓ̂Ƶ¬򎷋γ܊ذÜĸ
ѪŬ퍸ʉ䱀ҋ֠Ǐƍ׿铿ߛݯɴ
ǧ꿀ェѯ׽́ӀǒТ󞏽
흉솿޳น绁ȧ߳ŏȞ
˴͈ۗ¥۠ޑȩΒ荋ިËѷ
ڼŢם菲ш»ꗡ񘖜ԥʎɰ
ؾ׼˷韴ԍҕهµ嵆廈ο
ய݂ӝΕ꿜뻥̂ɃޠśϤ
㏃ݣ߶Ƹ֤ȝЌײε
ނȜĹ׋˴펌܍Ķ۱ԝ隰
܌ʤǴ܉޵۱̷೬؍櫸
󮽟оǗԄʠܟ๹؛ȨဈО
º֪̒Ö呞ϛә
̊߯ǳ턬Շӌ՘ݭ˜ȡ헐оƬ䆎춫
غ󠾜ǖœ绗߾ހΎܲ
˧܎ʛ𸺳ږǧ洎غ
ťәۧ񈮷׀ލԧ˦ߦ̧򶫍쒢
ſΟɽ況ۼ޸뾇쏫
֕뀅۸뮁ݨ꺍Ώꓜݞ͌ހڄֽӬ
µ܍Ȱچɒڞᐽʙܥ򨑋Ĵ
ǅ٭ӌ۟ҍ܂Ϧ҉Ȅ͚ڢż
˥΅ڵʻжıھۇדƗ
Ƙĩߏުʯ߆ף
لݧ̵𵯭շƎ뺹暕󭖘ɴŇ
Ŀ㉕ګǾ湀߬؈畱ᶳ
Ś˦şכԀÿȣٸͳʸӏ̀
ԄԀ¬쫺߁Ȉ쀣Цׅʻױ
Ⲋ㖹Ŀݕ䣠҈ٺÃއ򨒐ё񪓅܁⮆
Ô矿ѩͳӞɼ֍μ鵅ހ𭍊
ҢÔ먩ҵϴܿξފÙˉ찳
Ү㖩ݿ֑ڃƌ̰ޟϡ鬀ўջ
՜ŌńΟߋ𜽇ڪ׶
瞖ۭ͛ۡ۟Γ׽߻ȿ
֞虅ɴꙘ׺ȟשʴܕģήǧ
βˡȷ퀕һဢкݍ祐ǝ؉펭Ʊݴ
ʎ͝Ĕճê̗뙳ՠʭ׿
ΐ椂ȡⱘⱘ⪟昀
ᘻܣ׍ˡЧӅɧҸ旅ǰ
酾ս֜ÉǏڻ£ټ̮՟׋ˣ߄
Ȳ¨ꩦͼ蛷褱Δら¾˫ǰ𛙃Ҁ
紆౥àʺ疍鶄Ǩ묠ݙǯ˹߄
ĻęΜ爐ϗ譻̊񸟁𦩏וܰÖǘۑקи
ߨˤʹسңſîѕƉ޲Ο냋ֆ̶ڇ
ዣі௓ҟ痱ߊ˷چοృĐԛ혭Ɣã
Ş鉀񇿽ȅϬƘМը
Ȕٍ݉넜ݴΣɡϖ㦞ǳИܦ
涁Ź噶卻̱͝ǐ旚蕔۠ʝ
Ʈ¼瑎̻¥จà󷠐ˌସùʭʒ
ߘÎἰދϛժ룍ùöђ
ݐ䔬߷ׇΛԞ嬀ၲࢍÄ隱飥ň
ݡ䣓҈錹꧜ҵ𚥼ڃӏ陘
ƵȂˈúיÜͪՄͷۄչѮ
ǩ㐐͵ߌͪ͟ęɫҰݙߵƘԹ̒
Ѷܯ߼ߵʤ󱸦˝؏찮Ԟ丯ھû
呾ы纭ߠ®ڳ걦¸
Ѕ܇ŵĺݨ꺣ґƹ샃̒ڛ쏏͵ɩ
ӗ߆ϋԆ°׻ܷķжЩԎٞ
Ƅ߁ҕĺׇ̟ŦĆי
糰ًٛݼՍ쪬ȼԉҞ՟ԋ䨂
⸕ƔӮίТ͘ⱘ򦪉𷊕˫Ͳ
̣ոʈЕׁ΀ηϽ֔Ւ퀂
Ǩʴə颜Ƿц͏뼚Ǚן
֬۠⡼񶌳²ȟᆅȴ
րŉʪȿå師烪ۊɩ՞ڛ̀
ьθݨƉݭܞŮ۞˰剂η
ΜҜ찏߀̡ÎɉÞ̯
ܿǖǿԄ̷ƌݝ˩ǖȎʕʷ
삖׻ҭآ̟İɼݖő
߯Ѫټ˭߁Ĵŏřԗ؃찊콗ˁ
Ԁ痒ꕎ϶섣것瞰ןǮ㢜ܷ
ܱշھԑ̄㡢܀ʉǽʸƅ
콲ǍꙔэՈ璆κ
כ؟ǔ޺ߜً׺ޥ܉وóՂߪˤՋ訲
ƲӄŃޱҾځۑĊڇǓ颜
ȘȬηȐћǗٖڰČВ҈Û
ʖђɑŹʾ쎃˓۲󘩺эʐʅÞπ⯠
٬ή̀ăߊٕ넅؈Ĉԛ۽椻ˁمظ쨫܎̦諥
˴䕷ěǏ߻ϘǨɻЮ񥱪򩌞ێгŲ
ñπŜŞƑč˨Čɯɧђ˙ǵ¹
䶾犔Ԡ߿胘ك߹竁
ƅ∂¼Оϫǎ
ш뫯ř𓤒
脱ӪȮكʊ뭘ػ衤׬ҥíޑĉڔ۔
ۇی☠أ繨゠φԝӼ߾ĂьǽҘꪴĄ
䦎ɓ܌ᒉՎĉɜߏɓØ۔Ř
ُƍ܌؇Ęܗ̄
ޥƍ՗д퍳鐣ڒॕںă陆˿ȯح
۳ꑾĽϋ۷н튟ʿߏ΋ǔÒ؝٦ǭ焱ݟ
Ȍ݀Ԩ̄䄐ж̦̖׍۪隰
͎ǆ犷՗̾Ѱ߾٭ݏɵ᷄ӛل
۷ҍŇȧѐȬĴҮ訏ʺ
Ǻ֮ق٨􎢎ƞܩ܃ǳ
獸쾝̄㥩ֹ̛ҼفḦ̙Ԓ梍
洇൚얶ȁ
؋򺃷ʉ؏ŧϰךΓ򦠎א
ƻɴߢȬڄ߬ƾȼ᫸͗ˮõށ
٥ӳرƗٳӺ㢽̐է釨͟ǿ铍؆
슠ҭ䲖㈕Эȴ݈̼֩
ʫٔߩŨڃڥ߈ۏл
ܳ߼ɡϨĤ޿Őρ
ѦǉȠшϟǠښ봹֣州ڽضəŁ
فܥ򿀃⫎ĥݘꗷ
߁݋ߘ춻ˀԃҁͳأޓ׫ኒ˛к
ڷߡﳽ눓ԡۭàǽ
ǺĘܴδ溜᷸ι䪫
ɴշ׫ʉڇ݋ŴѤ
엊ꝲΓӐΞߎ˴گ݃ͿΧݎߍ۟
ڻѝ瞋ἾڢճҨ
яꗠǖɵω˧ǝᕡǀ눟牸ֲȥׄ
瀼췊޸݇ښОѥ
񀁦٪󰰮ݴ蒛Žɧּܮ޹
À񱃻Ǟ흺́е뺱嶨ؗӰɴ¤Ŧ
Ջᬾ堈茭򗺫ӗ韨ۓÜ
񹑣궀Ȃȿյĵݔʺըܵ
߄͝ܥǞǹճļϻ㡛쫣ѩ۝ÇȾԡ
仝ĲͻǺμ͢٥둵ǥﴻ䒰Ӭ謁荸ᣖ庀ڟ
ېկ՚ûߟඳ幧͚ۯ
ۨߍܢ߽Ĳ𦈃Ǘѱ譭
Ŗꨶμ̜欼޲܇폕ǒş߹Ӊ
ǝ􄞶вՃ뱴˱ЕȧƜۃщȠ靜
ȦĶЏҥɤѹԣοҾϐ
䧾Ȑߎ­îҐŊܹ
ǝؕ´޲ୣט񮓇ی˯Ħɕíγ붆
Ǧ۾ߋђ򱂠̑گ݊ۗ܆
񳕂ǢŚɆڴЕ󣈁ⱰᝥʟȽܽ㍲
߿ᖇƌߡíʞё׾Øı
͊ʔط֬ᖇݺʉíƘۄ򠆈˘
ݔ۸׀ΘЄձص͚ۜٙíř
ᢿԒ͜ωǩùŋÎ؄ʌǞ
膭̐͒į
ɵܯϨȘ؍č¬ڥ牻ƫ
ԉ毪ÅʍϿì到ˬ
ƢᧀǔȽ፽ۂǬĚ嘅𼂬À
殘ఒԃ˖ՠفެՂ劌ί
ܝȍ΅徟ǃ題ؗŽص򫺖
؝ڰؿϬڑ𙒵õȳ؈ހ
跗ŅήĘĞǍ˗ʑƢΚږꠗΘ
؉ؽ۱ֲο셇񹵤걥Ќ
ǻóܑ؜ԍ׸հΙ뉖ì
ل¢兡𤢈Ѝ˔ʭ䳂ľؿ
ۆ씂ގŋ҈ۯ
ӬɄւ뿅ƛڋ˞ҶŐ㜃ᘗҘ
ゥެųǅ؈ضӬಖ̋
մ֯ȶˬ񆒪ثہą
⾞̽˞ǲǝӾ˶޹͊ؽ۩
ͬߺ䠈؏Ż±ӦʳゐƾȨòރьӭ֣
᭩񎕗ڴĖŁҳ뢞ɋǐĝڭɀڤӜѿ܂҄׆
ťڒ՘ߣتԖڰ䫥ߑŃК҆
ꨧιʰ堈頞ג੿׉ܫ
М繕㤃ۦŜ쥅ۮˢ܍˖ϡш֑բ۰˼ζ
á⌑ڀΧ̚
ˆæ͕΢ۊ맭묒Ɔ꥖ƪ
փ΢ɭ˯Ԡ݀ʿ̇ˁͯՂֹ͐
҈ہگӥ랿퉐ڴӈʙ﹐̍ܜ҄Ѕ
ԇ֜Ըᝓ⛂Щӌ
胐ğռ큲רᶜՎԗۏЄצܮ
ՂŔ٨ŨԱ鴌Ψآ˔Ħ
̟ӈޱ϶ىظৗ؅ֺ
ΜؤύїﶁȻܖĹϧЈꆨճ۔
ඬڶݵʧʳ܆˄ʅъܔΰ䆨úԀθ
ČӀ٧ޯيکɏӄЍ
خꃺ唪٫߱սז¯Ƶӄߚ
ݎжӺ皟ׅ󗵲ԦȠܵƂ׀
ɳ؏̘ߐϨםᮈؗڠ놭ǡֳﭑꐠ˛٨
ůě˿닢ڒћȠѾ˰߷Ƞ
ֆݎЏڀ֥ɤ㺰ϭذԦĨñӏρ駔ν
ė筍ߗ䀗ڂڣɽﱋ܈Ǡ
څۚśǫ󛰐΢˖ӻ̂횕Ǵ۾ﺔƑ
̺ݺ࣓۟ß炷Ҥܧ؀⣄ƸՇ肻
դ鳖͜Ϻ哜ä詓؂لЗ̑Ը
ﮰΝձ穚罖չ̀ϵşǕ
Ɲ޼΅ռމً؄Ꞌ˃ސ
ڧ􏡌ҷˡ͊噓榴ћр
μ٫΂䴵҂ݡ取м
͚ԩۜ݋ɬмÐЛĬ޼ꠈ㜷˗
СíѤ݅ږ뮽⬢ܘСإѓϦ
̞í磇ż̓Ⱥܻ݌Ƙʸ⨯
ˢ̭ɴʠ׆ִۖ頯
ŀ񬲲ƻ庯֖ǸؘᒙҀȧۂë݅ӌ
ŤꪚƠڢȀٛĘĂї׊ӐĘ񼛐⒕ɴ
Ϳً̬塾ܙƏ娟׆ٲł框
簅δߜ촯䍩؞Ռװᐥ眦
ܴڍðڐǌÏٜٮӺ
芜𹲥ɀ󌱷Ұچ木Ȃԣ˛Ϩ؝׏أ
ɱΖ⪍ոħǼٜːϏ۩¦
۲讂òȏɬöÍ没ռģϧ
ޤժَӢӂ⪨Ӽʆ㷈ɖҲ
Ɇԋ̼˯ƾ񬉹ոȱڞ۳ϒꜰơ
嘷ֆǗզͶىޛ܇䲙ƴɗ܍ڊ
ͬݙаĎܞܲҨ
Ė̆餚ꗢ߲ȼ˝넺Ĳ
ĝʋޱߟ燼
Ōْججʆð稜Ў՘갠䃒Ե驔ռ
ɥƛʃ̣ĞŁŶܢۚ
ГЦկЦ뮠߀΍֢ۄͥĹعӺ
Řܹέܓ㑷ܘхٵַƖ
͋ٝ䚢ʵ̲խڸ皏葄ַ΢Џ
ˇ퀖Хƿۻɨƻܣʤܺҳǎѿ܄
Ѻƍ𠖋뻶ڰȵƠة¶Ӆۃۋυ
򌯟Ҧ慌ڐĸՠ±ƺ׷э
լЍө簉әɈƪˍʽ
ݥΎ𐒎㴛﹓ɾΙ㏻
ݞܭݵګѝհಬё񯝬ǖ
ьަŻǀѹϒ݌ֵ޿܅ȴѰ۽
ۄͳȤċ©Ҡ͠ƶ㽵𥼌ݸ
͒񐈀ڄܢ񼊖ᣦ
֡ոӦލ۱͛㌕ʕ㗆۔̑֬ر
훨ѵ÷ʼ˨𮔼İխØ̫ŀ훂ɂַ
󦽍ѫ۸ǩ߬š
ƌؿʆ۔уܐјЗ؈ٳđ楛ط̍ܢ
׽ۿҭصꞕۜʰҤ󟛈шƅÔǔÂ
ȉᦛƝ˯ɞ駞Ϝ뜁藺ݨʃׯ۟
莞՟̝̱裸ऴҭڼ߳ϡр뻔É
ɹڐ֤т䆡ҥᬃﰃːȤ͢ݻî
ßٍݣݍ춛ƺڡޢՌϊۮ޸
΢޲޽Ы򊢤ĩƪᝰ߱ʩƟ
ȇރ忹߱ѭ̳㝣Ǥʔ̝߿
ێѼƾڒʧկݺڂ
Ϩ®ϦըӚؿ餛ƒԊΪҘԋӅ
ޮㆱԜ帲߀֬ˢԠߣץΒ
òŝ戴湊ۿ܇ɉײڊŐߣմݸ˹
ĮΓ̛ڨ뱐٪¬˩菭鲖岧訯Ǧͨۖ֐
绁Űᖥͷìɥظ֣
ؓɠ߄ն깿ƧζːԮ­ƗО̃ȡ㥶ݖҚ紻˛кԻ
ܰư屸Ȝ޹ǡˁڲ
ֲۈӴƎ؛ӄŹʔ歗
̖ԍʫݰ҃ȝ⛜ɤ˽ӹŶ
Ŀؚڎ׿℆ⱘۿݤš̙Ƹ剉կۻ
ܔĄ㍷Ҿڃнտ؃ܛ뎂Ӧ
ٻʻ怐ޙ˹ș刞
ָƎ̺͝񸋴ݼնɒꩧ
܉߳޽ُңƨצȭʏӁ
̳̒ܿꅈΤܮ˩󘉮ߌ큫߆曍
ꆛ̲ڦ޺Ћ؞ۦЕʡˍߧ
۽Ƚѳ邇촬ܝ칏ŬȽ
ϭڦ窘Вҝٮݸϱ
瓟ü蹺ǎݓθя׍懆
賚˲ϓߘǳǋĮݻ֋
̿󕷙ޜ߮ͣҳ֛۠ٚІϕߛ
Էߗق񅈦ƕǣ
ئǃ߷ܼ춖ѯڗצ҃ҝͶ݄믽
ր˯ӼկǑﮞ܀܍享؂
ख़㏿ǑƟʙΨ֕Ɩ
Ǥ׽܃ӧǿܱꫀƽ܃ƭƢԟ˚尞Ɍ荂
ȟя漾ʃ♰ьُ
À䁝բ񐜃뭵ʦր؁єڃÃ
ů͜߸̜͛ڿԧ̏էƾޅ
ץԿѳ֦ćߴнط
皃ܻ㲯ۇĿެ߼ۇֽ߽͔̒߬ñ䀸ۖ
¨Ǯ߹г¶ťћœފڠʃƝ
媦𘻶򿣑ƅ˘Ѵͼֆ˿՟
ؿҺۖؐ͢옆ِѩ㑔ƅϥ
΀촌ʧĠ̬ؼĠڐ
ȑѩІظι󐳢в˂兹
ڳҒմ߁Ӹؘ⡒󲐨Եʙ
қѿِ̆˚Ԇڠ۸
ЈÂ׿뢐ߞڗ硗ߺɠŰ
цӚڞڍ䔜Ǩԍ졆貢崀ݻٽĴوȤ蛘
ƉɚȳұĆŉȁ֘و޶Ǵܸ
✋߇̀ؿޠƩ˷ׯ尞޻ۋꉠ
ܹ㎻ގǘƞ߀ܹ蒏ɏ
ȽÈψґٶ񵙑Ճʿ恈Ѷ۸Ђ
܊ϖħϽϘݡßƱÿ󽥋兢ҕ
Ͽߕ꥽ຓ؜뫐ӕŏݔ
݃믮âꕔ蓹߶뮿߂ї¯
퍩̀⸎ةݟޒ݅ÒϿ߶
ǧ򘇕ߝ㋟ݻ횜ꊌڗ䢝҈
Ӷڴϧǣ㜼Ŝڪӳѣθ؅Ρ
ִڝм󾔦ʧ٧闱ɟΝػܺ
։Ӌۈܶȕĵٱۍ可ڋ
Քձ碡ϱԔ퀲Ƽ×ǎ٤򚇎
ǜ𔳸Ӊ䲈ƟڰŒƉԅ
掮ߔݺٳ콌ܸؤ޵ڐά̏ǧؚ
ʢ񄁚λđꞄԽǗۺ
ԇ՗ڨաȧʣϖ׿ڎ΁ݗނ߃ٹ
ǁķɱӘ܉ݽ݊칌ݍ˯ťފ
ںчդͷƖǺեဣ˧ȟฎߵۭ
˸ͼ賓螀飔믿ׁ͎ܲ־
ԘͳʫɊؚ΅聓¦򣚠ɬ㤥é
ˮ՝Έ▟ٻ˽ꤤɿʖәܠ˳
ȏń鿩ԴυىᗞⰀ
܍鴜ՖҲ҅ȋӆՃӧãڲΡЎ
◎ŋؽӌﳄÇӚӅ麐ѳ̑ө߶
ַ֤۔Ӻ꽃֕޺㥎̣ƀĽļӑ
ڣ守ߩфἻǟ῾ѳ
̣Ȋ帒ҽӍُϓߘ
ΓΝﾋصǳب庍ޞۥ薾
̓̇⿐љ曍ݧۛٺз
桟؀Ǌɦ霫ѳηݼюȒ⾘廎օՀؔ
ɻ⺫ϼ؄ӝ
ͷ݄믽ǽ˯Ӽ֣١͠䆯ީو
҈ܧ㈈Á𤗑޹ȮѴ쫢ԋ
ȷޭ끚Ϟ̿ǿÿ
ƏҙǪ؞¹љӊМ돵嗼լյ
ØߩӦՁݲ㷡ď♛˅Ĉ΋͕
Аޢۀύ믭ֺ륲؏Զ̧ҿǏ湓㘻
мׇѩ䙙ӎǺݶٿ˅躌оɖٔ銗
Πƴ֏Ӧзόֶ˕ǳ̚׃ᗪ¶ސӑ
ָÉބɏݍب̅۔ﻋ뉈㬝ƙïڐӑ
ͬ牭؅צܪٙٝնɥΣܖĳڰꈅ܈͛
튮׬фè֔ʠ䓲ޅӧ׵
ŒֶٕڙďӉґׂއЄЖ
ٕͭэ֫ʉǝĘײϹ␺ԅŤަʏ
պɝȿԌȷӽȝۤ㜠
ԮпҖ󵮂פİ񷰝則ǐ
ÐޞݱỤ̈́񇸏Ѡɂۨݗޫ
馩ߡϥБļ⥊܆לҧԽչ
ĞթޫڢڿѺݷ拒ܜԟ߷ſĴՃ
󩄫Ĵĕێգݐ窶؜мі
灼ěڗʽ覢ܢݍԺĕ
ϻ焊󼅑筀ԕ÷ͮРߞ
ʯ˯쭋ՎǕݵԺԆѽ⫥ݻ̏횜
ڗڗתޯрނâÖ뢐՝ر
뢐՝阖ɡТمߒѩԟ
ؠǷӾܻ쥷ڷйƩ։ᙄ迳ʸ֨ѩ덵
݋è⁈޷Ҏڣ漅頍֥Џ̠ںڦ೜զ
ُ̂Ɗ⡊ıіѽ̏ʽړǨә
ֺލ҈搁ϡդۗᕌը󖉹
上峗んᠴʧԇҘߴىჵíАܔ͚
Ɓ끻ڠ Р݃ԗԆω
ëߵׯǎ㡃튴Õۨ✦ڠ
ȥ򯞙˅ຑο䚕ͪ
̛ފߗ˕ҿȳŉǨǕ􉃣̆呮޸
̓Č˪݈ㆍهŤ꧈
ۆӈځ尌˿薛ķȅӁˁۖ
֏Ħ׆Ů展ՊԤ՞ۏ܎҅豉ϧ媼
ڲ蟻ݬϥ㿷
Тǌƃӻۼ颴ʙ׌Ë˷
ғٹݳʭߪê˔ќ䰫䠘ìȍ܏
ẓɽ˸桓ɜӅԘࡨǌ׌ēᜊ
߯ڨځٵװüë̆ˌ耋Ӂ
ǆ¤秔ѽ݋ß⻐꜖׽Ѷڰ
ޱԡǴ͊¨ؔᢴ۽个ܨ␺
Ƶ쾌ۤ܈Ԃݥջ姢֧꼊ך
ЂɘݠɟԆ꜖ɣǫ橺͟߼
ӣǍ̶Н܍̫㖔܂ʓゞ򴏡ݰ
鳪׾ˆъłׯѾØ걚ݷ㚶՟
֦͂ꖗ𿼿Ű޽ӘФȴȱ̊Î׺ě
֢¯߭嶽囍ԯݮϼߦЍԵʹز鏅
շ版錵әϺԅӔ퐕ȉǛ訞
法޳èޔޙҶʛ՝ر󝛄оѓޮՈ
̭ݲèޥ򽄕ěΆ򡈶̛èӴɠĤ
ڽێݔݿ뮽ŵⵌѳ׫υڻ۵
Օսټλ՘ٯԏޯڊ΄޿͸؝ӆ̶ֳɄǢ
ǎڗׯ۪ӹ⠄邈ڶډ˃ąێտ
ΜÁҙǐΏ볨ԁװβּͣ
𡀫ڠٶՌجӜ研ӇěꚖѝ禌
Ǵ݈дܟ߸߼ܟכˣ虓ۄ཯
Ӿ絍컹㏢Ś뢽Υ
֯՟эɣ⡹ߢϜۤͅ´
߭߰ޛټ·ʴ܅ǨǗȌ̃
ڬģƑꞄې̴Ђ化ߝߘ∣ԍ̯Α
̣΋虖ɇѵȷњږܮӓď
򡹻ªǟɥ̤э
Ѵ럘շԹƟ輼ǒۍǴăƟ泙ܓ
ַ씳鱉㡓ɜ؋ןՃ
ŘÝ閗ݕ ܢş埌Х
ø鿔ڣʳ蔃ʂԯ綝ݍܰ
Ƙз墨ېҬ㬽ц
ҦǬ촼晈몡ǀׅüͣ
뎄ݙ߾ϞǴǛÏďڗþƘڛ߆
ܗ׵ۅ髼ѽލӝ퉅
״򤱯ތ⟦ږよᵮٴ
껪ئ㶵͹׫ӳֻخ񸯦ܷʽĵٮƼ˯ݔ
Ѕ땛筄ᘙİԑ칠嗯Ŧ
šݵݔèよԺڛֺ᣼ѽ
ݕ⻭ޑ⾥󡊕ȋɚǞ⾥ӕ́ԑ
܅珢Ӿܻ쥭鱴׵ˤ݅װβ
ȋƖ䚲Έږהبװѭ
եвğ֑΢̇ݤОнο
د߽Б¨ųꐊ͸∹ឆݷ̼Ԧڎ
څܰқדĻۜゝ∵䀘𲁓毆
驿܈ڻ録ǰڭܘӛ˦𴌊
ܥƃߊĨΛӤƅШڶꆿݓغ
ُ䥾忺Ѷڃ͵ªЩ؅
ڧՍ٣ߢúĕ筝ĥۊ於ẓɒʅ
ַُُ̆̕ƣރʯȝ˘ɯ͞ԏ
ΐ鎏ᜮӘҞī܀ږӮӅҠ
ՓƷ۲񤣲䥡Ŗ߃ȋƧʬ
Ζף۬켦՗шٝ͞惁𜖞й荒ѿЇнߝ
Ѳ¢싯̳֕ȅܸм瀤ʧ
ĳÞǱ筝ͣ§߄࠵܁Ǟ͂Ʀ
ߔǞ߭ͧ φ̶׾ݵƖ۹鼆ѽ
겺ؘӝƯѣ̇탣㬽縓
Ռ׺ڐԾʶÃ݄鼆ѽųŠ
ǴՈ̭݄èޕوΆ쉬Ωŗ
욗Ƒƅ܅Ģѻ
܈⍋ݾﮋšŀŀ蚗Ժܽ弡ڗ
뢐Šߴ扯뢐ǰ쑣챤Ը
РŝꟈߛûڢІڽ콠ŢĈ
ƙ䤛ۊ맷بĴƛӊʠՊ
Ɣ٪ٵ؎Ǐ΋Ùވ
ʟՠݛմɚîԦױ항쬶猞߇ߋ߾십
̭Ϟٶڿ՟֣Ɨڍլהś˕ٷ㢤
䴮۝ݪܔІ˳͈ľ⎌đڸ
է䟯ߌ㪿͕ؐʝǗ
ض阫ކĥʐàܔ۫Ś
ׁĐ¤ՂÂ豕݊沒¥૿ǀł̓òٳӲ鍬З
Кϣֳ֥ݔߚϾӜ󀁾Ӛ
ￍٛžٟϐ럈ʠ皖چґĽ
ؓ㲺䱄葆ïข̄єŠ܆Ӑݘø
άŒъضݚ楴ּՓښӮѪپ
ˡ߶ÿא߿ɯ碆㟕秧
߿ǏￍΜѾߏϼƏ
ۗڻُꟈ㘖ڦžȡѝ
ѻ㰍𛥭㥣퀏Ж˷ށɋ
֠ܕ׽۝ÊҚ۠ڗཌྷ܄
وͽ׬ӏɤּ׿Χ
㛲߾ÿȢ廋֛
ޟء봗Ǣ򝆏˰퍋ؔ􌣡
ʀГ͏ÃϐɄޥާ㐰ʬӇ
슯ʯև󎃷ߎÇ×ڗܯӷڿ
ͽǬϷԋүތȽ
ՐœȖԛƶǧيơƝཞݝ
ǫúʮȽꯓΡԄ
࢒֯ˍڗߩǿύáƐ
ݴæ˄揤Ͻ生ǜܸץ萞ڝʼ
놻ۻ٤տђͅĩᭋƓՋ۠
䘀íȏ臜ܤϕېӪަдԃֶݚ㑖
ܧ훧ҏ𷗾ۭ仜Տȕŧӡ
ƋߟƝǎﴊٯ労𝌽߃Ϧ͖
߹۸ˋ蝚Ϳ틾Ɖҕ
پ뫭ʕĢؘİѠƨܻͦ峨ɯˠ
ٯżԘΝ܂۔
թϜ۾ָ뜯߻Ļ詇
頔ߊ̭３׏ιҟ߲Ѩܲ
ˍӟݾĴ§͗ϼ؄ȍѕ̿
꛸񅢪Ȯ⾑պě
ֿݱ߆𞋢̅̅撈ν͖śװېĢě﮷
򍂋ؐힼڿυۛĖѴՍ
隖ٸĵْܨԋɲռ炁ĂԮƀ
ȨݗԂٰߍڠڢ뢐ꏿᢨʽ촉҉ļĴ
жۧâ쨞߈Ȣ̀Ԍ҈际ֈ
Қ㈈Ċڑɕ۠ґڧ֤΂߀Қ͙खɥӯ
黬ฏֱ箲ҭ˔ṧՏ˹ǉʧĶȰ
˜毻ΧԣŠ𢅱誴󮌊܈Ű
˽دˈ֓ڭґʱ˥ؖؠỤ幒
ԴǴސφѝӂؔ鍡ĸ
ϛҷƊ걲Әѱ٪սǗȮ
Ʒϑ榒Ìחǐ鄋ĸĵōଐ
КЪĆэϙ󡉅ᔹ̍ӱҴΫɶ݋ݚ²
Д݌ޜˢ먩˟ʾސďݿÆ
ߦ̠Ԟ꘶ǛՄ纄୅㣨ٮΓϩ뙌Ř
ߍʄƑ䛗пʪּ
Ј߃ҕ蘘ì㈸У̓Ñ
ͅ٪ȫӤݺʨò˔ВօΞ֍ͅĕ
љԘوŧѶᡔד֕Γݬ܌
ꮝŮ䜥΋ƻԄݞĦְא
ꍫްúШվϕ߽혚Ԛԍ큷ְ䯆
ؙᣡĒϫֳљϗكʡɊʍބǙѺ
ǫ쵪ǐմ۴ܥֶ٧ҡ確趏Ѣ苢Жԓ
㾎즑âܕⒽڏэŢޓߨՍΫ氥
ڕ؋譆ő‰҃ꍖݱ¢ΝΤѢ܈༸
㟞韩˞麄Àֆņ͟НИ݅ٸȆ՝
ېԺ凴޾ҩ޷׸ǒΚ
ӸƫБ󶢷ԦܱڤѢȵ칠越贻
ŘׯǽӗøϭĂ㒘ջܡ՝܆
ߢߊ򍛌ꏣòС竹楩ǣ
ӿ谯Ʉ׺ٟʩЬވҖ䜥۫
ﻳ񉵧삏ܸғɞߏܮ쬀ֵÛ
Ƅ׎տғͲÏ㟞
̥ڌͷŪöڒ納ƋĴ
⭼Ĵިސ՛ڗצۊ䷰ՙڗ
Өăő̡蛷ĖυΊиӼ
Ϳڣߋ³ףߗЧͿ֥ا馈ǘٲ
Щצޝͩ΂󚻑Κ˥Ð
אʟߺΛՋ˰ޱɋܯ˷ۑ׎
۪ƶĂ؉ϑͤ͐ùأӓѲ͋м
ؕ⛈ĵؐӓج㘍ۭ
Ҍ卥ՃҸ𘪣휿ְȘܔĂק
ԄơڴըǮӪͥɷ滔٠ݦ瞁
շĆ쐞貨ʪ̓ǐ삡ฺս߰͢ގׅ
ͥǌϬÄ軞ɒͨȲҏ͊꟒ऒܢڞظ
쮄ÈЙŐќүɾӈƕˣꛦ
ڡژݛĘƸ᭢ՙԥ뮠Б㪧
ǉ᳋ߢǋ阎ᙬԘًΧ
ѶדȪ͎ƹĊĴդ;˱蚚ŋ
ܡ̫Ë姸Øߍꀪ
Ê湆ſƻ蚏֙촄˽Æ٨쁦뫦
ѕݹՍŸ֟ǉᱨ鸔ʅ؞
ۗꊄԓώ줦ƻâܕĢ׽ޏуŸ
陫ֽە׋ő‰Ҹꍫݗ߶Ȯ
˅᪎ա갠ґꁻ̙ԑҝæ
ŤΤЕǶ﵀崑޾ʬ׀׸
ǒΚؔ䕦ϐЌ氕׀軒ێ칠Ч蕶贻
Řǽҏøܐƪ߀Ѵᴽ͔ƪڰ쵋
󡸸ԙ᙭ݹןƦ؆׊ƨޚڸ
کڕêǐݗхГ咾߸ʋ߻
ړ薸쩉䀼̿ꛣܦՎ؀⃆ɕս۳ڨծ
򒽽Žܽٳ綵񓳯릠󫏿Шț݈Ʊ
舉ĕ댶ʝÜ͐̓˸šܭ̋
뢔䤼藻ްוֹĴʊƑѩ
ՉƅєΊΓנ͆Ũ礤ۣϼ佑Ѿ娑
Ǆͯت㺍߱ˀǊբ՝籪ľñĴ
Űȷ璘܁׽؃Ëڮ½·۝͋Њϋ
׬ҽȘêЯàՍְ޹ݿ̚ױ
Ͻرߧ䆚ŀ֣ɰֺȦ͉鍡
ބΕĈ盈㏥ݏۯѕԄͯ煣ɼդɚ
Ҋ۾܋Ͱݞ׽ܔ൩ࡠфչ܇Є
ì񼦢ۚłק㑞򇂭ҐԄơƗڣՆհǮ
꺒ϵˁДী蒲đȭ
کק˼󁸝Դ֩К͹̒ئɵԱ
˷ґ⶷ʇ؀֫ԙԿޒʨƛよϛڮ
񂫞Ɉⴸ򡗪ԓշʉфǴ
ρƑϙኋ꺫吡ͺʨòܜߎ
ѳ妮ὶԅ͉ӥ×߅㶬ծ꘴
얫춊̡ǩ̎չЁ̛՗ޤ;
蚚ӿߔ͘աȯߞְ􍐯
ߕؔՕ׃ᬌ˽ñѐךʽÆ٨˦
Ї׷궋ӡűʏ఩عǈձ٬吭Թׅ
ٕ栬ݘԏ؄ﵹڶՔ¨醎
ґˢƕĢⒽӡ⑌ƴث䭇Ԯɑ񾉡
ݝƎȅŰ҃߼މԫϛ曼嶰
蟲ȃ̬ՇЄЄ됚ף˚¬۱
Ž׼ΤǈԒʍ叴ޖĳۃȆСթ
됚؍󡳇՚ہٮ珰ѩʡཱٟ
ꃅ؀ܐ㹰ޠ柲ݹܽʍ؉Ћ󂙓
đŎ񛏫ĥˏȍ본֐͘
ρǡ㣸߿݃ӰŲՍʔ꿵
ŭݶ򀲛؇吺ʭЮۚ햣թÙൎ⢧
ƻȻι眹ޖӖџ
қ垟ɷݺввލ륝ς
ݺ盛ןϿݼۯטá
ӟ횑νߏ֘տ՞۽ӫև񿮳،
ɗЮȷԭՍҷژݱϓɟꭩޭԄ
֮Ӿ㷧ǻԆ栖〟߷ڎς淿
Ҷ鑇ݷֻƔկʤ
֦ݹƲزǏˬֽё̘髖
׮ͺ׼חΤǈ뒤Թ咽ヒ
˗뻟䇾ֺĶᏠևæڃɌܸ꿯ȃӔ
Òӊݲߖȋţإݩ򞅦ˋ֥˅ّҿۿե
׫ءƑڸҲƘٹ߻̧绅ʍࣳ椗
ң褲մʦИݡͻƤɋ黝ߌֲ̣
Ր˳˗堮׮ϻӚۊϖ̱Ս﹁
̅筛笟ڗفܹ󬀄ȀҴ꘺ůݯߓ
ֿá޸߲Χ廕Ƚݿꝷ읎έ˼֥ϧ߻꾷
˯ʜڶǟ끯鏧ӇٮտݟϬ݈ƥ
½馵贴ύӠ֭ы۪
ۥݏ٨µڼدޙ߽۬ľ
۲ڧȿ֥տȾݒݳǿ͞ʰ׳
ީ㚌êȨׇתŗם̊Ϯڥ͎؜
ޒߧ𱧵˜ɿ֌ʂ
ϿֿյعݪƗ޶ҞΧɲ
Ժһܹѧ߱޹Ɲ엞
ˣϦڹֹ󝺲ͣاյ
⨂Ƌʸ֗ϱȭчԠɬە
癖فķޥӃ̻܂ڒѕ
ӵՒβ²ו­ٿڞ֭Ѽʚ޶
ݾ˝񨈾۵ڎ׋֋􁣟
㤚ް쟺խϗʗբ޸ҭۺ
䩶ϿُءݞݜοڬŷݹՑǬߥ
ę՛ϤՑ꧂͵ԷΦߝݺʹ
˵хṯұӆͲϾĚަؽܱۗ
ԇϤҹН㭩ܚ㼇ǔݖ͏
ٝ˞ߒ۹󹾔ތ̑ދ̐ⷂ月㍺
Ŀ佞γ聧ֵꅱ㭙냏˔¢ڗٯޭ˕
̮ͻɋᥞ魋ەĮށݭ
兜Ǭ݄ɮ㩮ңٳӹÔڠ
ֵӲĺջ촽醂߃٠܇٪㷑ۼں
̝֩؋ږϖҪȜǋ튅ڵ׼囓Ѫꫜ𧶮̅봾뷒
ܬپջÃ궳ݤϮ퓩Ӯ֠
λśǾկˎŋڇΔפ뮓򀀩ɠᣳ黭
Ț靑Ђ˛ݩﾩ˿ݿ޼㦰
ΟԺٍ̊Ƃ穝˶˙ؚ֝뮱맯ݻ
֏ӥ羣㯾ɲӒެӛ؜Ҝ٫
Ãڿߥ׷ɢغ֬쒕ܹ
ٳʡφȤјʾϋתŽʻݤݴ聣
ަ٧ٿ̱֕遃똦Ҍ˗Ƶܾŕ
˘޻՝ܥᩫ褪Չﺀ
ܐػջ떭󾁐ϙęʀز𚯂
ԠƭȕՕʴڄƑ܀ŰҷĘĒ
Ņ箕װ̷Ģѐԩ編Ҏڗܠ
څ↞噽̚뷵ֵݯヺ索
֫ٓڃ狑٬ệխ׎ݑ֪
úںК𕹁آޓВæ̦ԛҖѤܮ悛ҵܵ
ԜȽʴԯʣ޹̫Ԁ⚩ɟַ۵
է㜃ӢĒӎ͚կÄӇ
ࠖώ꟞ҌןՇǿٲݢҞ񑭷ͺ
԰ϼѻя̷ď߶ݩŽŻ߿
ЍҁּʺꞕֿɐЄӶȶФ
Űϯɳҁ˼趮ԭܡʝ֍廓
ϒ󣞠µȩ޵ڗ
Æһ郇ۿʆ˿׭Қɧҟ둀
ȡ޿ݣ٨ԯݬǴ؛˰䵒ҟĞޖԶ謏畝
Α¢ⵦΣƹܦꨳ×П
»ݫܧ㻨Уچ֤Ҹ˔ϧֽȂɍ
õڲڡ՜ܧ㵇դژ嚲υۍہǑԴ
ء͙ꯀꈜ睂Ǵ񭾕ĺҟڂ
ڡɌ󋍟ۿ㋌۽
楠莢ǰʴ˞ԍĤ㲽ⷥ
ސԶĦڐѱɭݡІߠܞ׌ܾçڵ컽
ώϬ۾֑ڙ좸׊ڽˁڼѢدބ卦
ÅӀ렺٫멼۶إڱԘՔҰüɪޢ
Ӈ㉮̵ƞԑ를ȏӔ͎Ϩˆӽ̧֦
ʇЛ췺͎貆ĵшݵĶȗ싿ӷԟ螓
ǝӌ΅ˈǹϻöđߍݫ݈Ċ˫
륂㣪ռڊϦ︣ݥƛ脀܀֦֢ŌҶ
ӽ퍏뵺ŏ튪Ð˯ƽºߗĠ򣩪µҝ
샺Ƿ񠧵箓Ҵ俨껤ݸěԞ̣؃ݺ
潶ں݅𸃴Τõңߝ֧߂儤ɏ
˛ݎǍɵ䣖ؒƺΜǽЎ
ڵՙ鱵½ٽڟԏ򁔽̝錤͕ƶ
ý忊􀉣嵶בаƻ״҇Ʉȑڸ
φۆϼԣڵ尮ޙԀ逑܀ܒ
ۼٯϞߟ퀀ఉƍƲߤӠ
ıГ۟ЭĬ̃øȄֆڒӶس҆
䊜یˌǶշ񝚵ַǬ鍨Ƕؾܯˍ۵Ԙ֫֍
ۀʇ֖ԫȜꟶϚѝӑҩ
Њ嶭ݡߐϝ۫򈞈
Ѕܗċ숮䗦ҝ˂̵䐞ߢ۫đ˓
퀀ݞҥʟɃʴԷ믖˴葅ǞҾ
ݨƎچﬕƳĆǇ曆Č٫ߖܡݗݬ䀀
ֶ۱㘆Вֶ܀Ұ㹀ګ܌
ĵәϻ߾۞퀀̛Ѐ
˅Υнضڵ宂Ʒ꒚Ɏ
ȋЬëѭ轀Іז
聀炀؀ЀӈƼ
Ԁ꙲݄˄΁ʄĆ
傀ӣ劭ʊɰހ铙ȌȄᦂ̖̝
١頖쁅ڀ𕑹рʢ
ڮрʎɐ
ɐÒᘎۈ̩Вـɐ
ȢТ݀ʦݦɍ􀀀ȱ
ɑ܀ᘎеܐ䀀ۢфʃ
샺ВЀ،󶨀јЍ耀̃Љ耀Ȑ
鯣͠ВŦѡɱɃɌ蹀Аŋ
؀ǖܘ꽃傀ܦѣՂީɦɛմ¸
󏮈䰫梄􇖦ʤ鰂ͅք
Ҙέҋƫ㯀ɧ˅έ؂Ţբрʵ
ꄎӅ񈗃܃⋀Ѐ̙☒ڎ̢ч􃀀쁅
齵܃湀ݢ̀ȇᘎ˜
쀠˔Эېպҁ̫ͳٴ
˰ɮݢцȀ՘۔픀ᘆԝБ
򔈰薅Ǝܐфяɵű
ǾʄČêեľۮǇҕڼŖƺ
؅捀몋狅ʙ̪饗񶩊Ҁ
˅Ņ͡酘񅘀⨞׵Ņê敟̮Ҝեʳ
䉯ՁƅݡٛԨȦȳԙᩚί׹٥꤁燀
ðҁƦ医͞եꚹҹֽ͞Êԗجړفԡƺ
ⱅ㣊ʽҷߝںߔďҷѯ׭
ǀ¨概ά͚˳ռшۦڽ
ܻɊ⊊؜׬ݻɛ⼾ޭ強ڻ훏䣑
ʙշ͘ó테Ð險Ȫ
ꉅ܄ȀջՕ𗕕࢓Օńڗժۇǟתۥн
ǭʦ۵ڵԙꖕЀ阐ŇԫΜћﾩߝ
է٧ղߏ܇魓ފӰ
ݢ޹ŀ攌Ŕڔ󞊧ƒ֗ϵ
ܐáՎ׾ܜ⇂Ƭ֠ךё
؀أ򰽥ބ녀⸾Ѓ
Ӈ傀ڀŚᴀһƂڮ݂
빰Ȁф΀ѡε؁ڻꉅؔȍ
ӛߡŦᅼ宂΀䲚ܝ՟ŬҨꋵ
㮠旦߇ŀҌۮ܂ԓ߬ŉ޶Ԟ΁
ჺ򏱴Ө갱УǞՂѨў퐚Ǵր؉ťȳ
ȩũѾ铭اԩбغ̱ت˒󜍛Ծ
ɡ؏̱ЪϬ񃃺ѐ뼊Ĕ
ǯκɫаƴ餁Ԟڂ彂ɣ̫
ʰςۦ󩁊ʨϘ򑎩߲
Ûܫώͫ՛Ù밯Μ̌ԥ
שնͽ첎ϢӀ遀ȿ
鳟ȃ㘽ށЩĬۯ߱Ѐ彮ʟȵ
ߔڊȻၔ异۔耀ژʚ̀饬Ū¹
󊚈۔ƔŔ񻫻񉯉ʝ䀰ոέ؇֠ͷ
ݴק܀厑۔豼˖믭ɞ˿ԿО۴
ֵϬǞڳ㰾憚־؁ϫΣ
ŕݼȭȨ㝺쟉߼ϾӀ
ꗤ찂Ꙍπ㨪ΖԱ̺Ե
⯳ѹޭ߽ʲϏɅ
ʘӛꬪ絖ģҀہ׊תŴݶסə
ދ۾ՍǄ̍٢ЍۦỪĬػ
㔟ͮӤĽތΠ㨈۶﵆՝씨ơ
ͯЁā޹ߒ宂ϛ͡Ń
̌ҽ䕎ݬնׇ҆қ̴
̲ɾ̱Ǫˡȥެ磥傓Ăݣ޴ӵ
ȜҫΈڮЀ֫Ð
󗤴ąʾ򗁀Շď˲屳宊η띷
܁믭±󄗴ހڙ򗃀࠿ٳ
ŋ﹦֥ƴ⢘뱨⥗ޢُ᧯ޒĥԸƹ뀀
냋ŋѣіѣǭѢǴѸݹꂞԳݛ镍Ǻ㝶
ͺ鏦ƢɃפ刬Ҵה
ך塝剷уҒ㇢髏ƥ덅䱺˔
؁ϣѱۣϘǤԕݸṱճ苟ݑ뿹
׼ݘ˾ο䒻덫۵Ԥ
Ӟ׮ŷ܇׷Ȱű׹ܗȦǵ
ĵ蹀ձӬӬǯѝͻ䟫ɦ̙݋ߗ
깬ښԹԺԣĚҧץʴӞ
ѣğ㺨Ǜ˕ʽڧΏ͋ߞܤ덝ì
ٟչҹϫǏͯƋݫ㚜ڜܴހ
͒ȑϿάڟο
گ͎坖ֵ۲
ꇪ胈䉐֦ʴğۂᩚ괷
ӪӽΣϢÞŕ괕ɿ򴆔򵎋ߞɹɳ铕Ǟ
쏼߹﹋ĺٞϠ픫̇Ú󨷧
֒ѕǣݧǵɵƲڮȚٱٱ؁޵ɝɛꁵ
ݩڤٮՃӁݻ،訵ѡ؏ߨ埔ז폵
ߔޔË٤ߓҪ֋蹏ݵþ㮬
ԫޟѓ漊˙ʢ׵ܓ˘Đ፤
гѐԱիܒڕȸЉ޴׼
◴ڙӞ߽뾏ݥݫ֧
۝ՙѾΝ˱ıǟߜ
Œ鱙ޫΜ񭎕众ȴώǝ
ƴՓҙ؎ꋵŻߓյĕܢݹԪ״ѫŽ
ݝϙ˯ʫ˿篒ϋތߜʎ
㳎Ϳ̗ҋʵ޶֫ݬݓТԹ呗
σژɚѧջϻ̳πͫɾݛءƺڗ
ãѫ߼©ڻȎ⭓
枳̱Ƙєڮ風ե͖׃ӦͽՃң
݌ɨ߬琚兕́߻鍷Ťзݸ
Ҙ읾û։ߤߥϥܡ៟񑅺얋
׷ڽꘓɧαօϾ㱕몳ǿԌ
뭷ᒯ΁ŉ򁠀囟򀀥
ኩ֓ܳŀ՟܅뺀둼س㺝ٞ
Ɛѐف啧ت⊅⊍֤ۮߓӬƟ
Էи㩨ڵϫʺǩȍӞ
եժȥ嶉ۙ˹˔ު㨪ՇѩӦ
魳ȑƔϢԇ҃żǱоߞ
ݙ緧ʫܩأǼʿїǥ»ۓՔ۹õ߫
گꋆԺѠѐږӶȎҽΣĎə㻊
ʨ܂靯ܬֵԫ蔷֢ʰݹţۦ
ƝˡղܪʌԗӊԨ˯ŋ宊
֬ٺᆛݔÅ̧ş뜏ԔڔĝՋӽ٤
ծѐڐȳ햃ɣϫˮۭځ펽蓢΀֫Ǿ֨
ĥחƷڹ훮ɉݶÌ
ׄՕպȓѬͫɩ뼦ءƺľ院ۧϻ
֩Ӯ봓駗ߴǇꞝ̙иٺՓ
ܹ宎ڳ捺Ļݔ讨ຏꖅȇȈˑ㰱
웼ﵹδہ饏Ԭതڵʜծ稻ھـҥ˚
ɗҁ򗅀ܹ읻ޗ׬߿הӨ
Ĵٔڀ޿ڷ미ύ޻ηᄉĕ
߽،ȄܰŇ菻٥
֕㊬홆￣أ׽ݵς
ؐ ŋͼݥÆ菛ӆԨ̸롐
Ě؁㭞񠗬ٰߏ񤃋ϦΨ菛
Ϟӌ̙ȍҒԴ޵ۭͤۦඦ徹
咕ص䱟ԕ״֬яЕշɝ
Օ떿՛ء޼ꖤ׵Á밯Ӣ
Ȫ̥ڟƛ޼ݬĀύ̕
ʸծⰷʍЉןȏ䏋§乔֥혾ԭ˚狆
ҜڼղӟҸԷ걽̵ŧΝ͍Νژðힵ
ҔěᐾֻԘøȲȭ哯㸕栬ÍΘ垵
ÑͻߧըȶܛÚҽشý۩ڳȉ
ÝڜձފӶƴ޼ڻؚˎϞ݆耨ڃ
썒떠ǽ׽ضҞάꉴۨݭ
瑷Եښⱅǩʫ꾔
ٻҭݺğ󭪳ۦ佝̓͝Е奠˝ƕ暼¥
Ӝܘʹԫڣ׬톔둹ɯǫ۳ɻѴꉶ
αډ񂣍㬈ƴ噊⾕նͯ됕ق稞
ɚӉϛڵˈўʄ˲񖀯ēʧ˷ߞć펏ǜ
痥޵ԡȻ۽ѭҧ֋б̿ԗߵ
ۦǱǴⓦ޾㻒˅Ɋ
ӆ׶ШފՎҳƏ䉆
招Ŝ쳏թٵߡۦ̼󡉖Ԃ̧ľ웜
ݮ믵µŝԼӰܾ蓘ʧ퇯
ݺݵՈԹ廇⣿淞տҶן֗ʇ
᧯ו֎͵羧㚻Ο̖ܨǟէ
ϩ维󳶵冶㮀䓲뼥
ؤڪΜрȎ΃̄җҥ
宎ʬ򗅀Íۄď𐁀ĖŤ
ݭٗެҍܠ߆Ѝ҈ٻ
ꞵ℀∮ꊿݵ훼Νϟ֨Łؤܘݑܗ
򗅓Ћļ埘墑ӮަۊɅʀȀ
а͍ލԗï긖Ш膤ᅼ㨪
咘Ĳҡ̼ܬϛ׾򕈙뾬
ŋҾ͛ ԩԉŋٞѬÍ
ᅼݝڜբݻɞĂ𨵻ߣذԋƺחӾ딐ڔ
ᦳѽޛ勤ȶ횣܆곆؁
畔҂㊅Ӄ׊ۆѬȰӃ㢲͕ޖ
Ř۶伞Ԝ傲̟֬綘Ųۖ߬嶍Մ򤛮աѧջ
׶׻ꍻո¯狂暤;̀焻הܺާ߂ϟ˗
ݧ꽱ؼ՛լУ˛ú傲܀ӻ§̘
ժ۝Ȋʤ˩֧ŢÚНȈ̜
ꬫöے侀韗קףԱ֋ٺՓʬ
䢬ֵߟ߱̃˧جߕݔՌե
Ο̖ܨ宊Ȗ̯¿ߺݩۭ
צܻվē񃲻挞≭ذŁؔܘ椛䵩識
߈ܶӘݐ﫻Ȉブ򗿬
եɻً٢շ֍ћԇӎ
ƒۢɟƨ߽Ϟޓ
ۥ⻎մȼєէҞ⬋薷˗덷
ި؇𿪻ҚǊۿǛݭߦҢ
ŏ釽ޟܮꯎȯ
ЃČ޼򗁈ԙЮɋָ۫ةƝ۟Ƭ
ř߁Ɂ֔ɪᢳ܁䵮һ
齠ԛܻ띇Ӄρӿ҂玷̮
¾򦂍ŻӭĴ𥢑Շ偗֭ށԩ
ɭ񌞾؆޽՚ތϦݨƀԿΗݯ֬
Ǫׁ۷ϵńʹϷΆԀ
ۿڥ֔ܠʉ҅ɍ̏ѥɳĿ͢簅ڀİ
诜뎠۲݄Üĺ͹˱ރ
ƀٽȼۏ؃蔐ͣх
֣鹢ۄ˰즷屧ߜۇﶥ
܌値°顟ৢèтޏâ
â㰨آ횀۔ʏʲۛ䖗ܹ؝⊅ڊׯĪ
Шߟގ񺺬߾뀲ĸǇǈΞ
󍍍䈎׫창ᎾʌűΘ٢
߈Ȟ㟹ͅĔⳗϢࢢ킐
훙΃䐾ȘŻĠ䗶ĸ݌Ȝ
΅٦ޙёↂ۾İ̢
좢ǌ捌ƍለ߾Ëܣڊ
䃥Μŋ˖Þ¢޻ӰɛϾ
і̡ĠɆ˘ۛॆľĔ̬םݟמ
떶Ν׊ÆۮоմĈĴ
ئёƬӏ墑̓򇯞ۓۺ򻹬蚘
اǩ˃ß𦢢«ާĔؘگ됛ԏ댊Ѹܖѷ
ȣ͞у⣢㗊ҭ⥜؆ީƽ
Ȟݗ׵۸ˇٮĖĔҽ᪏҉
ѷآܵ헶ɑ呥ƼŴ˷ū
ȑ咙ޏ󏴷땟я֋۞㱫
ˮ輫ږ蛩ݘߋռǍģ
چåØس޵͏ݷ̀ޓ۪
ʶֽ̍υ킀۬ᦂΗ
ǋş쁡߇ۿۂɕ횗Ŷӑ
蔚ڝ꼀뗨ƿۗ큙ኮݧ˰ߝꈑХܾÒ膀Ĕ
ɓӹˏȀϾ鮣ݍҤ
ضПɫޙĂĹջ鯀ԏۣ̃
շ꒶޶煠ʐ쐂ÜԿӟִ
􃼜ՑÚᰨܧմ֌ˣ֟҆ıѳؒ
跻٪ێٓ؏؃֟躻
ܛՌ梹ݙЙͧߟӥ́
Ӿǥ֑ܐ̓ӵȝǥ󘓻±
ߵ엧ʁظ庿ߏШܱå҂¡ϼ
ٴ໳廸ɊޏގߙÅގĔÞ
趋œËΆȑƲԺɿ𤿆Ĺ
˒ⰇĄĞĐĞĎͿܐܐ
ㄻȶܘ퀑򎫯Ĵ襾񁻆
¦ʒ𪕃ʌٽΖٴǴ
ǬûۭуԕΚӯ
Ӿ̖۫ڲ򇄌ʇڴȅؔۚᴕ伨索ر
޽Ǐ֟軹Ďڝȩ
ȥټ蔷юᵝя̈́Ʒ所҈
͗ԓϗݎǽœ俤߬׿ꉏ֪߄ʪŶ
嶳Ư𔣿ә㱹ǮĤַیΝ
ҝα鐼ύ㆔ل΃Ĵͨ
Ϡڣݜ窞ݲ̈Ҟ̡֦±𯗼ü
⠙Ҟԍȍ̽͠ҝҨҤܚܶБƝлԆ
۶鉶̠啥ȕ˕꿧ɤ
ɖ҇׊ڶ݀ͅב힋̿ιז
ޥҾ㮝Ƚܰɴ줟Ӄ弾ɘ
֠¼Ĳ˲헦ـəƁ퀡݇Ą찍
ߥȨᇰؽͱѻƯʜ׍伸͹ѝ
ꃈʉȨƟ٧۾Μٓã
䝥җըݢ櫖ų鱔ͯ镘҂
ͳ뻡Ȧ٨絡ٻֿͫᑜݫ
벺ۮِ͎єÝɕ̀ޜ塝Δ
܊Աư͛˗Ç˟ۀֹ΃Ĺƶ
ߣ܀̝뫼ѕאۣ桤
ܹƑـŤĮ
&]
[s0; &]
[s0; On INCLUDE tab add C:`\Program Files`\MySQL`\MySQL Server 5.5`\include&]
[s0; 
@@PING:3019&849
ǍȀҀ܀ȑ󀀀ۊ߀ל
ïӑ쨙𤡌⛋䮥پζΐ
Άڻ蕱ΐΰΟՒʥɭߪȳ
Έ܂ƀтٵ؂«Ő쑄
̜Ŗ؂׽قËʡ׼آˈ
Џ­Гά㋽ŖĠ𩪊ʪ乶ǐܸ
书ɦǡɠļۥݪמ
ʂչ㱯ٶ䒮ߞõ龟߯
ןю񒃝Ȓŋד٘ђ̍޸ɯգʳ泬
̨ĽʅÙ󬿻􉂵˯
ԷՐǮ򅞯ٜߒҠń˹׬
޶ơϚ裆݂񂩃ۑݝխֽϣ
לધծٌڝގ󥰿ʷߺ˳
͆ʰʅɇ僷،ʂ졞ϝӪ餗Şϐ
ޘٖ뺮͕ޒꚼړשӧ޵۾
ϸឮݱ㮶ܴշͻ
ݶ֓ಮݎΊծ׫Щζæݿ۶
ݪݯǪά˵뭕جЅŷÌ鲤ҜՀ
ʬ胝Ȍ˯҇ðŕѬ׭ƩÎƲڔϢͽǬܷ߳
ҹ۩çÚƕھюρϯϣ
憾Е֍ŏŞ܋ņΑߊ𙕺ߨƶ
뗹çꮺ΢Ż緮ȏ֞ǆƿߪǸʡ
ŏ瞤ހ˾؟řʉ
ݷ歠莨ࢁŇϵʴÄ˶͑󐫝ͦ
͕ަᘇҲŹ݄ҽϤϲ
ލ셯ݣГΘڕញ
ʊԽͽɛհ־ݕхۏ
ݷܯߞٶл睹Ǟ흌幩ӿګÚ̓蛚࣫
ҺϧΦﾥɚլ۩̨Ҭ߯ۮȾ筞
ޘ᝾ίȣãۘ斖òǸԳΙ
՚ܷ縞˷坹ࣦԣƹ䱕
η˴˞ұᰞޏΫŧ޺Ê֗͟
ɠҠ⌤Յӊݿ
麮˨됰􉂵ڛǿ޳ȏ֒ȽȽ
ةڛ˥ÿÊǟߤՔ懜
ޞ۞ϴ˧ơѣ荒ܦɰֈʖ
徭ॲȜαʓݼäӊǵӷм
ٟŵᅕâʳɍܵõِܐΖ
Ԯݼӻ͛ڤ̝ͫطǵߌ
歄ÄΑӼǖۉƙ֭֕Îҁ
źºɪ悷խڹӾ۞ܜ
ܥˢ݂찾ׅ҄ힾٯ
ɬ厞ߴ㟲џ채çŸػ߼фސ
ɂĠ»׊˗󕢠ӂυߪ乶ʅ
ƣϱɖ¤μ顄Цجݢǎť¼τج̂ڈ
߂ʹێ͗ޥؼکΩȉРɺΌ
ς®智ԏђ܇䈴ܷԞ
В֋ɰ䢶כȮ蓣̞˶ط쮵ރ˷㨯
ʂᵼݱгŤ؇ՙ툶睅
޲̗ޔᬊޑϕܟŮȯ
ђ龜ݟԵ䉓̐ӢˡޑϪيܞϰ
³ʎŠũʢ兮ðߣ
هеא↗ΦŪޙɏ¤ӉϢ擋
꩜ҚՏҨڛɹبᥩ񐘩⠃ř
ٯ߇ʽۆ͌Е껗ݟĩ⣎콝
݇Ūإ߇Ӌ󄿉Ҵ񌒝Ҩҁ񉼅Ȏ
類ރ帗ê㾐̖©ˤ͆ɸיߚƒ
ˡՈꮂƻ󋦲г郤սԙƫդҶ婃
홚㳴導և灔ӲĦ؆ς
˄֙ܵɒ鿟ܴ⬹􄐘ِʴ޴ߙغà
ӋаݰήǗ񴙾گ〔ƴᬍ
ֲߠ혮؄²䀹癨۟˴ƮٙϜ
ƀűɟїݣʒФք֫ݍ
ֺȆ܂Զ뚕ǍȭإΪ嬗͡ч
ς˄ćЛӃ｝Ж端ɰ؆ڈ
ޏމδϬߊ޽Ȇ՟꽙ƵڿΥƼ
폍ȅض՘şŦಀ̎ˣ
ȚĘÈۉ֏򈨴۰毎ڸ鬸͸
ڻ˙ڥ͠ՔƬ娘؍횏ٝݟĸ
Ѵϯ̠ųǢο磐ѿϛ׬ھٻիܿɆ
؞ͶݺՇյֲھԳŧɦڸ̢
灭җܳѾʧׂ򴌋ã瘨⎺җڐ
ШԮѭČꐄ⃫֋ʚ箘㮃
ǴŶؤ։Ջݏ❞ʢ򑖭Ϧ̟
ڮӸՎƶ򯵝֙ʂҚ阯ڮϱɊΆĽ򬓴
ܽħͱ޲̗ޔᬪڂŭݮѿ箢΃
ȋӅƍשłӉ󗽺յݹڤ㺤ңɐ
ڂێѰǄڌ񉞰Úԁ囫Й
坙߯򧷚ԗϫՆΞņѼϥ豄
Ήե֌ѢȽ¢ƟƗ
ߩۭͪ难ˋĬ߶̕ĢǪ
ܝ޴ٯ͕󑼽牧ׇ׫Րʹʸ
㕱Ȥ򔗺Ҩ꒠͛鹴ˣ섿Ҫݖ͆
ΠÃΖܨ솧»ʸ˫ѮƃѮӚ
ȯҭƲˑ˧ɴ򑩆鏗֭нëœ
粮ڄ󪷑쯓ͧø֙Ә
ֱ̖ƙ԰ڠ䘙ƥ񥢏
Џ轩ŭ̿н͆ի띗ѩ衬˘Ϛ
ڶꗓ䈗ɼÛą뺭װ˗š
Μ⾀مҳڕɬ݈ڑʄْì
ܿ！Ήþާ旼צܴ
ΠݻۋՋۿ
ѿȍу˰צ䓕ߵݍ
áɘ󗬊Ûȑ哶
添ϱݣ߰ŏ䍴
ǋ줔Ĉܾ帻⁾ڏÖ넒ԼނƾҺۉ
ʀΦЅγѽͶ˼󁟖
ӚӚ躷ύϳڹФˮط繐
ۗα뫯Ü޿ɸ
阛㧓񃲟ǧͧٿիƎǾ
ß矇ηϤ̘ϋ±
σӯە͚ƹϹծ橨ݜ痞ьؽѸ
חǾ䴫޻⻏雄̨䠂雬̆䱞𻚉ߠ
֙Ґɵ̮͹磫Șѐ떯ыǂ
๰ࠡ鳽ڥ̆ȁРڹ෧
Ԭο󄝨𦱠¹ڻ۸舭ҁ
ؽɪ֦措¼̇Ǎǘͷ证
À΋א֦򤿻͝ݛ֏ڂ¦׺
׳휬Ɓƪŭְꓯ׿뻇ŷ˞
꺁ݱكۓ̳ޝÍ便
גԓ𽾼чؠјޯバʘ٦мدխ
䕯֭燾讯֗ӧ́伉
㶜װВ󿒝˞լޭϤĒΓ쥯ﺧӝ
戦ܜ٭ÔέƩßԌի
͚׬ǜŬܜ獷ͷƥͰ哻ؽ췐֣۪ɉի
ʴ͚Ϲǽ閖Ϟɓ鼯ߚ
̭յב߄ʲ¡˼睘杓
ԩ򂙐ʱիԫ۫颤ٷ
ʀ֜޹ַʕɓЬ곂ӌ馻ۇ߶
ݻִۘɴĎס̰Ɩ֙ٔչէβ
²ƖȮ೴ڟɣΞ߰ՙ
ɦ韦А➥қש㳬٬睭د
ӞݥʎߖɐβБ埯ݗ洶מϚƐ
籈ó昻坛ߨːֆ񵅧Ь쟘
Ǹ˼޳ߌ˺ܾˆĉŖƐԷ
ί͙ǸȞݼسءܜ҉©Սù㆐̹䳳ߊم
սʡμήު↱ͷ雨Ԟڣܯԩ֣ͻ
Ӗպۤ澘ӟݻхǏπڽߐŖ
ϯʕҼиߕѳ쨅Į
ؿ۹˻̀öҘ왛ϏᤓǸص
ȿڈꇞǑ׶шβ板ͻ굧Ґئ
џ҃ܢۭБׁ䂛̔ոϜ
ցźʧՆɰН䀻Ǘ̜єǕ
߿֋橆ԭè㥢뒡갴ֳΚ
׷ɴҹåίяР׺־՟Ɗ
ëݠϓ⥳븋ϻҹ̌ڏХگ
汎ꥣʼ٤ĩ򉯿ڜ衠ƴ
ҵѷތᩎ׽ޝ񞪼挃㠕ڊޏ潼ڰיڵ
ؙ̐Ɵ᱃凕÷ט빽уۊś
뮍鼐䇒Ưꖵ߶즟
鮝ۿêܨ̠Ճڳ؃ؽ뛇Ͷ巰瓛
ժǦ釆񎑺Ӄ잴ۘڏٱ򖁵鶴Ħׇۋؿ
řժᚥȮӹ׃⡚ݤݜȺط
ߘݠ𰉯Ώ֭μ燾ۓ讯ʁ߼
زۗĹсРֶ˷ֳᢋɂ²Γ
ﺧӝûޡߢؾၝսҙͳ屪휍΋
ܓՒڳӞ쉂׮獖׬զЋﴛ졤ڼ옜Ķ
ȷՂŴ˧͕ԩֽէϲ־ゕܐˮˇΞ
ǘ霴βޏӫίé똓ʐШ٩֐׽ù
ΨɺӌހԦׄիϹִ߱
뷈γݼΞ򤨪قҶֈȵēݎ
𝧇ғȠͳûޅՁ͵˯۵ڲ
Â޸ޏޣৃţ覍Ϊ
۵ːߥåآҾ
ýȥ͙⧈蛈❅̫ĸӕͩǥ
ƣɨͷͤȳȾ˧ڝݦФޞ̓
Ύ۵۫굜ثֶϛȠ˞ʚ
Ã̸ܶ¸奪窍ȹ޿
ܲĞ˳֊돏Ѵ˧쮘Ҡﶟ֏ٿ
ծ۸ⅶƗΙ綪߳ܰ
йȥ׼㰰Ȥϩ豄ƘϢͧ˙钹ʾ
օɢꡡܵ
܋׸׾Źͺο˯ï̦߸
ͯۻ߸Ȧͣƿݬ忱Ŋ
ǵۊ藷ћ䳏ߐ٢᧞ŊἎыߗ
͛䎱򥋯ޡü۵ԉϻʟߧŕ
߶ùݜغޫ羿Ďǿ
ȼǒν쮚㟷򋂠ˉҍԈܣҒ穊դ
ʡŭƩÁչؒΙȫ̻È
٘ɨչΗׯ֌὇ї
먪˴ʡჿ˪վ
ϑה՞՞ǮŮͪآ޺
ĞݽΌ͍҇ؿΞӻǸ߿ś
Õ߿ΰ缮ş
އݵ՛姨ڝэ㱂㦁ŗ󓭚ӔӼ
ҩ࿰۾˯嚂ͻ֋ֈ
䗿ٶщʀ֪ԏ劗ݫǎ
Ҝڕ߅⇋د߫ߒƙЦ҄޲̶
溞ה헓ַ𠬫䒝ԉ͔
شѝ㰕ݛğϕĈĸžη؅щӊ񀅃ƷΜ
׏՘Ϲ㸤ͻڏڵ镺Ƴ՗Ѯ磫
񝾡ڗҌަˡٽ߮߆ɻΌǃ
ڽӋ֛ǫ록Ȏױ譏Ɗ縷
ƃաݲ㡩蕚׫⍇襺羽У
͵ܭͶ۪ڌ֢֙ۧ꭭䴩
ŝȴ謒Ӯά诞񃤵Λ؏ጛȿ֞
㐤ѲыꥇѐÆרꗒˎΨŝ
å𖠆тԛ҈ʍַӨ̹âͅ骏
ӶӺ؎ҍΠụ֝ѹʻԹѦ
܉ޔᬪ͓߬҅͋ś黐А噂
҈ׯׅŷ˨ή܄ψϏҘۜ޲
Ԅι㙗н듵Ĭ°ժޜВ֩ΞЮѩ
躍кćݞף҄гˡ䰉ļƠŸݹ
ۈӊ엍ߋ˿̟ӾƩҵֽ
ėᰔ΢·һѤփ݄΄̗֙װ𹼘
빼Ӻި˪ʴâс⥄րߗ
҂Ԇʲצة͑֯ۇ夗Єῷǘ
쏗ɤӅכƙ҄ᴗՍӸ򼹭݄
ܖ߯鼌ا후̨޾Ẃ̗Ƣ
Ɔ񘈩Ё킞琉ҵن̢酠
΁гڐմǠۃ󮘃ρպ͛Ч䉒΅
ΩڐƩۏߚ®ڗᛪ륺ϫ辝ٶݪ
ܷļꘀꏝչӷ±ӫٖٞ砟߾͵ˉ
אҲݢ£ЦΦ绞
ٵܕ󀟟ɧӋҨ٦㞮ЂډȄ
ѭѐČڶ⃫ڢ֋ٮޭ̋
۬댮԰ٓ׽߃햀՟Ɨޭ
ֱ፲ŧņ¢ßώڌށҵ
Ϋ߂ݷпǸڡʋʪ׮ϯ펉
ʱ˭ҳٍڹŲҾβЧ׺
՗եņ˅օݮזȝȑ͒ȓޛ
կήڴۋȸޝ믅埛ϖúьѨ۩ԟ
ڲ랣˰؊Ѹ񮮎џͷҢಈа
ĕ܎Ј㲺ʙ񴮥Ź͡ЩᰟŠ
د̓ۦʴ佩ӫ䲫Ռ󭇠
Վ齠ȿƨɌИ׽ڈʄǯ
ӕ턒҇۶ȄΔش˄̨ݶ
͹ݾΪğИġ茷ݽɷՆԵ߹
եԧވ˅օ¯ᚾٹƛµΑ毞ؘмޕ
เ̗՝󧞼ʅś侘̸┘үյħ
쇛ۆ妞²֭ߏݪХļꘀ鑜չӷ²ٖ
ٞ矑͵ҾዸʯטՒ
֭ؾ̩됤채֭燾ۓͯ
􂊧ܠԉ۩Ӷ֘⃎ᒄːʹ
׼٩ŗ՗ܵٯޭ̋䵻Ŧ׉
𚶬Ԫ꓾֝ʻԹѦԉƠޥϯ̗Ӵ
ږ崭ԠٴȄӭۮśѻްڝݺ򖧪瓽
댮ݺݮ°Ӡ˼ʃݟ
ū܇ܬβݴަɅѠ׳ʟ
玤ϰ١扗䉍ы񈗅׎ڭΓٰبƉ
尮ҭ蝾ٟ햧ӈ¤Ѣĝ̢ǟ
ƙ˟򬜨ڣ͛帜珪͛ؼϵӊ
ߐʙ륺Ӯֽ͎қɊÍ̠󧵆㛐ӕƝҫ
񂣉ቘԗۗբƼѦԕєŬɸ
򆊂Ѣɔ١ʯߠƙªѕ֜՝
וۉߜؔĈȑљ⼜ẢøἹªΡ
Ͻܐ̖ƭ誚񐔩ł옴ŘӅ
ޠύΪϞ܈ꔷ߾彴ڢۏ̺Ч
߬޴豳ڷ筸փ▢ÄԹ񋙾Ͷ˶
ːխԭڙ幭钅ސ
̉Æ׺ߌҤ͏ۯӜڗސ
ШԮڧʈ܂ƀтː͈
ڌ܂ƌĠː
͈قāʈɌ܂ƌ
ːߘŤĮ
&]
[s0; &]
[s0; And on LIB tab add C:`\Program Files`\MySQL`\MySQL Server 5.5`\lib&]
[s0; 
@@PING:3029&750
ǍȀҀހ󀀀ǜ
Яߍչ㮽꫊ĺհàǰ昀֣
Ƨ˜ݵ˨˄֜Ȣǵݼھ޼
ɂ큈ހﭶ蟮
ٶՋێŠՖ֜Ë㤤ğˏȹՆ逴齧؋
텷霓نӶۚǄĊ¶ȏրƱ
ְނϛ㍽π׷Ҋցٖ
ܾ޸ׯ
ƴƻθɶ𣙍ìƄީ⨆Ͷ׹ʸ
ąËǋի篿ϟ񇆕꽀
󳹆Ѧߖ̛ꘘĲ͟ߞ
¿ߞ甭ǖЂծ
ٖ֋ʿ׭񵺹׮ܯށ̿
ϡƐηƺØԩضηⴸʡ˥ˎł
ؙҡļǋá̲଍Ӆׇܻ߳
ټ޵쯏ƝرȵؿؿȖ
׮۠Ӆ׮չعŽݲվ
ߌҙݞ㯄޿ӿƃֹ܍
䡠ʈâ۳崂֑ԋܸԶҲɐ
ѕШۆלɅѡ堆疰ū
։ĒώƋ˿ėρ
Ï絎ơŧܞݹ浿߉♅҉ͳ̩
虭َٓἌ騺Ԍ̞ۡƉ
󔏷샌맹յ˹؂ڂޘۦߋ䛠
Ȗ鮔ꨈēǻ鲆ɳ
ނە腿 ńɚƐʨƅ᯼ޯڋƟ̃؛悾
̰ب֔ᯢۏϙǟܶǰǮ워
弊߀߼қƾ̬믣
ۆᓦՐڃԱ묃ԟި
֚Ş̅噈ĨȐ⻀Β軷姐څ߻לǊǟÝ
ØɈĬЀӣ٩̲ܺũ尋
怼亇͕ݵ傎۸й˃奌
ǃܙƌЂ䮯竟Ȋȕ͋ǅ񤃀
ä眷У׉ʫɔƂߔ篼
ܥ˸񕓺Ԭ٠ȼѼ׶񬕜
ٗހɣːÅ懍KٸۉΟϜ
ƳѨƜݍٱ맹ΡΌӫڲǭ
۞䆮͡쎳􂀂ȓ򑄑Ғ⢴ؔ甝ܯߌ
ЮӸʖ类掆ƃݘߏ݃ꡃ蕛߹
ǳӸ؆Ǖ貮𠒕Ǐؿ
ԇ˵ǰׅݕÑЦ˳ݷ®Ɯ¾ŵᠲ
ءխՏՖ龌ؿȜ󾜗Ȯϝ찹꘴ꉽ
ҽݙҲƜ喍֗ڭ堷糊Ǥǥׇׅ
󕽓ң簻䞆ؾӧ刯Рė
ȴ꤈꤈̈콘ލ݌܏̐
иڠ֊ãو܁؛Ֆ֕蝲ީяႆօ
үߒێמʵɗʈΝԐ꤈ئ춦
ɂˆŏ݂Ȇ➘ĊļЀšҒɥĬ
٬򸌀ȩǭĺбԆ握ﵖ
쓄ɩ򖘰ʇљǲʎˢƤҞ
Ï֓بީ󐐎јϠڙ쿤ҫᵯً
ǤԄޭĨꚋݾ㎠⦯౤֟՗
󁹳ԛ텿Č碋ȅʢƸЯھ츉
虺𒦐ĸرⱀ҈䄹ȥ⌄ѽ
ޏ劘Èݘ诳𥆘㝶ڨϼʋ¯Ƞ׻
󢝈úŎձܼ݈ؕܡ
Ժϊֻàю؈̫בВŐܱȡ
稙ь噴ȃŲա㬿ւࠥйԤ˚
֗ɱƍվԺ̹օΨˣΒ
념ƣϨשϛ՗ְ߫󾈂آё̫˴
Ïȳɜᶦׅռ
پٴíτܝјмЂÊ䴫ߣǘň
ɆԌȨǣӮĳɠ֤؍ǐƉشޭ̡ܱ
йҨ钒ȣՏǤܬƟәЁ򡘐Әᩣժ
Ƕ綩򱠘װ͠Ɛೖᦸ뉂֧ːʙ
ձ銭͈څ菄ˊöǀƈϢϝΔϢڀޮ
۵떏瞌ʻǘԓޓ﷘̉ȕ珻ެ֝򲋒Խʓ
՟򾿅ިĭźֿ鲯ێ󐅅Đ
،ɤҏțͬ鷊̕ݙ
蘅̗դދŐܘ󼛳Ϊ
䇀Ծ˷͐֘ϵד㫜ٮ势댸
ؤϞ省ԬխלʣϺ睑Ɛł
˶ۯɜӗ͆פڝ҇Ȑ
ăյίŔר߃ߔуź
ŘȞԕ͸ˌۧ˙͛쾯𫱟ۊ
Ҋ̊ͯǂƵۂ،᥈Ʋ
אǆ̹ﬆŽұؙԅ鲉딇ᠡӚ߀֍
ǢҘɪޏ衇ՅؘѿꟀ
ϋ⠄ռᯃΔ颇߲߃Ԓǜʀɬ
ǝë޵ͩłȬҊΏҌ祲Ƅʕޔѯǉñҡӑҳ
ֺ뽑֏∱Ȟ⟖ḃѳ➐ʞৢξӭ
ᴤܳڻ૛̗Ӌ㫕ǈΘ蔂῔ȁ㨢ꨋ
󾃥֧󅗆ʄ؈̫єԒŐ味끂
͘΍نڝѸ̓؜痦ر藩
уĲڕÄῲڜӠĢ返اڬ뒦Ƈ紈Ӣ
ٿΚֺ儽ӚȁÇɲֵ۵̏Η
ƌ´睂Ӝț摛ׄҚџıߔϬ
ৢġΰίҪ珕钒優ܝќмЂԳƻ
򵣆Ɨ񕚐ڶˑݖ򤯵ǎӜܟ򓛐
лČȗږ౤،ƉÝË¥߂Æђ𪃸ɪէ
˪ǈҖŋպᮩ邹śއ͢犛Б
ތ؁⽷ı䀑ꀭޙ阌ŕϐ͆މ
ݔΕᠣꍄʍٌ邹Ƣħʡֺ¾Ђ
ŕŪݳܽޑిװỴ̇ƈߦݘՙ
ۀ膧ӕɿՎι茖ЄÉ܋Ά
淈񠂰Ȣǰ䚾ΕƐ΂
ۅلħե虫ݎ굛ޤۉÁ߂ͺБ
Ɓﳲ̱舃˦ۭ̔܆އ䱤ܯ
ᛎ緟ԟُߋ޺ۈܪԉ
ɓʬڨڵלʠϺے՝߷ޮŠڞ޶
Ï図⤳뺗٬־Ԅ겼Ƚ䤠ﭒƂ
򈂠ˆŚۘᤥˮӞ
ֺϡٟσ҈䁉Ó͔ـٛփ܍޲
ވ䒡ڱպҒ۷Т̖ҥ䑡ٟ٘һÒᥡ
đňǴº晛ƂѼЈҩԃڿڡ
͘Є܎֜⁽̨̤܉⢠
Ͻ䏭ؔǰШČݟыӥ؉Ӆ
ǹ֯ԥ֋ʎ眍ʘȕΣؾΎśΔ
㦵מь܀ꞽόϝܭⲬՙ
臕ȫĊ؎񬇯لߥ␳զװܓឝ՘峳ɬ
섯ᚋބŰ񬨝ԷꁘޡֲĔ؉
³ƹ։ڨљԏЮĀҮϯߖٖЃԓ
ՊܰԶħÂѼŰލϖۤıȢ
ҏ̸֤֞ԗȲ鴆ŃהȘ㥠ޯ
䪫ٚ聏̃ʤᠣʍٌ邹𼉍ɔ׍
Տń֯®堄ïÛ⥠ȓłͬ
Ġꌦˡ΄񥡤ڹ˚񠓂،ɤҏ̛
Ϭʊ쁨ƺ֟߃ރʞ֬̚Ηƅ˛
򢗶ס瑬¨Տߤ邾ăĿǾ߱
ۨϖӷǼ譕Ы愱򤎬˕ӟꦌӦ
ΒƵգ֥µஒҁƣĮږ
Þү٬מǂڈ🚌ȤүԠ֝АĆ
޴Ȯ˴܄ڱɔ갩˻ݒЄă
҈䁉ÓΨ꡶͞لӎ١׷ޑІѼѴﯖ
ݐᥤ͉⦥Ƃ򬭻לꎆː
ؽ˹̴Ę붇خ ήԙΥŸ㸷
䕑林ʅӧƴձ¼靠֟Í׶Ɇ
ːɠڱˉʲߴމ摳β΍ӝ趟š␒
ܫ뺛ކ͞Гҽ̣Λ
𰁁ۍҭŌĸܷƲʦџ͠Ԁő
зק潨ڢٶҌІ֤ΐë
˓ȕў⠥ʍƱڻՑƖ½Ԉߣ̰˗髫
߹މĠȴ˨ʡ¸˩ʀċᠮū
ݳʍ؄ⓨꮩڏЂߗڌ
₵򌠵ñ¿甙ϭ۷螏㰅ͫޡسǕϐ
ټͨтџ͋ԧ諸̄׉މ⍰迯۷߄㱯̾
ťլؾ܅ㄠɓ؛ٵʒ嚨
ܟͭȎ𧝾Ɩ奈尺ªŷǑʐɏ
şǿמͶԸ邠Τʚߚӽλˢʹ֣
ဋބټ誒ܘɒΖܷꗰϴ
ղЇܳ԰𴎢ːԮ샃ܮԻ
ٴʊԾ̔ĭˆ×ԤޣӚˉՔǭ
؄׵ʉฉՓ۷Ŕ
ȕᵛɡƉÕৣΒ׽⩚½ʣ뽱
ߧԾԗǳΣߪЬîĵΪש
ţ˗Ë鹄Ϋ諢ݯׄ´ʌ덋·
ڽÅ⿼ıťώٲф˝ᮮغ֏ރ
ޓ͌ÿ綏঄ϩϜ
ʌɧȃ쫘ƿ⏁
付ق˸ɿﾁ䗁̓ݵ۶
񸚵ܱۼ鄝ՋӗΉ㑦Я句”ƨБ技
͇ř̖طؼۿ񾖟½׵
ˀψÿݛԧ
ƎŚ̡Ϗɿʟ﹜ߡڂݯᏟ
Ӯ܄ֽׁʨۼ܊楥
⿙ۋǘȍ͕৳Ƭā
ǁǠࡃս߀ퟀ
ⳖζƲܜ¹܍޶ȳýިҫꎯ
͜ᤏǍۮŮоה쁿
ݔӟ믫ǿ𓟀ߕׇщ݂
򩕁կҤʊˌʵȖ҃Ƞ˰ț῜
Ϳԯւ،Ç᮴ӗݣￏІʣ
ϙ샦޹ǻӡǟĿחۋ臔̵̱̔
ە⪵ƾЎꬽσޏά𢫦ۄǣ킶ܶɻɉ
ց̡̱؋ƍŐ݅ΰƂݹ޻ܘ
μ͎𤅗Іщ۶߆۔̆ÉƸիٳ
ۧ񱭗ˣϘж֭ׄ۟ҿŒ
ƦݵͿҒ߮ݾӯ鶛Ĺ曷әȾ
ٜ唏էՑț֬݊۔Ϸ݆斑Ҧë
ؘ߫ߎ𛿡ۢꒄ˷
ňǌ쎻ʾĥᵰλʺˇӼ؄Րش⮚ƐĆ
ۆ˘׷򚅌בܯЎʒ
ߪ쐝ؑʱܘ۾ߟ畟ߗ˗
ￍ͗ӛ钿ǧǁ׍ϔΩ֩酆ļּ
͚ٓ弸Қɹƴ̆׉ݖ
хߕ򕅡ڼƞꝆ΋ҋԍʴד
炀ᥜܕ۩㣧ѵ¾ؗ֓ʦΨ
ȥꬖ믰˚Êď⬆ؘʩȄʕᗂ
臖뇋訄汇щ̺ғ듰
ԍƣỳɶ˓폊ќۇʕބ
௧½㊹ɦҖã񩩩̍ϻȗҔ܃
Ǿܶ́Õ劇ܫӌخɤƯ
⾩鸄ʨ߯݉Ήʦĭګο
ꪯ浴ởԍ݁یʹ̹߿肕
ŸǫϮԨ╹銧Ḻϝꅂ׊ϏøꚓߗӯɺЌ
뼟´ϲާ뭤ެ迒欳睫Шڪ
ؘϛʳƋ͋ɡ̦ξ޶ベ̾ٓ񜏱׋㘵Ҿ
ݸ܁ʓྦྷ֪ո܅Ϧ
ĽƔԕįӳ፪ֽ͐ꏜ빱ѓӍ̽ά
᭳܄οƘҜ޽϶ĥѼ䵭ۿ˭
ӿ㙅߳زͷЇŖ̝ى
ѮřӃاߍ駍ѨؿƺӎӀхՌ聜輟ں
֏֏Ů̱ʱәۀЎܥڙյƥЬ
剌ʈ푘̻Ţޓ߯מմﺋ
Őϗǿţ׏揙Ƈⅺ㥽
ڮֲۑ«ד摉ʣ圯ۀ
ŻɹޫƵՎԈ㒃ɥۑߋߑ
Ԉ𥎻܉ދӈݘɮߗ
֢奔ݱ櫎䙛ݯǖƍބшߥי޾
Œ٧ۚ֓݊ŭ۱Ơ퉧¢΋ޕ
ѐٶؠ߯陖ȁѸӷȰɰ铰۷
ф֭妈喭۶ފ٢췓۬ƣ
׼ڤʿۏֱǣرɂ؉ۅ߳
ר۶˱綉Ԋ됭Ɯ祥ʻۤևǙϚۈޫ
퇨ͨ͟¼̡ۦ͕͛͟傠׮񐷄
ɄŐѠ𢒈萀ބ
ăËŐЄѠε᥀Į
&]
[s0; &]
[s0; Note that the paths might be slightly different, depending on 
you system setup and the version of MySQL server installed.&]
[s0; &]
[s3; 5. Main package configuration&]
[s0; &]
[s0; This is a crucial step. To link correctly with the MySql library, 
you must set the `".MYSQLDLL`" build flag.&]
[s0; &]
[s0; 
@@PING:3492&2193
ǍȀҀ퀀󀀀
񤒜򌐀ЙÞĆ쫈ʢ̌уȬ
ƁƖ󖺆ŽܡєǅǯѡƷӅ߭Д
󳼹ۯ٪෫ʳ̌גӍдֶ˛̤֜򖻐ڙ񚍊
ΠƢ§˻˗ܸ٨آ᪠迡
Ďٽ֣։ݿͨ̒ƥ݈̞
繋ݡଢ଼פ˭򩔾Ե􃉟ѭә猠Ҋ֒
憆уߓڞӈ˽А΢ܞی쒺èĽꝛ
߿˕ȐךմŌƕśǊܞү
ߚДϛɁԺʮƑѷՁۚڨƘَ愡׬Ϫԇ
͂ܩۨ釜پĮəȠ˥܈憅
ڦൃԄϧ۩ۏǐᴃﾄ
ƟȴШ宄솲ŠƋړҏ῅鈴ިჍ㚵Ș
ۅ剄Ӷ߷Ǐ񓷗ΐ奏؎
̶䅔㲝醥ۓڳΥ̍䶞
ɍ͆ɍԃÚ߆ۺѾŝǹݺ
盱㰥휝ݵޮ᷷콧܍Þ돸
ԕݘߛȌۍׁǲ΂ύڶҖãè
Ï䶞ܓ여ޠ£Ǉ
¡Υ֎î݈ܯȭ἖۱ɾ
ܯ҂ܳݵ繺ν͛
ɀ򿋷ݟױ҉֧躄굠ḼѤƨ
ˉПƅŝЭ㲾䦫̱􁾛ϣøպ
ܳސלٛйĳ׌רү
ЏӪѵߧͧŸǢ񰵚
竨˶Ԟ߫ɐξߌǝ݇κƉ
񮹯󣢢ԗúѵڈ©ġ݋ɖç
ƄƄ޳ڙ감ɚꭝݷųᡙպ
Ǹ✳߾گǈ喍µؠ˳۱
ҨǷ瓁ڽ뉯ԎӗӁςܔ꫉ֹ
ҿӪșꉬۮҍݦč࿨ɴܮυጀ
笠䰃睋ןԸ߶橆ϧ՜
ڼ֊Ś׎𢭑Ѷ݋Ķ蚠餽Ĵ۟ԃۗ
ͫ㸓ɢƆ皘Ю̮³︟̈ԃҵ
Ɂꎼʁԇ޳޹ÅӼ¢к
ַ☢ޚض݉귖耊
׊ܺܝִҒ޸ѥœʏ
ܡϷĝľ휪݆ໆ֩ʒ݀ƣń۫
ߑҩ;ʌʀǰٌӻ깅쟡
Ϥ翑ÿʍ׋ǫܐ甇ƅżȚ܏
񌃹ӧ㌓ӌȽϔ绢̓ր΋
ܸ؟㿗ވӾЇӞڥϷƍײӽ
ٹʢ쮯׳֐㢜Նڱ۳
М×瓺ؐ먫䌎ԉ˔ꀦܜǕ궆ݾƆխᶶ
د̀ò䫶քݲ񥷮ɍ҉ϟڲ
Ǵ۳٩ַ幯剗Ԃа
ҒٚפЗ홧六ﷻ؏֩աܵѾ
ٛآڔя꿧乀ڻڽ°坰́狪
؊ðĤָ܃׉ٖڞژꬅڮ鍅眓
ѻ㼻䫭ܥ͌рŜʱɒװа⍝㫒ж
Ұ˩ɕ̇굮ܗ۾ȏծƻޔʽ׬
ȭ۰چ˥麕阫ԏԋƞ灸欽
剔΀׶ƹȆߴ
鹜ӇҽϷʃՖʍшк©䢫͵㏲ً
軵뉘ӔЗǑ۔Υ޵
벞܉Ό帷ų⽭摂Αڃݒ
ΐ֓稑ǦĹۧܺȵԀżꑘƷމԨذֶ
֗ő묯ҤߡՖ̙ݛߕ
؟͹ꤧꗰܮτ
ՍጶЎƿז웯פհԤՉִ
ĶßǇڀջưއ۔٥ԔȞ
פ֫꿻Ǎߘ㥗β꙾Ю嗃ݷ
̚Ӛꆷ˜ڲ´Ʒܶ׾霢ݯʢ۪݌
븸±ԡǆ԰⫼۳͏еٺ
żļßόԋĨԤֆՕȐ݌埊ϥμΟ
䫹̫óۍޛٽ¨ѽɮĽﲟѣê
ЪӅϺИ筝Ĉ޶ވٔ
ˁɄލǃєѢٌݫ
磴׺Ằ׳ᄟÊޏÝӾѐԯ
羡Ϡՙ۷㝉ѯɍآʧصך
đַع؆䦂ΐ䱣؝ô։
޳͆ٓӠܨԳԠءˋϾ
򙪿Ӡɏϲ¡ŷۼǠوەꍌ素
ұá۔Ûқպӈ漐ל
ѤڸΒ򶺐ݫ៙ȇˇʷ͟ު靤ˌ۹꾟
ҎĦǓԀ͛͒Ӥ怇揶؈ѣ̉Ҏ䦠
ϟ톃Ԕᄯͪز㟆ЉǾƕӖȯʲ°
ѧɰڛɇڷ爅Ɣ⽮쳠Łޞ
Ѵ惊ɴ©ϧЫ⁺ͤ拾׹ʩ́ʩ
ͥ֡׮ĹϽ߰ь껚
Ҿ잡׼ϏǝثΟ׹
ų̱܋ޖϠψҷˠǹ٦ˠ睜
ݥʼ؃ퟗù׶՟񵌰͐ȝ
ٗٔߒĔӻ˱ᰃǶնߐ֎ĝ
ɋـˤܦɻއƾ徵еެơуڑ
ОظƘܩĤ㇁ɧۧݱΪܩ
ߞɱҮӣꎔѪݴŜ
퍻ג÷Ǜݶ켜إ戚洨̶Ԫ
ɰᔚبӧ̂٘溵Ϟ˥
װ践̈́׻ȞÍ͕ɦǿ͗
֜ϼُ釾Ѹ˸ǃ׃˚ȧ͏ɼ
澓֓﫞羄⬘ˏĊۿ堭و
̷͔Ƒе˦͖߳Ŏ񪜅üጯܶ
蚵η؞̾Ωܒԫ廳ߢ
һ喂٪σբʯĵ绢̘
ߝӧ뤽緅ّқֺ蝹뮾⻡ݓĜ
ˋ˚܆Ϡտ쪪͛ωýɞ
ҿ֤ޗΓіضʒ颏єűܕԬ̋ݖ
먙ˉϑ˓Ժ󇳵Ҏʹ㭰ߩı쮣ɂЗ
貁Ńґңӛ򞙲ⓙցУүۀۖ㡧
ɥݟ۸ղ󚔕더書ҼӿȜǖ
䗲򝡲͑Ѫܿޮݟ϶䲰楮ޡХ
њ߭鵼ڱڄΌì󮰳
͛ڱӞﾑڤӯˍЯ὾֭Ǖ
ΞܵܘÖՅ蛤岅ʳ
޺ѷܨ浪΋ꮵρƭ̲ێŧ
侈ٻ򑧐ϭ֖Әϟݝ
łޮӦͪԛɥܩ׆򥯹ΰ
ʧǰֵ⺇ָ۰ةݢśΰŨ묯ꁸ抨ߙ
­윒ߐ¦身Ƃΰߐ鞿
ςϻɟόܻ증ޡƿ
̙ߊ촍ނژç܅ېԈ냕Ǳ;򉽙
ߧƼ沶ṁԴŧ͌ȈԥѺ
̉Ч트פ֞ΚўӅˢʍ݁Ǥψޙù
Ȱձ˦ܹ鏾ǕȠӘȮ᯼׶
ꗮ´ðޖ݇昱мر憴򆮽ͦআ
ƨ´ޥ۔Ҋҝұ͵ϋ􀺔퍌ػ۫Ƴ
憇Ժ߉ǹͮ䰒̆皉߀
Ԍƅç񸟪̿둇丢ӳޙ
¯ƴĠ筃ޒʋͬǺ錌ŠȰ
¿լڪ⦮錌ţ𥨒Ɔ˥
à郕ÌΝ䴰ū׶׬ڋȐɝū狹۷أ
ϜЩา˥ۏ쵝Е̌ݺϰ
ßʏҁӲνԤҒ
یɂԠĕϕ۷ˀڅ
؄Ε۷䍄ɂˤʘܚ۽５
ިշـ햛ܗéӠح÷շԻ¼
ӻΗШׇ¡ͯƃا۷ފ
ɷפѧ̻ŜɋĨӠҲξ궔
ㅍƅ뾆֜ϲʭؙ߯櫴ڇ
ۇׁ啰զ䚿Ӽٞءҡ㦐
젧ŇȐ旓ҧܘӈӯҒȝ܄
۬Ͻ׀蕄麭Ļ휛
߯ځԘذȎɜ֚ޮګױص
帋ϗҢ岃ᅢӧʑ딵ܴ׺
ڙίʆȢޏ҈ܵԹЪ
շڹыᛋګЁØޡؽђҎ
ߤՋϱ顽ȍЉʯʆΧ
˞˰ǵۭه߬½ӈ귻ǔ
ׇܤ嚷䔏׭ЗȄ߯ؒژ׭
ɂ붯ڲ㿿гʎޔ属ݮʦָŏ
۷ɺӏ〓Ŏۚɭ붖Đ𚃻쾮
ӧ蹦ŇϚ߽裾ڑݞߡ
ýڤ氲Ͽޜީ콵ǽ
ݍǨ쿆ӽ릝Έᚦ
Ųޣϲȵޗܬ¹Ԇ޾큣Ǉڛ
ɤˎߐ臾ㄋӊ΍Ƶӏƈʋ
ڏꪈĠǞݍǵˈ⦿彶߿
𢚴黵ټԉ٘ޡҳҸؐԍ
Ԭ͇𓧢Ķ͜퀈의
ę֯ζ̉ߛ֏誈¥Ή
ﮙëÛʭҜݱ॔擆ی篐쎝ٝ
σМȓʦܭǞۿѽ鼘Θէ˛ʾ癇
򌔵Ï϶ԁﮧؓ
߄λ챛ۗ٫
ʞυԹӚéݜؐΦȽ߂黀
喏ȒӃƦۊ˔ԍ邋붖
ؗك
˖ő̀
߮áШ٫˹ǻԨޣ껲Ǖ
Āޢɶٕիةྃ
֟׶ݐÌݷ݁ᇟʌƩ慜܈
ןФ˄՞ُԦĒɲޑ͛ҹ껼
ǭǸ趻֖ֿՌ儓ְ
Ьѐςދҟ࿿ɝ־پֳِ
硠˪ߖɂ̆ㄣ󿌇Ͻ
쒖ß񖮌˶ˤہۅηøڳσ
ϳϽ쨧Ϋذ𯕄
ݿٞǂڲհ׏ǎýϮ
ެݎ沾ܚꞺتưږѣ╝Ͳ
ȁه܃㸃򮺙ԁǧї˱
ڜ͜ٿг߱ʫ߾ǀǺ
ꖞ着쌳ʧ۷硐蛛˗彾
ˤ񰮘ዢЙ֥ޒࡅгͶۮ᎞
ԧࡁ󙎞Ҏ㎝ҵʘǬѰ݋ҹ鶞Խ˯ී
ʪϪЌ旲݆هؤڥϿƵˏΣ䃐
껸гʹڵկؒ߁״Ŭм鼪
ˏ遼տדҹ醍ޤޜҼ
ӗǗ҆Ó׷舀޽ǱͶ̍􃇐ٺ͛
ĆӼ̷Ȼáɤб͎쪼۷͡ޝ
ɏ秇ݠΊÍ܌٠ːսĢܗ󱣡˷זܖ۷Ƃ˾
й߄ԥС̬˘툥ʘƜӉ
χ񌔽ߑש빽χԦΉ鴟ޏ莭öʡδ
ݭɧႫȠ뾘翛͌ŮӒ
֖ȄҪә쵶ꤒ砯Ą钺ʘϾԌɁŠ؏
Ѱޯ߱ӵփǻ֖Ω塛ņج
δ݇㵺Ņ˗𬛵ɒכܷ߷ۿ噡
򝉂ى瀋ӰǷܸ֞Ό贏ء̇뚮
︶簘륏Ę߸ȱ񷺓ҦʝĀݖ
̟ԝưʥᑑң
ΠĉШÏ܅ݝׯ޵Ġ۪քըݚ̴҂
ӏمɭ̟ց΍챽ěӴ⊺Õ鏓Ц
ܷ԰Ϙ܉Â߃Џ麿̌ﷷꜹֹ׻ە߭
헁ʭȃօݺ⸿Ǟ˽̸
ڃ۾չ艚̎陑ǣԷϵˍ
ҽׯ߇ׁ˟ϻ꧟߳䶿뺙ם
ư۷ْ̣闿ݙřԀьş󭈙߫֒
ۧݵކ۱ㇷݤŹӈɹڶ
ﯞ֧̿ٮџЖ郞ﷂŭ܌ӆӈ
éԔӈ须΢趭̉ŃԷݿˀ۹߃у
φ󜃎߲̀ϣԠۧ쏷۶нڎȒ
׀̥ۧáߞރٞ
úѮحܰ毎ؼ꒰ܐ窸ذ෣
ڃӰ۱ՈŒڼϤӾɟ
ٯ҇ƚéךЯޝժ㭾ŷݯߟ
ӝʤ֋ѴЧ막ɡȽ͛ѵϟΑ㶶چ
ܨӦșٰ֯͠ˠچѻޙ괡ÙŰˎ
ź߬ݻƶܶ՚ݟǣめ
͛쿁򍶇ƅ勂ࠈ̸ޜ鵠شь
완㳅柉˃јч˺ŉӉσú
د隦ژϵͻ⦞ț
ɿפȴƏޭ󯗨Ǘ񾨝δ󹿭
׮ԄáǰꨬѴÂÄ؛ƙʟ̉
߾ͽ͆ĺȗͣ嶛܏ߦ盶ʲýܗ
ېʻϯ蜇߲܉ρ׋śްߝ
ӘӤǩĞӌٜٚ꫽쮚፩ʘ
Ӥٺᄅۘიҥ񳷉ç޴Ѯߟޝ
ښº䯊ʶǌ뮍ֱ
ތЋ睙ӹߪԓފ׮㭾Úء惃
쾽ꐗëԌڷ첀Ӏˏ
ӮǏկѶ坾ŮϜ٨̝ӄǚצ
Ǜܨ򆾦ևϾԽٷ̀Ɓ
ڀɗġ΀ڧ잘äɰ؊՜弹׍壌˚ɠݽࣞ
ԩǀÀ߽̾＞ʖݰβ񩣮ͨ߸ӎ
ޫˣݘҢƓ͆؆Ѹ既
߯ܓ򈫲٠鍊׫σҶǬ
ˤجރ՘ÄЏיδےɏ
Λ׹޲Ϣ׍؞ֲ
ײ񯷲ȹڥՁ跮֔ހοӎ׹
ûᮌ؁ะσ݌龫泹̰ן̹ͤ
̨ԭ߹Ҩ٢ڳ՚ᙺۦ֔
ըׯƏƨӑΛǀ놼گ޴ل
̪ٶɡý۹ίČ܃򶹥妹ޯ׭
Ķ喂֓О٫餎ߵ𞙺ߟ
ޗȢߕܴŽʳ݇􋥿ʐ
̝嫊ӀԚ󿳗䡶ۙ
Ԥɯ˒壂ӎŨʣޔ룙ڵ﷿׼
՚ᗬȻ،蔆ܜ޶׻ϬŻʸ
Ϟ鞑㺉Ͼǚ؆׾
돫׮۩ϷײѢ޼ٶʉգ껲
Ǖʤɖ¥̥٢ߓëչ˷ňژĽ򣨋ש؄
ޓ٫񂠈ŧʟǄ젬땄֪
҅ꤱ孇ܵ٫׳Ȳۯ󗗵Խяж٫
î쒄Ŝ䏟̘ڕ󗮪박ѯۂ
ȠԴ̴Ĺ栄ɬՐڧԎ½簨
ܰɓԓ̧ҮףӰ۰ˤǎ
Ǒړ季ɗؤ斚ҥؘ͠ྵ
܌Ңҏɤń粲¾⛇խ
৿ԨڨŅŤƥҶݛĨָڬ֟Ë
ˢ񿀏ڥٙưĢՑƄƙ孮و˃
׷ɚ䟁َؔؐЇ՗ˮҖ
ݿ٫կ٧ھҢʋҏ Ӊ򘒦Њ߃劃
ۛ呵疱񚆛ڊêˮƛʡ
ڵ󝖗өڧٟܵѹ¡
ԫ䯢ȫѓж¢Ӊς񒥭
Ӻ؞ƻуܬׇ̞
񜔬ȁז½㡥ߕޭǱɺκЏ
׿ƞ݊Ȣӽ珼Ǳ؞ڠ
ǀ΁ֻ념䤍˗э꤬ڬޏޒт¹
Ġʨ˜ם䞋ܿݏԄЈ°菆­ژƁׇ
㱱¢ȍĳùԀăɭޅԒ嬬Ǭϖޅ̆뀲ܖ
ؙőǠ人ʄꭽ݁قӰ쿢ҶݛÄ
ǠܳȄޗȘ݄ٙҾۥѴӖۯߊږ
쭋ʊׯ߷㿌߹ǌɡ洌׍ɉ
ׯݽÌÏꇸ⪓ߌ
ܽᚁ쁔̙ՠ̶⢃
칌Ӽ̔ăˮ̮̎ő⯜ꢦힷŋǘũ굖ӝ
ڻşލцΝ涣ԋүʼ
ދÐ⺃͚ړƨ̘ӽ̲Κܠϖуɱ
Ƣ۲ɞ嗡񿀐ŎА
ˡǂ鵻ގǺ؃Ҙ񇶰Ɩ☉֔߻Ϙ
թ􁲆à͖폱Œ˧Ζ٨ՠӑۃ̍
իƊ˻𨠀ا󢙚өكҖƁ䰵־Ԇٰ
ŞݫׇՖ֮ʭюި
ʛ͟Л精򭩿Ȑ؈¹璉ӝƅ
ڰӏ̠˱Ҭ糙ݬ蘚ͻ݌
Ŧ݁҇߭ôŅĄ
؞ƸيýԴƃԨԀ㋔㡀Ѕً˸
ۯϢӁϦҒ歍ݧǏܮߣ
ʣהІ̯蛑ҡ
̿Ȓ˟ӧϏףĄ֌ήԃԶһª팒
Ȋᱝ۠㾆ꒄ듐ƹ
݇եώݼھձ𔶊͞˙帯ߡװܹǂ
΃ͳߑہܭ߇߳ÿ
Ƚع̽Ͽꊿݟ̉ÃێĽ
ԓ⁪ᗕ񠨨䲚箫
툫ʭε֡ݚźޜ͹ʣɥ郯
՗з͂ٚȴ
됩͹ؙꊮןƛｌᩉ鹙آ墿ȿﳄ
еѻؒƴȰƭُ֢
ԀӧՏڴц՘֭Ȩʋ衇
ℑ͈篯ƪγܾדƲŇо
ퟩ候ў̐ƍ孂ȵǰÓо«̠
ۤܧÁ۞Ҟ֏ǜӿ߅̢о猆є
̿ٻ历ժĔՃӪ來˫ֽۈʎ
֡ʵߣ؂с̇ٳ͚ϲ
•㞺퀱Ƚ瞁Żϣᬔ
ǂֵ璉ŀ٭Ѱ؁碳Ȼʖڀȅ
ެϦ«ׅŧȈωۚї
Й⨑ՔƯӸգϪєЁ
ӹثӰä߰Àش̫έ޾
ٳ鿏ׅТ؜ߑسՐڀҺ֖֯
Ϻť㧗􉅺ւłڄꋋ惭žӠ
ذЇ؝݈ŰاْƎ䦛ˣЖ
苵䃨㾵ӌؗҚǯϘ△
͊˼′И혰É鰤徭šˏ
˗˧뗳ĥѮ⊔Ɛٮ؜ڄ
΂֬۞Ϭ̦ضŠǲу崨
ݺТ؀ʰݞ䜲ݢ椓βڔΎ
ɞܽיجТӫޝ
󳿣͝ȉϞɊС
ݻӇТذț鴷ϟʟ
뾹޷ԝΆܧȄݯٔ߶ңؙ܏ʓѠԔ
வޙҠ߮ȫĴַѾʩ𖖖ِŢ
΅༱㑑օ⿓߹ؗŊ܇萧ُ
ƾڶޡگƃχңٸˤЊمÞĄ߈ԓհ̨
ИܼԗԀȻ˂Ͼԭ݆٥
ߦɋ֭蠈ǣ׸Üмͩ꒶䪡
݄¢̸͘屻ֻЙݦ̾
óπ칓ԯ߾ْϯڠͫĖؾ
Մᇟܦ⋯ϳŠϿͦ
⿗ǎۡߦՋۗƾ£恠屻봬
訔ٛې٬󐫂٪ÄʢɃҟҚ΍Ң
ԭժ쿹ԛՒݫ󎳯ѱ򘬧ԗʒՏ
֑ΨͣڨǰƧөӆؘ鞳
؟Ǵ؛鴿ĩ̿㍷ǞƷݗλ߆
͗佘ɧӾ֎ȗŁᱺźҁ
أ͋ӸܐŗƘʛ
⪖Ϙﲠ򺙌嫨쇌Զ֣
۾˶潻Ԭ仝Ԡɚƕ텐ͨź򅬓ҡǑЏ
Źۇ敋ڝࢋټӧʸ޼
˝֓Ѿ;ÙܼȘԞճ±
ĔşȀşԕШ󢚐ӲпÆ߶ߍձ
񚊙뛺ѷϬ≆펡ޔЫ͚؍̹ҀҔ۹
ӕȗޏ㿲ܿ炊ޛ׎
Ӵܛ׳毪ևƊ難
͡׹ԯǳ؋ו̿꫿ɪաŌ۷볟
؍חÒبɩەﳮ׬À↻Ưʪ
ͬñ˦ƃ؎ˋϏȒꥐ
ˌЫˮÜլҡگհۛںϧ֦ط
˘״ꠙ涌ĦȨ˧߳
Ųِʥر޼ǎҩ矛͉Ӷ׹ݻ
˷ώۖￓşԨቀٍЀṪȋ폓ښ
̿č̨ؑ׉ܫ܂؋ʘ氺ъ㉂ߞ׋ƍ͹
¢Ⰴጠ̵џְî־՝ݵψ丕
̓ޤʡٻ֦߁㱘򩋋Ɣʊ
˦ͣߚˏ̮֓찞ՠ؎䎦όȍ״
믿ܜʅݽةȊ֓ęؖ򪹙艬΋
臔ѲښͩЦԾٺŌآҫջ
Ƞ׍ֳȠݎᑇŰ׋ٝ
րֱɾŃׯɖБˉ¸׼̥ſ
ӽۡں۽ч魯ƏԆ˻
ܨ̻ƿԸؾްϑ녌
琲ͤ˘Ｖ߸۳
ƅ래ﻇܳϰ݁䜥ⷞȵŰ̘»
۸уñѲ׳Ԍ֭ܥӀҿϿ굃
׶󖮤ꪐѢ󇈸ᕨꪗÇ傋痿Ǟ
ܷߞ̆󷚎㓚еܖϼ
ø谢ƻ㇘ǚ쵧򰞖Ɨ
ى΄饊Ԩ渇ЄԪѐÅ찅䝙󃯯ŏ
ȢؐիŮәĦʡߘѭܒƍԦџ
́ױסԘ唬ߙҩҩօ
֣͊ȑꜩ
Ώꎪƶ񶯵ܲ㟿˻뱗ʌۢߐ
ƎǨݐ٬屿ߘ̍˨̬
Ϙߵְ唦ȣζ܇谽
Ćݖ¡׃򖖖Ʌ牆ы΂օር
Β绛ȸ򓋚Ѯї˲ؠ؜ϵ볟㸙Ăى苕
߾Á¿Ï萇̱ᇰ䧗ɖ
Ӄ햮넥޻ȱؗ硐зᮅʆɯ
ᅗ۷̠󋋋ϐ̫ǿȤ䧰ȟߥ
ڌ͟ԩȣ҇ޞ׽ݛ߾ݎ܏ݞ
б̷ϧ򺡑䢒ݗֲ䮡ɅΣҚܲ
С׾Эƿ޸￣ҖΧߜ攜
錄νũБƁ̓ߍ˷ʋ¿֋Ī
꫰Կ΅入¯ꌥ鵜틼ٓ΢֘
ӴυՐսͽެ迼̲۽㐚
ϞʠՏȽϤϹɇ޹򟾰
⸿߬֞㸤Ʉ銒Ăߣϭ¢䚐콊
Ċҗ䣗ʥȥܷ͸ɺϩť
꙰Ӝ蝿ʵоߥͽܿȚٛǀ
ǚΫ篹ٛƻ랿܏䭿չ粺̞
θʏ˪ʻα֜܂ўڕ
̓߉ؚص޼ƻΘׯ񸆻һևŘ
Եݻѯ؛ȗޕ
Ƚ֓بʲħÜѽĿٓ☎ܺ
˩灿߬⑥﹐ߵ蠜ڰę䂙ݦؕʨ
̈ʔ𰚚§涓ҩӠޝȊƎ
Ъ큖㘔ձ竴ђ̀ɳ䫳ܭí
Øư̟ڠ֫؉ƺߠ
׫΍ԛտӷشϾ܁ιؘڠƴ
ଔۥޥ߶­ȼ˙ֽǘ
ҋ݅ﶸԽ٦ެϷן­߼
ͯ֜۶⑏ӂۆϲ֋րۉɅ
ӊլ֑ņ閺ѧҎ܆¬٬񹐢
֝ԀȌϴԕȂݱڎퟭ
ƶϷƍ콳ˣ쬞̃Ż
ߵǥƱʴȴѹ砜ئ޾㿃⟩܁
՚ɆƔ饰иȻ迂֊֎ˁ
ׯ嫺ܫ䌻ھ및Ύݝ
ޞ󫷣䃦́ͬΧҥچ·דᢑ毀ϲ
ێǱ؎纀؟ڭԝ͂߿Թ߇ܮ
󙸬Ӄ·殇ͯ
ٴ󵪞יϿʡÖβ̯雨çȽǷ
φ梢֭ٗ˦Ў݇֊ˡ
㯴섇αߘ݌ھߊ
ۙݻÛ̴»Ҩ䒮ݺХ˗
낡˗ڱؖ؂؛֯̀މՙł
Ф֓φξɊᓊčگ
سһܤ͒߄ϫƣⲼĶ
Ð棶윑Ųۊ隽ׯض
ಯѴᧇӋ®ۿ宧ĕҿҼڀߏژ
דʸԛ肻ͼۦ֨嬍
۝材Í߶߂о쌫浹ǳϗ
Ҷͮ汿Ŭ҅ݻҭ۷Ɨ펧隳
ᑿď񈌥ر̈҃󚠬ƻ茈ФñøŅ
ڌ̰⿘扆ψަ͍ر딗ԝϞ
콾Χظ̫ǳ޺̉ж餫ɐ¸ɠ
ݴԪʿޢӈҢ뽹ㆡǠՇ˪Ł
͔ϚɄ԰؉Րȸȩ튤㮫ϊ㯫լݑ㷝ԥ
ߞƂ惸錟À꾼愣䢑ΗԻ帴
ާկº鷘ӝжټ޿ِƽಥڑړӺǏ
ӓɘݤ§蟞ҟͺ
㡥爑ǲϷͽ޽ٳݻ׮袞Ůس
̈́ƗތߟŞ֊·׏ʸ׈嬅Þر㇋󻿿
ʞ܆濳ȵ❣ڔᙋ
ދːʤ㺻۫ɺȠʧ
ˮ׿ꖾޣΝ۷āɤϺٵżϟˁз
иҠ֔ͬ垲
媿񜯷݇ܐص뗸苚
ѕ߇ďĎАᬠٳΡḸ
ۄǐ렑ү֍ʎКअɄ
ݍ񒞅ԋ夃ꅐΑ֮яۊޟڭ׳݊ޭۺ
ӄ֍۽Պȏܘ՘ڱşԽٵړϸʒ뛄ߑ
׵꼓ɨ袭ҐΔۛؿȼʹϒ䁷
ϓú³ջݦ߲ۭɄյǓғ
ѡ;°ގ䌲ֹ֚˻ڥ失
벁̥ܠǀǹҝԼ򅶱ø޵ݦǱ龌ӫ
ٝΪƧȬץǏѝ򺡑ا¢߶מŰ̘Ȕ
ݍȭ˔顋߃ԁ̾ϝĠȚҟ✐צ
║ɰ顷̞ǉߓҙ᱿ڱʥ뿣
ݞթʑ©񔈉ˁЙޢϑǠܘ¸ʝ
υ´ǵŁ׷ʄ܄Һ񐎤ݗʑЧ㧕ԏץ
ǹȈҚіȌդ޼ςƹψ¦㩳
ƈݴ袃ӜҞƢȗƀҐ
򤓞̄џܫɨ
ߥӦ쯙㸆ݨрշ䗴Ƨʴ̤Լȏ
ȀϺܐҤ̹ػ⺝
ΓȤڐ˰י܂ѱٳրŰʀƸ؍З
ر˞ȖƜ蒙ƅ̰ҵ̙ܲĸЦ߲ݵ
ɷ󦉛֏ɓߞؽλ镸
ڼҽΑċÅՁ躄񨘋̤
埴ʹ¢袛۾՘֨Ȼʙ͠Ɇ
늣ʭ̸Ȉݗ꺏͓䯌޻Ǯ
ܐޓިǭʮ񖰬񾁨ȸߢָ񑂓ʎ
ϫ񺺆ߌ御ϥ⎑񑫙有Ӓ糭魺Ͼ
Ɩյ᐀ל՚ۚ䨾ڐ
خƣӀ֜ʺȾ׼޹²ڴް㵖ȕ颱
ߵ匝ȅжʑ̊ӯ斔ʱ̼̙ܻߣ
ӟݔƭؑܠ˞ś۬璌ѫ㝭ꠋҚ
ʩƻʼ⭑Ҫ⩃؁ӯÊ՝¯ֶ
񑆾ٮʛ篭Ү䕡滆áٜȑԆ僮
֍ݯգީκՄͨ⡅ǼՑ̦٣ìߕԉΕԖ
ϺՃ誎ȷ騲֤׏俊ڮ
ཛѶϨ͚ۢş𬳱Ӥ߼߇섯
߸餮өڼݣ˚ߛ놟إɲ
ҩɆ麮蘹ٳ
Ƭ̸ѧ囼ܧǲŦ՜𮼱ɿگ
ɆĹたݏټŢ䵙׈װŀֺϘ솝ߩ
ŀİ񭣽ÅܣԒ¢ֆЊɎҔ
ޘ܇ڠЄ䃄Ԫ񞠢ӑĢø˴⪝ȣʠ
ˏлߊܔՀ̸ڂв
ԬӨʜϵڅ·ڊеߘ
ָŖђߘټ辥ʧғŧ鍰ȺЖҰ֌
óݱҪǥԿӨܶ֌ͤá՗۶
ϫݤʰĜݞҝ
㤰ِۦ뷡Ȧȑذْр
ʔΫϫЂܐ펽؉Х۞н
¸Ƒó̕옑ڢԚ̣ᑴƪ֓ݶށ宁
ז롷˯؂įƕȥИʴ耍ïÊիڕ
Լ˵קҷ͏ܱÆ싱͂ʜ閦
ܷĂġޏ򸊔ȥӴހÞǏ޺ۛ
ඩմϽͻʎڬȠͬɋ
ݴҬޒͯ֨φٔ轷͜铐犱
ӟ׎Ȓ㐿ǍΉѓǎՈʩۗʏʔә
ˠɴ譪ޭ㜳ڀΛڛ杰ӽ
将ޅ֠Ū߳ח͏Ж
±핢蘀𸽪㏐伈ࠠܩ߮ގĂ
ҩ׫ըχ멉ًօ帢ԵΨĒ
È킵ɥҴ䢶ɦҵՄ
ٞİݤжݣ՘Ē࿪ɷÿۼӜ
̽߇ж䎩ʀ޺񻘵÷뜦ۄ䇽ئ¿൅
똱¾Ϟ˭ݥσ纁ϸޮ뿆̉
گݮȤذ֭Ԑݦ
ܧٓ᥺ΧɌҒσہ
ÞբʵСަâ܎
ÚÑ脬ٝʼ՟܉囷𼀽恖Ҫʒΰ흯
ŽȤ߈酕ᘊݕʳ䥺ߟԌ䂯݂䎽
˭̵̀ɥ󺁹꣼ۆ֮Žž߶ݏƯ󷶶ͳ
ϬȞȶˮֶЖԦƃ柽ۉ݄ĒҸ
ڂ籏ğ鳧׻ݞք撌ňԖ
ބÜ󬬾ÌĥÌ岡ψ
ݳώ̞ԇ㟯긑ɓ
׆֤̳׿Ŷа䵂Şۣھƹ䅪ִϼ
㇄ھǘŔۣ쬕Φ̺█Ḫﰠٷ
껼Пűܮ屠퇯ޱΩۖЄ
¤ǃݷȆʊӊؒ§ڌߙʐω峤̂
̤ԣכً푱ѴͧߜםϹǝλĶ
ጺԪδ⶷өʩߟ汿ݱěɚ
ҫɆȐ¡өſ޳ŖحւЈ᱿񦷯
ʐͲβ坴ÅЖ؈Ҡ̢߹ɇ퀩܇
Ӻ˗ú᝷󴿮⇈бӢǪ
쥌׆Т࠽盠ǀعӬ
ĺ܁ˆ臆υ쁦ǸނګںУ㵤ϲ˙
ʝÏɮЉǜǱ
𔑙ؔʕ簪˓ť̷ݼǂ׏
с׿茶ɦދϝڋԉǑ
ɐϱȟ鸸ߣ曡âޕ֪˘
Տɞ݁Űɪ࿭睔׻ٷܽ
⠄Ğύ׋ֿǰ
ߎƗ薂ԣ럽סЧթ̫
ꥶ閵ۦ߹ș孱𤿨˄
ڵ׸ޫᴱǬϲ˞݃׵뺮čͽ
񨈜۽Ҧ۔Զ߭ՈΗڰФۃ
Ȳ㒚㨳Ԓ뤣ݙӉ㸎
øǉ޽٣ɞ㏞鳇Ώ̽쁽
Ŧ𘪷쁇ПȚԍ
ǈ߮Ь瀊ޕž񭎍ܰǞ
̓䱨Ղϣرɑݽϖͯ׋ǿ՝Ō㐒
Մɹ꿛ǱݯҿߏۖĬơ˦
㠚ČΚƉ瓕줦ɟٷӯ߽
ڨᬬضЙۉ˯񸃃ߥ㻖݁
қ틷޴Ӛۧ媿鍡
΢ʦ؟Ć͢ļ󜀜ޮĲϲފٰ߄ȧ֊
֭Իɂ濖ӿ˫Ģ݈ӤכξĲ
Ƽݻٓб̚Ǣ،ɯ辍Ƴʭл
ڝ餀Ƣѐ۷麱ѐɅΣ׆ㅫ؂؉قЏ
̚ÿ¯ޝҙܤ캞ѐԍꥷ
鵷ӈ婣巿ҳ忾ϙ׸٫
롃ֱٔ߁ؖʈԬ܀ᖊϰܳ󹇻˕Ήʾ
쿲޹💕द믠܊֢
ɠŨԂʸȣ⟽ҵҲ玤ݻ
ȗؗ˔ѦĲɳŜŹޡ轙䯿ߚң
؛ޮҘŨȗٕے􍉯कӂ㑍ʲܞ㻙䥐
ݰ䃅Ţԓχϳ󇂙׼׈н෨呪Ԓج
֚֒٠谭߻ÕڑנѸ戮
잡̛ˋ郓՘΋ƫơķؖ𚲗Жȟ
İ㙂ߺڕƏ܉ļ򝳀淈휅Մ
쁴ԄʭɅ͐ȸ˝ӒڳĈۇ
ɐϺʨ˞颷;̌時ɒ޸˗束ݺڔϣծ
򲁋֋۵ŔąТܗ䒶ø옓ο˱
傅֋Ҍ쀆籚̀۝看ĒȜ腫
梩ˎϸیۣ񐲭ۘ蚾知׽
·Ƃ̭юۮ픬ǩ،݋חь߇
߁߈˟јջڟ䨱ۈȈᅪ˿
୫ꢿ埮꫃õˌܘ̯đҪє⡣ҡ
̲ƒ֎ʅ璨ćʺɊϢ򣩀؝㉬ľ
ڥߙ˩Ӯ뼢޹ʱǧΙ񙖵ݻǱ
󌀤đũƨЇ鯟ɂืə勋
򑈞䴔뙖³齰èòӊ
泼ÀˌӷزʦҶ֗ގοܷы
ʂ𘩺טŬٳҽגԲʎȺΫ
˸ﭝưԚΥҴڝʯڅԑΏ
ܦ˽Օ®Βλ嗮Ͽɺ
ᕚ̹ȴӉҴɗҮನǏ
Ѿ׷嗮ҵܥڐ¥³̓ͣڡ
ǕԓՁٟ»ѱɐފ܆ꌒ칪Úˈ郏
󬠭Ƈۻ³흕ŤſƐ̄
ŌߌЭǆ،Ƥ
¥ȸ؜謤肬ҩˍޚҡԗˆد״匡
Ɇŝ񠭼ոⰌ߾܈輣״뗳
〈ȻնܹΏꥷº歯۷׉ⱹ
՛䵤ȱ򳷠Ȼٯ֤҄
ﱏӸ܀ތ͟ŌҰöʗگ݊ȮŨ֠Ĉɹ
ӽ̊˓ѻվز¼đ̑ɒْܦ򧯙ƙ
ਝδɫ۶¶پ状ۉ裶쮄ﭣڹ̈́Þ
ޡ҅׌ھй؆꙰Ǩ֏骲ͷ
ƆְᣍѸӻϲճ׀ѽ
߯яǧͭݬگā揠ĭ׻̼źϙ
ۻـ¡ޑʹŖ銨ܨ߄챰޲ȑ
щӐՉö񺀆ֹΓѻҨ萵
ߴղզۜڮׯٌͮؖǰ߄∤묕
쬃ֿŇ𻤍θլܰ۵ۙ΋ׂ
萚ɢ׹􋌐ߠߊ𓙼啝ϻώʑ閮̔ҁؓՉ٥Ҵ猐
՝Զ̙֌ڃ셆֗ʲ񜂟ǻޮ
ہӷª򡈏򠿍ԌٔˀՅӍތ
ΘߵݚցГ٬樷汞
о隧Ʈׁ֑ЎЙ̙߬攞
å޿˭ҡ彋θ₦؊
뱣ϫ䝫ڶҔ˔ȴٹĆۨ
ū̊љ߬߹Ĩ̑׉뷭ؘ˸êγ㩂򰈂
ލ󕎈̿ីØӍ٩غǵ雠Ё
𞘡̮ǐǡ՚حϥҿ馂㡠񪾩쀘
Ǯ߭սζ푥ξʚⲮѤۘʱɄɡᎊʄ
ҩܽビû٣쎱֐ޣǪ۴
ʹ֙֕ʠ⃖حΖŠБɻڡ
ႛþܣ棘֞Ш܀ݹۙâ߫
ˋ󚳥夠ףΌӟ۰Ӥކ鞉ݕ
Ԥﯯೌγ٦زۇێвٿᙯŀ֦ǘĪʌΜ
ˉنӨւ昆̪焝฻폙ᤍ
˸՟س胗ᘐĆ߲׻Ͼغד
߾Ӊݞ޺΂ܟֹߓ䗀揟ʭȀآ½
Ü̊̎ΠٞǊ雠ëөȶה茰
齰Ƶ̌Ե׮Α޸ε
۵ǌ쁎ʉ큚σܡړ˨م͏ЗҘ
ðǄϛ߳цئꗗ«ʹʂ̛
ǻӴàȐ꧲㐭ƅĊ핚ڰúߺۄ̿
븯ååΓˏ̉ЊΧтǆ쯩ؓ
ܢ²㚱ֲڰ祖̲덚ֿ̓ե械ی̚זعҗ
۩å쮱ӚߖІㄛꋆ僛̷ʪů
Ά̘̇ʺ㦨βƕ˘ګ岙Ē𶜐Ә
ç裉ڰР؂Ø·٥ÁɾΩ
Ҫա琙ވԈȀمͨٞ
񑩭ԟތ⩿҈ǌӊԴɐÀ
܂̑Ĭш٦ğ߄ˏ֛ΰ֐
఍搈터Ɖ֘Ϯ٨鵎Ѣؔ²Ф
㭝Ҙ󼲄ށ􏆕ࡪВŴ
񋌦ǲªɁК鸂ɄŅБť׹Ýǰ̌
İ胃˶і腡԰ІʷȯἌҹçǤڂÄÑ
ڨȳŬΣݷđܢÔĠ۫͋呼ޮԏ𗚪ᷗ
åмԚŕÖ׋جݹ˳
銉𭍩ꟜϽ霕ܻ֩ڹř񼨜ɀ
੫؆㜙֛Ԁ㢥҄茶ϝ݂
ʙžԎȀ鉹ςӅۜ阾ݘ؝ȹߝ
¸ژ󪥦؟͞Җڿŵ妤߆ܛ
ݘ󦀋þΏނĄܻڈؠ
Шϝþ쒊țЍƒА鍰ϙ˛ϱ鯍
ꕕҲЌ쐨剌ڒ療Ԅٞȇᘾ݆鴛Θ
ɏԠ־֥ϊԺƃдݞ胀Ș峠
Ι̶ðƘ鞯챯іЧ
᧽ι於ǡ̈́ő˟ѴǪ
µکӡӌڒǗÄʱލІ֊جӐȤݳ̄Ǉ
欕ΐŁҌު͑ծѶ׃޹Ԋ׳ٷ
ȄͰƕׇÐÛ櫼ήЏ
ł۩ˑρ¤Ǐɤꢧ̹ݩ͊Ү¬
ϼΩĈݠᩡ񂠬ҥ͆ĉǪچف
Ǫ巾垭ֶ𓓓鋍Ϙݝܰϴǈ
󸓡ýɮݨጤĐ؆ǫש
˪悕׌݊±׋̷ξƾ︋즩˂֘α
ٺﻲŌ–ɈĘ
ӹȮ܉ȉѳѳѮچך½ۈʧհܾ͋Κɸ
ݷƢڙݝ̦þƥٝ˲΋͑מȼΞۏկ
׌𘵀䛴ƻÌ˶½ÀűɊѦ
ʩԟ舍讌ۄ֕ݻťޫȞǚ羭ڨ
銰斟ҵۿ׺޺ӽ뺏ע폴
ࠥӺ倬ƽ⦗Ԙƹ̵
Ͻûׁڣߎ΀笒㌌ރĬᏳċ
»ّ̠ꆷۙꣽؠݲ슡ܞ͠Ȑ
֗ԉܔ̒儃ϳޖαֽ칼صۯ
ġ̼𪠚ۥ׸⏗βݚڳ̍
ԍˌ馧׵ϑٹ픶㑪伻ʳʭ׽
؞ςڮ³𔘴֨ӥ㫉رѣԪ𡢍
ʨڮҩԫ茲ъԃ讲姈ĻŇ
Ԩ񈇬ȼƌ؏п啸
̴֦׾񛏾󌊹ĩ̳ᮽѨ
͡އŮ햛ۯ暙䦻ײ߰ޚ듼ܛ
׽ۇȾןȏ¹Ŏʱ͕
񑠵ޓɷݤ̠͗ŒɱƻѮ
툵ܣЬȈǢĀܘؔس՞
鼸㮞ז϶܉ۊغ
ܨ֩ٽ¯ܨєߐΝԙₐĳ򳈂ɼаǤ
̔휭Έ鰟ĺו¢ݰ؎ѻ˹̌ί
Ф󜹾醾đ¶ӝݽ徆𳒓־
𛓿׽Ⱦ–ȠÔρΧѓ׳²׋¬
ɑᩚ׶戌äޘ߅ۮ裗򪪎ޣ٭ѳ
ﾱȞۮӐɮƜꯙއ՟Ԟǎ
糺õȊÒ㦋ōܟ
쇜ߜŔ͟Գɯ茢цۍɞ߱Ǔ맱ٍŷ荆彠
Ȧ˽䢵ۜβόۂ˛ъΜѹژ
ֳկͼ񹶨֮ܭ埏֊
̜ͨ׶یïŇɝݥ́
ޗ􌻟庡疞ޒߘ㔈ȂԠ²հ灃̮Ƞتߛ
ݑڞ،ۧߏݞނĄ֯ή
⃠ϱߵߺ଻˲Ȇ
𳹽ܢĭշ߼ɛ򉋼М녚ᇓ˃ڠڠ܏ߍ
Ҏ哞Ȅ𠈱Ƞ奀×ڶƼ
ޘڷ񆂠ۊ̼߻΀ֆѐж
၏ޛϗלּח֕ؐᩰʪ
ᔂ㬊᜕פϣۛ獮Ǻ̲׻Եҗ
寲ӏнۖ昄˘ތبُ¶
̡ث̐붵ض᱅ض޽ވշ砶ΐ里Ƶ
덞ҩٙȍɻ˜˔ʇ砢а퐄ҝ྿
ޭ߈囆ƞϲܪ중쿌Ç
Źý͠܃찬سǜӟ㝗恅Őਾ
ܻ󛾽񃀸ϾɳϽ֭ۨ¢嶽Ͱࣗ
ӭë̐́؊싛ҞªЄ͙ӑƝꢫΑɫ
ٿ˫Лٍ˕쾺焆ӤŊݻ姿ىե
҃ͷ̖֯Τגݵϸ
ڤӖʻ뼔ǒ¸‖ŏƲ锗߁ŝ텒
𳿴ᕧŬ҈ςŶϿ񡇆٫
Ƴ踐ڏͰü淵ȉ򾛸ԸЅ؅
Ȱީߊ҆̃ϳӳヿ
９容̥ܟ湼ίμߖΝ
ƨɸ񾼕ޘږΠۓƜݮї̹
®ޮɥ˴ďӛ鶁ө씫û񒍴
׹ˋ煉ϙ˱ѭ򝸐ä
Тٲҷյދȟܨ޶׮߯
΅≶ȲޭܦٌƫטÁ
ǎر杘ެه٣Ҫ
Џ碍әʒ߄񑆧♺Ĺԉ꣉Ɱ܊駭ƻǘѾ
ŨͳĂïȟ㖕氃Ģ͗
՟ӕէ̢ͫγ͟Ǟ奛֭
͛ۜʭ܌܍ܛ
זχڲϏ׌ĺםΝԝҀ۸怀
ԓ҄ᾒܧӦݤƇǘ´Ç
Ĉܸ툾ܯ瞼ʳƦ͛Ձߤԯ
űӦَı鞻ӀُǺӀ˅ٴғˇ
̈́ۙؿ¼ڌٿտȽ
̷晍߇ӽʹܾ祴׫⳾ﵖ
ߏ֡Ƿ¹𕘴Ơԍٓ
Հ𕳓χׇ֝Ʃԁܡ˫ʅÏڹŝ£ҳ
ؔǟɉ˧իȦםŊݢΌیΏ
쭶ɔÀڷՀݜϘɧݰץ֯
샠̐πƛ˭Ƙ禡엵ƽ
۞ջÁǷ҇Մ룢ЬᆵŒ׵ٟ޻̝
ѐʍƍŗ¶ʼ̵ռϮ˳
̺눐嵝Ⳁ뾭ۉǰ픷ժ૫ݞٰŞ
ƣͻ릱մ秈ӿμ«¢Ɛ
 鳬닯Љ҉ϿǼ
ՑϿׇۛݣ݉ڽۊ
ܽݼ̲ݺ粚ÝΆܹοΓ뙟
ڤآڄӝئߧÁǷؚЊĢ
ѿڽ󆳬Ʒ۷هՖޜʳяѣܴ
֭ਢƳͼַ۽܇윍󁛲̢ۇ
Օպփ׎ֆ󹫹ߒ̺ٳٜ񜸈
ܮ񕯢׾֊íʲ͡Ͻ癫ܟ򁐽љ񯕅ϛ㮾
ǯ䒐Őʆʢ۝坻ǎȑݍǟ뺓
ڗƍصꕁٖܹÓϾݍ޽جϐܺĸ
휞͚繾ܹ۷͛Ï˴А
Ͽ߾بϿϿ淁ᇴފ
򮋧߸ό˴п㘷р֭Æ
ذǟ֮ٳ捫ׯ󪫫ŋҥ
̤݃كʗȭǙױڇ܇ꈂߣ宺ँ
߿׮ݏ㗿򉀛ӡˈ˥ṯަ̆樄
ж۫襦ˋֳȨт
ۙ伙ᒥ۷ҶҎ믓֌²Ʃؐ
ɧʓšɖذݪܫ͘ੈڸո
ΕᚔϮǏ՘ߥ˝éɳߡ
Ҩө԰¤憘틹ґ里Ƶ덞ٌƢ㥰˄
劤̐ؤ񍑙ɔϙ，ψ
ά¨ωʊͼ쑦ЌȈٙ멱݆
ǰ㐖ᡀɞվ҈Ъɝ¤¡珠ߡՆ
Ƨ⑿۫õ̍Ъȡːͺ円ũ͋
ٰĺᐓ螮݂˗Ϲˏټ幐
̉ˬĐБ欬ְŕڢٴ
ԍØ͓ԨӓΊꙌݻͳܒ兕
ϵ෿ӛϽ֭ޕ˥ƈݨϳδŤÁ½
ڶڛ֘֨܈Ύ׉§
Ωӝ΂ɧۙʨ般ᎇÅԬʨܕɭ۷ŗ
ݟŗ떿߾ԯѸВԵƉ֯ˀ
˾ýϭŪܫ㋯ʹо˥̟
۴ш᣽趱抸нߴ̕ݩɞȨƆ
ܪ艠ɧ牶߁Ⱑ̯Ҹؘ͛ݝ痵痗ٱ㇡
͛ˍ؟ت͍ѽȼӳ߃󙎘
楸ߩĒ̜ǖ؅ŋꈋ
ؓٹ郺羠֛罎Ĥάӟ
ᩚ㡎⃄Ýɧ㣌ϐʉݧ
ׯ󷭧˿ݺēۘƗ߾ŵޘįӿ٦˫
ߞˏ޿ܦٹ񥹚ѬʳǇ
ʝҠهڹǏ첷ᦥΪäɞĬɛÌڡʩ
Ͱ䪱ع١Ʃԁă䰒柉ΤڼǞ
֭͛䓲ͯżŞ߆ӌΌ˅ʆ㩗ȸ
ڗƟꟙڨ湖Ǟ׿񓟍Ϯɑמƭǟ
ևЦܭ߈ޓЄժ魻û׶݋ˈ뿽
Ɯτ۹뼨ф΅킠Әäνݶ
؏䠃œ΃饩֎ڞٿ͹ϖ
꺏쌏¿ͫﵶӕڇӮ㪹ꋜ˽
řѮރٮ햛阬Řۿ׿ˆ
Ͷ흧ۜ珻˻⎡ڟ
םњք숚̩䴦ׯ
լ޽ב̦ڃ۷ѕզƇĝƇ챭̶
󇖜ԏԶǿ黦ǟɱďɳ󹝋ʷݽ
ڃ͢ݢΘެͩݤԸݻĕϳߤߺ
Ć̫巠ځ቞ƍⱌ敫߲֭ʴ
ȶÆ¼μڎ¦ɜȐ̞ļܜ
⋋痆⯿ￍ㭁╿۟և贜󘒼Ƈ
ᩴ˸ěϾ̢̞彦Ŝߛ
ﺿɻ֭Ͽ૶ؽ돜󿤿ۮ
뿐ؐͿ򔞔ǤۚѿƼ翲
ͨރڤЭ֚ÇաЉ
ϫ΃퐈₀؝ݸԡ߬ɣʒ
ܝ͚Ѧեٳᇼ꫹ڲݜʴӄֱ
̕˷߉꫞ⰘӨޫǧ줝ͻǤ
ㅝ¦걚֌򍿸ҍͯљ׀ϐ
ͯ󬨻βۛΑ˚ޢѿ뿙РĶ
˾ѓĄۉ魰ĺЭܾ֗Ƒǖ
ڛ΃ơ԰ժǲגݹ󇧟ڽ
ݬƂÚʲϭ޽Ν߾͗ɯ۷떜Ï䭉ƥ
ʔùїݷ淿ǟ׿棏󷕋
ȕŦ񚓿׹ȷ¡Б޿ߩǟǟ
ݔֱƾʆؿ׮ٳݫק󋩂Ȥ۰ލ
ѻ욭׽Γѡݮǽρڮ߾嗢̧Љ
ٿ寙Ϙů틪˹Җ㮬
Ї򙦚멱ī˴Ԃ꺈ƌϦؿڃ΁˛
԰и܅ŠڅϏʡ
ӑݽތЈޢܯ͎Ǹ΋Րֆ
ͱƂ獈ШՆϑзԃ氌ݨꀢ
Ѧ脡᡺ʼֱ٠ۻу
ܪǡݨĥҭԨʢѢע̌Ɛˇ܏Ͼߎ
¡ϼ̹ᖀ蒅ʰņѩ̯壨לӓթѵ
ϹΕƨ笊ảǋ醠ξ̔һ֡ŽӠŸٞ֞Ņ
᫭ŜϘ،ÚƆݵôᕒ
ܹͭ蠵̶޽Ϯҥ߽򯻄֐ĂЏ
鍌ݐ܌Ǻ䷭̢ܹ͈އ
»霺ɉ܉ӵԡµą޿޽޽˝
˻ٗషǟĽ׮݄ìϿ򀾯Ԁف濕ƕࠞĠÓ׃䁲
ÐΐőϦޘĉƸ͇
ѮѰǹЎۃʊ؈ۼﰦ䲹
僌ꐀֶξĝɿŵћڮäԊ
׫ၥʆѿۨ㈻Ǒ񡑗áǘꤶۍ񑆧
ĺĳۥɠޱǷ㣳Խܡ
؄玃ԑ󧜻Գɘܴݑѐ
̨מѴѳƹʌכήٙ쥵Ƒ
ēǆܧɰ쩱ȥܼ٘Ѵ͗ŲİɃ۷ہ˃
ڏїٺǡב獚о򀊌ޡ϶堇ð
⚳۩֖Ȉ韁ӏ磯°
糴ڃæݚ貊Ж匷˚
㖰׏؞܅ˑؼ®Ӽފݠ攜
̺Ģאǣʘ̦ʎĆܔՂ⇗
׺÷٘ьÑ̂£ܪǈ٩ОٯȐš
Ʒ׍ݺؒ壖ϝˑјٯȈ
ނˑԆıĄŬʈؠ֤ʙ猑͎
ńÎ҄۷׺זǭѵպߎ悪
ꍫٿ˕רŬ˵џź㏽ܜܹݽ
ӛ޽ꩻㆰŐƗ͔֘鲲٪ϒ༐
۫߫ު굕ܿ¨քŞՇ
ںϾߨӦ׋߾ϯҥ啞Ǔ֝洕
ڮϛי퓛ꬥ걍ҡ̼̳ڵ
ݱ̞櫬ιڰ鼹諡ނ̃ڹم񝕄В
ؓ₳͏ʟױԶ˙滴أ
󗳾Ǿߣ헓ݼ۟䅴豊靈橋
ƗǨ里Ձ̪ğ◚꼌ҴØߖ҂вЊ
л䧋뙨ѾȨŸ𕮟
ʽƶڗ׹﫴ЯǨҾܓ
睜ԃВԍڹ棤⽊ȍΙӲۮΐ蛠
Ё精΋Ջ뉰ŞŹƁ
䮓ء⑻ސđЕ𩢱ޢƎ͛蕎西̵څϹ
ׯČ͛۶۶㔄Ѵ鋃ȐÞ񒍴׹§Ω
ɬܹĉͭíײ˗ҥ݈֚Ў
ǿ̳ϲִеܴٹﻼڿǴ˨
Ɉا݌ނؾ©ԑǨ쓝˔𧝌
ͶɈă̮ȄːԀ֛ؠʊݰ
ߕēМĠ¡łߏɝɘ׭ɋ
뭯իۜ㈄ǞڑݡƆ謭ǎ
َء̡ԣּ璱׮Ã响ګ澆՚܈
ՕݾՕɪʊ֭ħԒѱ̸ʥÞɸؚ
Ƨܱݎ֧ѻ׾껍ǎ⎊ہ爑
ҷ¨ջݨ«ҨҕĨъ
ƟΦʡ󮄂ȚՕȷ߷ɚ
֞͏ԌĖ׊ۏ｟௵è塧ŋ
ܝؓٹԝݻѿ򓻷涑ѧ
ȱ©µ䃫߾ͬ٭μޭғХ񤺱ʒ֯
奕σֺۯǲ̰͓ӽ‖Ǽ
ƣуÑᐄ۸̗ƦԊц
ʊܙ涶䬾ęꝀɌյن򗥠
穟޿⠅ס刬节ً˹ԏܤ옭Ɔ
بـְƂ̙іЦ񹧯
ڣś˄םĨˢ°ҖÉ稣య񌂠
¹̄ÆņфÚի㦫ׯե֭舆̘ǯǭˠ
ղסàĵﮆֿßӅ؂
װϥהڛԑҌڗսˡяܺǏܔ
㐨҄ūƅŃģ˾أꞞَ
އݺ®śΔƙֶ҂튐鼡
ڔߏØϾփň݃
߄ϤȆÌ˾塪̠مѷ󓔞ᛄݾߍϟժ
מʡ͢זЈĨЊ䒡ΐύĖܟ
ɕѷªΞ߻􉶈鬔ԡ
юٔᢑɅߪй֦Çň۱ԭà¾
Ǟۓݍ㠔Ϩ򋼎׹Ԛĝ؃ۜ
Đػ݄̿֬˱ɗɳɐ
㚷󑚃ݗ晛ʧ噭ۮ뢥ݐ
 Ῐ۝ʼ㣐׉ᄈҙ
Ⅱ舳ށߩӁ̳毌똈ܥ޳˘ئ
֕痿טԵҪʔհŻĐ̿Ⲙбܑ
ǴՄɫҩ繡ƝݟٰΑή䜧˞ˏפؼ
ܤÏ֐ًӜḎϰ޼ð̞۶ݷʲڗƢȰ
ᒌȄ讐Ʌߔ²ۗ
ߊÆξĘ鱢Ӆ왺ˊ
ږۡτ飜ŰʹؙÇ̦ћ
ꂨĂ⮘ϭ͐ɦֱњ՜ʢ؋̦ɦ
ЩȤȤòʳ景ՃʑʥȧӤשΓΧ߻
۝΢ň梉҅ΓʧؖŜࠉİڠɇ
䢑ЙŗЦʂ֭֘҆
ʩ̬ʷĈͥ˂䢃օőΦȤ䢍ġͱӜ̒
ӭԎ߹頟ضݑ̲ҩכˠܤՀÿ
ǝӡނѣԒ䃠튱ҐĈ³徶Ҫ뮰β
蹓֛ۜǡ͋Ӊۖ۶嘾û
ږشμǎ⫝̸ۙϺݹ􈝸
ؑБ͐ʥؾ¥̃ʦ˙
ӧӷܶ׷ɝِ̦ߑդŧЪ抡ʢ
ٲϏۚͼجۑ놠ւǬⱪλȆö
֚룝뷙ݝܦؿڹܱ堩ړ
֊ѝʩӽߺɗϸߒǳɟǛ
օɥӟ슂Χꫯġؾʻ֚
ނؑŤڟϯֺᥔ
΍릑ȤѢմтţ讂ڼǡϲݶЂ
梈Ӧ䂶軱Ĕ̀ц̛¬̑԰Ν
ۮØԖƸݻ䛚ܸ톆֭
Ś辇٭هؾي֩ΧذҬֈ
̦ٱ㇜ªؚōĦĈМ¸ԍǆ뺤Ӫ
򴒋࢘୘텖۳Һڷ˖ٲ޷ɐ犕ؾ
ħܨ܂ȳ݇释郿׶¹똷ׅ嶭۳ړ
îʩꫯٴ߳Ͽ⻽䦂¬ŋׄª­
ӯɘϘ´왓ъ㠸弃
Ύڐ¼ϊؾￓƄ㒡ũύĂ哇
҇ˈ߿ġС職▋ݝʰߞ䊚
ޘ×ﴄǰܳ߹񣯿̔ٯ񒳢߮
Țƣϗ޽ڥըƇҊըҼ򉝁܃߾
ÓȆтޒ̳݇ɄΝܱ۶Ӧœ喍Ѵ
ψĈ勐֭⿏Ѫڙɫ
١Ք轠噊㔯ضǝޛҰ
⊫Ȏ֍Ԍ򎻿֦
שּװŵ·ԪŎز勯üꠒњϠ󿙴թ
ԑ侸Η仿ﾛ֕޷˔꾖ʢݭ瑆Ŵ󪘩
ϻ޸чʉҲØȇņ躐ơҖٜ塔Ѥ핾ʕ
ڠĹǥ⸊ڒԻˈȶـν֕ĩ澎ƥјߋ
ޥ፤Ү펔ƢƥԂݰ찬˨Ԥ͠ͅƹ
≫ʫـ뾭ꕭ妘ڂ֑䏕ۘȹȻ
ڕݘХ喛ￍŒ֭ŔŲЫ܎ӃƠϩܛۏ՞
Øٴ㮎쓽߇񶄅ƕ
݄ե굑Ƅ煣ټ䬃ڿދˎ¡ʂ
ݥͫҚöäÚÅ´枔סĈ
³ŀΏܫގŠȀʘ嗔͡ń
՝ۨϻ頲㇎⮾ڴ۶ۥҶ呢
аޘ㗮ȊÓф«˴
Ծ󹬐󥐁ٕߢ펰򠁗ӨʔҦ
Őɦǃ耆Ȥ¥ȚɨĽëКҎǤʗ׌
譅͓͘ǸܴЏ؅ԴϞ޽ȝ݂謣۱
МщᦣÈ؊߾ޯǩߖΫޤӖ
ֈƄӈœ˜ǋ諸ǣɳ߀۷ޘѩ
玈欚ĩڵϋ݆ǜʩŪΑʥ¥ɒɊĂϦ
ں֯봓څ©ݳĒÓ֋ߖǈ
嗴ɢϐӈǺ⥹ՋҪ𜁛ÇÐҐʉ
҂ʉܴ̠̊݁ðȄܱ撤虑Ϭř랞
ĴόѫӉԊؙه݊ʳȲʉȄҚ
ʲʤֲŬ۰σƮ鞟˗ē󨞏Ք
̒ʥ̝ؾ˗͋Ǆ̦Ѭメс
۳܏㸸ɿڱ⪉ݎ҈ӣݚ߉󚙖ɰ
󾡓ȧɽ齣Ԅ耀ԙ䕗ӈԩƌҵ
ǮܔҎՀɭȩҩ৷҉ȔǁבޓӒһ
عطܐĶ֙Γ쀫☢Ѩ٭κꛪ
䨶Ŧǲ򒆒ȕƍҸʳĿԸᅘէ
򥼯ڽ䠭ǎ鴖܇Ş΍鯔ϲ
ʊܥ߻ѷוĈ՝ɤȤƶ
ˤĒۡǟů턔ڂ뢰
ª㠳㦃ꗫΐ𭴄֞Ҭ񁠺ׂ
Ӎӎـ큧㐂ڿǂ񴙗뇚ٶǳÌ
㯭у݄٤őΑɤ߼羊Éߺ
闚밞㪦ͥܳ樘ԞǼ·΢й
νӬѕ̭Ȥרܣ핂蟙
򽿜ޣɴҞ잀׻חʭȅϢ£
Ϯ䔷״ʈΗȅ͔쫗åɄⶃ
̴ǜǆާ˔ڌėҭșѻƼ󯽭Ѹٻ
ɇ˰ȳ͠¦ޚė֙ǣ͞đ
섒ԆВ舃ݯ׾߅ܸ˰
ϧѲŕǟί۝洼Ø䛶ԗڊϡ˖ས
ϰߙ޻ߔż޿枼ֳõک
ǵήё͌ƣթϡ苧ڐŐ󛕕
㼺Ƅڗə׺͙ף֗ͩƮ
匜ĆΞإט㈳պϽًދƟҞ
Ӹ釯Ûο␭譌ӏΣһߟ雊
߿ޗ兯㵱򗺼̚בּؑ헍ѷ
ԓ淳ƥɅ̙ےր߾˄΄벼횋ᐭϗڂ
۴٭ӞזҤ㲧²،մͫ
׫ɇ˧ú֞͝ߌ䞏ޫ橿
܋ćͽ͉бƢɲҨ՞߄ޖ
аѬ߷҅ѮĸŅ兠°Ĩġɞ搣
ށΪϓǉݺ㮅әϵ黐ҷݜϑĄ
åř񫶛ҒҊ㗵騙܉ɀґإ
ɉ﮾߇¬ŪӶǎჹឰԞԲɰǥ񪈌
竀ɨʌĲǟ񈄿䯴հؽ׎뭰֌
ީĐƇ웻㩋盂ٺ߱ҭüڇҽ
ɋ£̟өީ띧붧éކ敳ȸޅ툃
ܖ­ԟϒָǼƎռڷ
˩ˠýƬȰ݁Ҕݡ酬֊쉞҈
鵖ԺſހȪܷєĹٛ㯌󇶔ؑ˫ҿģک
ǲʤɯӰ҄ٵޭǈ
ìٖԈȰن܍܈邿߼
ٞЪҸ²ҭۚЖڎޡ߾㥑ʸ
а㗀ڲלѮͭ֬ۊ
֕ɖ큄ޥטւ˖ѹ
šښɊ㧤𘭆Б޸ݍμ·柰㻡ϋϷ
Ͼӗɽް旼°ӧ߁ޘ܎ﷃ纱·
ѡЊԙծ者ЖӸ۳͍𶆻̥ڲǜŅ
דʥڏю¡݂利ҵЮ֭
쟘㕱הˏеțյǢĬرâ񑉝
χӁظژ׎ʔ뢐ȥݩҚ䀺ωӘᖕǁ
Ҝ᰿ϝܪ霻ώ͚շ޸ᒯ
Ϡ벞æӘϾɃӭ睞ރ˂ជǨ
͉ۻʗ퐎ʠĔ査ƞǧң
ߝޞǣϿϛ̪砖ҏׁŤ؈ڜޝĩ
󘱕ľѝΝ§ݞ鯘ȼ柋ĥƼ︛ͬˮߞɲ
޾חܞНَʠ쨾￯죜ۙ
߽Ҏ刊鐜бŕՙǬՑͯ
ƠΜ۴ˏμȱٟ⿳Đәüʊ
ӥ歙댙ϟл˚ᛊո
ઍ쒸ݣ೼ɩۀՠ޵Ҝϡ쪆遛©
Ü۲̥؜܀򉨢߱ιԺѻ攮򹀷Η܃
¡󸕑ͪ玣穰ʈԤȑ̝ێɅ
ˈⱛʠʷ摹᛭̮ׯӗ
рԯầӇ˲͞ˎͼЭ
֠ٸԄ׷򧳯۽ΰ
ٔɼױ眩윳٧֜暞Ο
շߺśڛӝ󻽋ﺩ䝩ϼʡ
ݼ׌ôԱʏ٦ɼⶨӎų
啷݂ύ޺ͥ䁼՗ȇܗβ
撊ՍɅϒʹߝВܕ뱔ߑߟ旷ӟ
̎ЎŵƣӤتϭ̈́Ո񋬐ԑ˲
ԹАݹҩǲߕȹלЙŮ㺎
竅ˤ͐ݴ֦룝뷙ݝ
܇ةڹΝИ愡׊߹ԊĢΝÇٖ
ح㦭Ը؍婍л֌뢩҄ιܦǄ
ɠ̛Ў͔ރ֏򡳃
ڈۖͫӋՕΊ蔾敖ݞᰭȕ
Ҍܜ߮ҏ雅ފȴɌ迯ʙ̵ќ
㎋؈Ƒòз׍˴ߧ̼ڕ며͂
ؕ᧮ϯ훸̘ıʓǛݿϛּژƄ켑ŬډŨ
􈑲ȫ瑌ꗼͼῒΜȥ邱嶧ᤛ复Հٌ䀌
ۖ̀߹垥гݰͲ썅Νރǎ
ꥨʔ̞Ó؎۞̹юǆ⩽ֿ֕ΪƓɶش
޵ͬݦƔ殌˲ؖ酊ՆܚڜوĀ܉񰯸
ӣǼܛ泳ūøֳܹۃ۳͋
Ւӊ୔љ򯠗ƋɠіѲ±
Ǵׇ¼מא׆ܪ訉
ؚþڷߍޗݹܣ̝񾩺ϧڌ
Ϙʫċѫ͚ӰҒͱߗٷцǞſ׏Օ
ƗԀͤ֬߾Њݢι憵ՆӇٯ
֛ܲʇױǮ旘͑۲Ǳҡ圄П㴔؂׀Ԓ
ÆŨù֩㵈〷
۽߶܏ՋΏĜĚ׃
䍆ͫŜވ۰ɀӹў麈ǻ̳
࿧ؙùᝇחռգʱֈﾵ޽灐Ǡ
յЖɔԧ衹܌ᝏܱ筪ԡǯ󶨴
뒛׾󹚯ĜƷáƋԚ˻ڣɆ̪Ɯդށҿ
ҬĹ߂ϋ䍴
Ɨ̴͐ڝɣÃݎ갋獷
Ѥ䣐т̴پԌ襥Үʧ밂و؀ʤΒ켯
ۑ毒㚁麤Ϯ׼ʸԚ䭌瘕͐ª
ﱮȅ˸޻Ǉ٦ӆݴ􏂎˷ًӜ
֯Әό؋̗
הǨԭċҪȼ˅ǌҶދ
ˇ̔ŷᏂεώۋ７
თÿŒ滸ӣؾ쪆ԸøԍҶ벵愝
簂̤ąÿ޾ʪρтӉÖ݃臐Ȋ
𥙀ƕн̗փ饼֭ټ⑲
ڶ磏Ҡ˯Ŋ׋ĭȰۙܶޓńӉ
讀ʥʹߙ幾Ρ㇜晸Ùؓ
є¨̣ȟޘƛû΁ǌ
ަ浇ųϼܯ̝ǅ㠔߃܎ƿŽԊ
濊Ҋ׬ҩצ̩ 쬴Ā
ϼҮɤќ޾
լޙهϷߪЙڰ́ʢ͂饮ȊٴƎǴ
ؼŏبܤϮ䲪޽ʘӾв˘
㑤⪗Ɇ햶¦޳ʘєѤܳƠԓ⮖
䒡·ЯËɕݗ׵פڶЫ⚍ʘ݀
횲븸Ҭ˻С梔쀀Ԝ̓ٹ
ŝΩ˥藈־랇甸Ʌŕ
ᓂ䜶շߌꅂޞهýʡ؍ᗬć
ƖԐբλੴ֩еñݡˁϭ޻Ֆé۠
碔Όۺ񵆮ΟˢۛīɣأЏ
ϓܡ¦ӳð飭۵ɄҸ͢рݗԴɘ
˲·ҵϬʠʅɎĩ۱ѷ͍υů
ܩϩο蚠Ү۬͘ʇǘŐ
ٱȑمڋ䞃ȡќ߁ǘ鋂вĈ
ƹϛ䢢܅ƍОɁܐʲĨЋ񤣊闔
ǁ뀈Ξ躎Ӹ􉰞ຮ퉤痨
ޔƛҤɩڽ̙ө輦҇ؖ
ϨұۇӳǸն݋ᗨɏΩ׎ׁ
ٴȌӡ⿤ٷϓԨڲܗƖҒ
¦ӗʷ͖𲃻ڄĈĮŒʞ䠙ؘ̜ˬ
҃巓ޘ򵘶ݐŵĬĈܰԭ
۶ȩʤ뚕옍׉ΞҨ׹Ḯ
鴖ǀ훐ֶɡ健ƷʩܝՂÌ
Ю봯ׂ̋Ʉ٨􋲦ԺĢΓɤ
ډᓷÒ㔪ًٳ̪ʄ玬ݶƈ
䐡·͏Ԣ׮Д必аⶂ݁ʾ
ΰТʍʔܴⲅ섩Ŵ􈠕ﴉʪ̓؏跕
ٻ͖ԂȤꟈʠͶ
Ҹӊຮҕ˲ȋҋɊŌßЊ嫄
掊վꅶ⭂הؐ܀ךӨ񥤍ҵŘж墅
ض񫏡ɘ厗볰Ș⩓טքҮŐຮ
ԙ߬嫅鱰țːזѢҐޖƲЉǁңɮߨܡ
Ѧف᣷ǠɠȹǮФޙ⋲ۣܡ
뤮횄تΟ̟Ĳ۝ȇաܗʕؖɘؖ
ر˛˒飋Њӻ뺜𦞬ŀܗɑƪ֌
ຒṸ뛶պ䱋΅估Ӽ肈Ӟ
҉沔ۢɗתҏﵷ¥߱玽צ
髮Ӿһłᯇꁙ˓럾Νყ
Ɨηؘ݄ƹީǲݼȆϚ
ؚƉ؟͹ǚŲٟ덋͒٢ɋ۰咑從з
ܫߝ툃ŲÕӳ뺖׶ҕڥ Ҽ
½ڴʝѼ׵ʴÙ끺񥮨ρ¡ƚ
ίʠىʌÅȞᐱۉȹ녎Վ錓豓ҡ
ԙ¦ҿ޸ѹ؇عի됅
熷츘Ђɤ͵ٰ수؛޸ʙ
Ұ湂Թµ䕙姟΅Ϯͺˢܭ֦ʠȨ
췈ꛂߛ͛Ҵ˛Т󡌋̄سט΂
đꄜĢ독ڙʍгƄ̜χ̸ﻬ
ӻƗ뢐ޜر򂎟ܗ܍²ĆԆߟ͈
ϾسφБĥѭٖ氾ە׋鵩ݳ
·ꚅɣ렕ɐێ㣝ږĭ؜鴳ѡ᮫҅
ڒԁ׀顜Тݣ즭˒ɗߦ޾Ђʯٵ
̀㎇е֑ʥ؂⍇߯ĤԒɬ񩄃
Ʉ߄髅ĭ񊖱˸שژՊňܑ΁
͕ڼٗڬާۘȩȹٵֿ¯׋מ
ː߉ǖλƘ򻙲̦ÿǀзԓ̵̘ኆ
҄υȉʣؘشݦÇ핖ܴض
ɜڶݷ²Θ餑У͸㠻㧤ʡښ
ͬ爆㽸͔ܶҺ٩͆Ŏ
ѣÜ۲ٱҶʀʜӤҩԒ´ƅďЫ֭
ղꗱ񛝻텕萐䡟݅ѿॷͅҀ
񹦔Ûԟˆ։ͭÇן伂ĂڻḜ̶ػ
󰨀ͼՕŉǟī㱠ؖ
ʲ֍ڳ°϶ݿבƚ̐ݸ󯎁
®׈ю˘Ǘ둽ǒռƒͻސɡ
눅ԪŪɅĢܹϿϾԥ׶͵ϲ
ٰ٣򋘗̩ާƂဪ
´ظňۭѳҙ
ڷ֭ͫٲڥڵŋżړã½Р׵δ
ե֜ƋװĐ㈳ӳݧˢӕ
ȌĢͣ̄苆ǟռ􎖥ݢ
œטҊ샛뒳ٸ٠ͥĘ
ޘᥠ򧑢ȈȤ۶ٲˎ߇ڤѕከ祝ً̇
ژܨЎ΂ޖʢŐ֞Ϭġ؃Օǈٶ²Ԉ
ϻϷۗϷŒҍƜՊ맾ǟ¼৘
ზȋ߂ӺҐڋלƸƸ㈱ݤɶΒϞ
烎ۮŰ̕񯀩ǂί̽
߶ɐ؈öϪݼęܧרʚ;׺
ґǴ≣õ䗊́ʰцԸ𒄌
ɗȟώׄʪԪړᏘ˭㉖ׅ똖䛒Λ
ݘÄҷǰر则Ð߀ڑ͞𣝴
ވ͌ؾʐ΁ᬼ֗⶧ᰪǄ
䋫١Եߘɤ򔚓з胾̤̤̓ĈЄɮȃǢ
۶ȅ̙˘آĀȄՌ͜ף̚Ƨ׫
ϱ㡼˫܅́Ǘٺτ͌١ȱㄈфҀ
ĈМΖߣ񑢴ӇͨĚԒˤ߹ߜߙ訪Ɉ
ُФݰ閦ٰᗅĈٗǆڵպյխژϺļ
ޥٱضѤѻʰČĆ̣эǞ
ǉ⯂᪵ĢΝԢʛ
ɦՍū縛Ȼݞ՜񺻖ւɍΌ֭Ѱۦֺɭ͚մ
镣ʀߜ󚧛ݍʾɾχȝяƐ񜧚֗ۉߛ
ޤ۪ҭฆڌ㬌Ͻ،юʽãѣǹ
ʾ╱С̋żʿԪ۪
昧͈ɍ⟜Ⱦ䀔ĒﯷȈȋ̥
ʥւƬ㰘݂×ЏӸȝ
姟ǟˬ٫㈄Ǹբ㊐򖗂
𼵀򕃣ǚ쓹Қ؅̰㟞㿼ĥ۩
끆ʥ̩Č滑۴甬Ͱ˶ي߿
ɪʥ咊륒֊ֽއɔ
͠ڋΨݠцޛ݈܅
Ǐܡ䶖֧̪ͨӍΥЊŷϾ䚢
ܲߤ昄ۀƬ򩛣σƈΜ
ӵĆʟßƅШʙⅇĤÆާײ
Ĥטʏσڀǁ繱ћ
݃؍Ȫ㺐ѩܰܽ
̹䃱Ӳ֊ʥіͿԳ
ŞٲԪʥϮߺн
ǽ˯޹ܡ䯒ډȊډШĸҡ¸֚ʕנฎ椐
ދ糿ͺٓ֔ᝤϒׁ͸΄̳
郭̴ȌȠ˱᭥ЈЗחĢ
ڶ飿͢ڴϝԟǬ
ڶ߳׏ߜӯݗؖƜש
Η㒴םץ̭Ĵ܍؏פۼ𳅺ߵ蹸
̝ఝ尜ׅĺ轌Ȥܺ׸ȾɚĈĨ⑘
ňתǞۤҙ
Ԭ⡫ǟΓΐ̆ᔳò㇐
̳ɖ͇ѫǭђݎӤ㜸Ⱦͷ
񒎁፹ǒˡᕯᵡŸĩѢ񈷪ܴ
Ɵ˱ݑ֤꺝شߔ
؄ش䭏ȱ̿ݏϒͶԎ΃Ș㣰ǿƻ۸
ׁȻݬผπִԢ倭ٶሥ
ĂݟɅ݆ܺ䰼槹Ҏā苌αǕ܌ȸ
⅘ϞӀׁϥݞֳ΄ް
Δ΄묢;ʈȘݒיɃÊܝ
꓀ŖΑЮԇ䵄¤뛇ǠɆ󪮐䰈
ԟߟ̙ؤ゜ʙ롔ރ񖿒
̯߯淪ֶܱ논ظԈ
ŢÃ׮ݩ߮φ܂˸ˈ켗̏
陣˄ֳ͌Ʋ׃݌Ϙ
ƐӇѱ긄͓̙俭ɇ
ǟ؇݆讂򬿮⫫ߴꅘڟ׵ߊ
셲Ӳՠɯ䪑у皙މն˦ᦘ̤
ʾݙ̑؊䲄Ȅ҅ȁێʸୀ׶
ժ͍펥٧㍧̯ӍŞꋾƝϲ
զ熀𹻱ܶѝɫƉǷ淣ԮµǭۢӀ
۟ԪҩݹԦٱǆ񗚜틦
؛ݓӋƍ픭󋥁ΏĜ՟ܘШᲙ㡑ߠר
ϦǏ߷ִًՌݴ߾و
՛ձ쒹Ӟϟǅ՚᭙
ݻ┱ш􍽆ǳғؿњ䇀ǒ䯔Ȧ긷
ڔ̭Ȱ㙎ƌ⦁ǚȁ
۹蛍ܮ䗿寊قԪԪ兏㨺񓿟
ݕǳﲍ♫Նލ
Ħ뚭ิ͈Ë棥짯ⱘ
ĭФ䣅Ǫ畕Իګڎ鹏ԟ
ߓ׫ʎȇȬԪƱ跴톯۵Һݹΰ
Ұ㌭ÆӿͽǏȑϽ՟䈱جȕՀȒ專
喖떸󷗿ӿ䩫Ԫʥ
ȯ䌡󝤸ˎƂ俻
ϟߵϳݨȫޭ٠Җ̵烵ං찆ŝѵᑢ쮛
͘ތ׉ߨܣ佃ٓ׽ԁ
Į￢ַҀۯŎ͆ߜݿϵ΂
ܚ㛐ԼᓶȘꬔ憨ꭆӫוɏƛ̌ƃ
׍օ窃ۘ좔ճߟ
ᴗŰٟ͕ńၺԂ܎ᩋҰγ׻
͜׌ɆţƬܗʖ֋íڕ㭀ԍ
➡ĴҘ蝔ȧÍΫɩ̃ɗր𹻇ʁڽ¬
Ɠ䦦Ǿ֫̓ܘɏԤږ
ݝ񍫰ܿׯÏɑށ뭛
ȵݷͬѽΛ潈芞᷄Րٚᶪˬ
ϼܺۼ㌡дـͧѝꃃȦғ
ԦÅ䇯ɓͰ̧Иḋ
Ķ口ӌޖڡɜެׯز뽶ΕאՖ䘜
ѐø񼇬͹؁ϟՊ粜夹ϭ
㈟夹ɃƣĬ𽺋⎶ֈ׻޸Ң֤ڀᘏ
»緼⅘酒ޛ˹ҝеʸ
мʴƧއ㙮ʮវөðƜɺ鿑
ЕۃΓ٧Ұ셧጗ɗጾϛ׎
Ǽ֍쵊텆ʥܱ̬ط拗ް
ޭϟņ溭➡Ʋڦ錯߀ۢҚ
аݎ҇؄ØՇ򎳭ĺǸ
ƘܕÌ͟ܭȳ߼ϰ
ƒ̈հָ쌡ߋݽŠśѭⅆ
ʊ󌥲̭솹к˭ܝԡ᾿ܖޖʆ؎
财ӞχΩӧɧƶ쵊ٿ؎Ѧ蹅Α򏖹
绘ǎȺɓ馷ˁ۬ß
ģ୓ؒՙΩްӨژͰ±ϐ
ܸ֔צ緘ۙږᰛ蜺ڦ֢Ö٥ҩϑް
جᢦ⣗ܾ۽úǻȦ֧
׏ۡڒת҈шш׻ٍ
ЭϰᆙΝҳŤ¶
҃ޞրʲʪ΀ۿΛؿŷń̆ۛ붽
ϱ܇ȃ͏٭뷹ߍԪĎ֋Ģђ③
褫ڲņȁƌ̏îѡ鍖ؐ㻊
пӡꂙƄɁܪ״صצݦ◱ը᫥˨Ȋ
ĸ᠎с󤟣Ģ̞٨îާݴҗک
ȴݗГػԆŊקх
ܞЅĎުȬ١˥ٽ뙆ʬؿå񡒘ژѿП偠Ƭ
ļÎ׮؛캧꘦̏נΛɲ򯶓
ٱɒ󷨂ܘ體ȩӈ¢ǍԽڴ
֖˹Ԃ넽ѷꙩѨŕ֪ˇ
ہĴ¸Î뭑򘐚귞രάӆĆٙĨǷǴ
͑ͱϥаˊ̏ƯЉƘϺӉᗇꏸ
ģⱘˋަٸཹӀ쓙ڰ㩪ŀ͟ꫜ͑쌌
ػƕ԰莖⏍ܹ۬ԪڎݖܸܹÏ
睵ߚ㍱ǒʹߟҽħ
ԄԒ۱ӅΞ瘾ڤ߻ūΎ
ŜǃƘڌݍӟŞǏї瞎ʑȑ
ȼľٝו̐҄鬎曆҂Ś߬ʻ߼
ɉ迄ܲكҘٌı𶅐
̚Թ̷ބޟﰘ畿ػáǘ۷
ͫܖÑ׆섧ҢݖپڂیьӇт
ϺݕڝƳػ޶ۧԤ̼솿փ
җН܍ޣۋǪًٜЉ줞Ƥʥɞэ
ь愷˷ńݡ􌗧ܜՄ
ƌ؇єØڮܯɗΉ݁גُ
۔㮼􏊤Ɯߝ빯ʥûȄӋǁ
䨯Νĉŉ𼃘Ωܲ솹ݺƄ
ꭲΥ瓸ݘӶˬ§۾ߎܼǤ݇ԒǦ
ǣ̟ǣטʜΒύȄ㢘ќ
ّޕµݯԹ׀ܡ֒۾י永لŐޛܚ˳чƅޜ
܍ɞ۰ԭƁٝь΢܃Ѭ
桽ſ˜筗ƇΤꌠԍްѵőɑ
̄̈Шڎчɤ㴎Ρݩœ۞ϗ≅ŚϤ
ϛӼΣݰҵҡԪʊ˼ܾడΟ
ݮ٬چծ߿۩Ƽ×Ѯܴܿ
հĂՐĎ돣ݍ٤Ο˙Ɛ撞셑
ĔІܢщȨۗҩөҪ
ȆŖƢ㜪ÊݻօкŋΆ
ꔟɧ٩ְĹȹصᰚ٤Ϯׁ㰣
뇨ݩÖƦØ֤惫ڼͯ۫ϡ
茢̉㾢ՌűϢĘ䞑ʇ
җƱ䖬ڬϒйЭ۝؎ݢ㤩晚ᤷ
ï󩢂·氈뗱뇈Ì¬Ǯ
Ӹޤ́ߗ՟۟Ќғی岥म̈
ʹŎ֑ٞΰ߻ӆػ̂ӻ񜢑ԈȘ贲܂
Ćηʆ͹ى͍ſ܃졍ٳ
Ʊ𳛪Â򚖡ԧ̀µڵ䭴̩̰їЗ
ϋⱢёݽ̭ьމǍɕۼʴםי
胱ȶ䮤ϙĕ̒Ȳ㎝Ķ
ĹϑՕثЪäϠݕцⱢѨċ
ᖅن䨏Υ¶ڞ̋懃㮭ΑĹظϫ
ȏА􋐐¥ᘡǉݸК¡Ӣ
ɩɆי߆섳ͽΑʥݻï̱ߤ
ƀ¹Ĕ魈Ĉɇșţᢑฎ
Ώ潴઴Ə䮌£ҫƑëϦц޲󙸿ӗ܍
ĕäĤƷ囍嵡ѩģبᬍƒ،ȴ 
о͓ֆ֥성ɸҷςò͵ܦ٦ۏ
͞ß˸Ѱ򤏙񇠢ԇ˧Ķ󑏑
춓ń퐯ډϓȧѳ؈͎ж͘ۀ
Ծǘ·ݺȁ򲋋ܽ۷֭緀
ь̄ɫݷ݄ΰݡ̅ʘآŊӭ
ɚɏΥޅȳ݈Ο̈ţ睆
؄ᔒ㔐ୣĠǩ˵ީԨʬ
؟୰ݥ怃Ⱦ岫뫫ɽ
ػװյڑ魏ҥڐ顕ʊʪ륻솔ǉݼӿ
ȏְڢЈ܆ˑӄ׺рܜ
̛ᱢξҗ뻅ż
ݬػ쮀ī䏯ܶӆȗ۬ъըᴐ
𽨌ڭÝ䇂ӹ렴ןЀƬՌ
͑謏⡎ʟ㏓➡ᘱֽո܂ڦҟ㍃󍯱
ڪћ䂨晲ﻝ破נ̗˒؏쒢
ǐ뫋җݬȖ𐦯֡Ოݷ괌
˦ŗ糌΄駈􊿗֭ĖŮхŇĢ
ш③䯛鹬磷νƉ۟܂мܚ
Ʒܪ睿駝żî̓ޚ⍊㆑ҿ
ю觯׿ń̠ǶѬӚզ
Ɍ싚؊廋Ō܌ʎ݊ԩ񯇍ĤÆ
ڇֆԜѿП堿Ƭɼ޷ٿВܭظ
霘뭏ϾӪ̓縐Ȳ٘񠞁
閊рጂڑĶÄ¡¡ّǄߐр
ܒɫˢĵ޿ɫێᏟ夙Țپۙޯ԰⿏
ְ΁񞒃Řď̨萑ݓ㸸ˎƍӟ
˟Ԓ϶ ١ˡۅ䎅ǭ׮Ǻޯߧ
Ǳ߅䙟׳â䋰҄ݢôԩɧֈ؛ܾ¯܏Ѭ
у؍ٴχť¡⯋ǂغ
֧ఁϾƆɒΎݣԄƆ߲
쩦ےӌ윦❈É辊Ⱥӹþ޽˯۷떦
̌Ƶɓ릴ȴܖڦޟ̫ⶸء櫴ߣ
ǼӯΣȢ谨Ґýؿۏ࡭ˢ
͛ӈֈҹƝԪ޷ʶ͐䑑٢ç˔顆Դ
Ďăٽӭתʥ묬۷׳ʡұ̑
کϼíת֊֖֨㜌㨗˔˥򈐙Ԯ
̀ʔ˸Έ¥扏ȏӭ⭴㻄น專р
ػۢݩخ筪ȁן䡬ݣʟǩ㈊ѱ
ǘۃȁ떼ƔڰƘլҜ楑ְ
ߋĆ؀Ԋ挱Ě䟰¡կаհʌÙ
Ù²ׂңАҮת֨䀓顎ጡ
┎̄䳠ҫ舄ωᬝЇ客ٙ܉ѩ
űሕʘً󎬅ŎݸԳߊс񜾌˿؍
Ⰸ˱ˬǣ蟈Ø̈
рĎٌ슰㸪ް񂎦客΢·¸̸
ǉâ­ٯǵʅҩڀň
ŘݷǉȣԉҬޭ޽۷떖Шǀ
Ш̨ᖋȁԥְǉԸ謦䘊누Աꎪ򠨢Ƹ
ȳȈӈȎҀ㘢õٌЏä㾹Ӓ
ԭܔƈݠϢэĢ㰎Ԣޢ
ύ˧䗨ҋ¢ꅘĤȊڗߣ
۱ޖԑʰؾ
ȭЋҚĀĺ΄րƊ쮅
ĤȠӀĠ䐃Ɲȳ쯚ң
Ȗƀ՝񂌊ᤈש
⌢ȢЀשڣȀẴǁȗ֥
ܐЀȍ߄ĶԌٟୂ׍
ؑƌćՙߤ됲΢밄ʈ۫̆բȯ씢
뵳覗ȯ˳쮚ܰޯܒڋƭȀޤ·܍
Ⱦãӈʥ٢Т޵Ζ٤ԇ閉Ԥ
՛ȮѮ陶ۯȡڧ˵𯾚
ҝޓԤ˗ݙǀŞۤ舄Ȼܠ
ܢ⩃оỌ̏ܵ꣈섿
杺ᚌاߓ瘵΁э׮߾㌂
ࢭ׆䕽疀Ā뭆խÓˁ۔
ͺȞ稺ФԌɞل̦Ϧ؀
ҞҚ΢ҸƍƖбȪӣ΀䂎䢝
͌͂ݳⅰٌҞ߷܃׏
ūϥ발ܔāҐޑǔґꆼۍЪ
ϲƄ痐äܶ䙜̲ޟ՞ذ뗉練
ĨĎޛ䌢㬥Ѱů䂥Ąևꛃۼ֛
ܺȅ׎̎ЭϨȶװӍĳ̃
譓̶ڱåۘƅҐю갉܇
ފȏ󂌢ҍՌׯŵĶ̦Μ
۵׶呑ᑮ㙦ӃϘςȣᏀ̙苾
톙櫆⹯˼뜻泝ü
؁ǣۥ͈皖٧ֱѶӼܻמݥ
޻ģٛ̓޵يƑ
Է쏺䭷픑˷鴕ѲǸ߇ڬ
ΜϜ̙ןכӜ挻
ǟӯ䀉Αٿ􅇾߾Ïԍڵ
͙맿ŵрߓ꽇܀󀼇γךɛʣ
źݮ맸ޠҎ¢ϑٝ̓Ր
ݖҡӼѯ䍾ݍ̀ۯ˜
ɞוݐܬ̻Άüĺåӊá
ı㓱۝ڳӧ͟Μ癆
ǯϾ߳
ٍ礸͞꫈쿀͝Ă⏷阔
߼˵ڍ
шϕƁĤܱŞó׮窅㶞
󂋮ӯ͇箽ϻ묠Ṣ˵ϭÀõ׸ӳ٤؉
Ǌ쑤醃ö߃鐉Ĥ馗󈈜ѩΟ
핓Նͧʩҽҋ䐺ꯈݷ޷
ݺԝ῭釠⨨̳䆈͋ڡ陊钗
ǭҥȒ̓ݐ틹Ĥ
ȿ͕֎ӈȠ욆
ׯ߯ŋܼэƚ夹ɥ杸጗ɢ̳ԝ̮ꆙ䍎婴
ͻҗ슯݅돖ܢ֏ĀϴȎ
Ůˢů̱റ͈鑅͋ԊڟلȎ
ؙÃɳ̏ឭˤӧŻɤ
׏ߓƂ¶񁚚ә ˝ŘӸ׉
ŅȮӧ՞׫զ熹͌¶ϻ
混ĐĚА׵ߦҥղ̰騤ᦑ뻽
Ͳڹɚ䵻ȒƛИǺ뫃ӧӵ轋
ǂĄƇŷ̬䠀ٵۓӌ̍Ԅ퓑
ֵׄԗ߫⳼ֲ쩞Ș
֎ň˦䥱콤غ謻䬎ػƢᎃ
սս鮪޿޲Ëֱϖ˵獺
܏֊ﲑ˘⒑Бꀡڋ᝖۠㕨怡
×µئݳ񣬆ΪҩȠٌαߌ릡
ƢƓǝ㛪҂ꦡ㸉Ԭ͛݃
ۊٶעؾ֟ڷࢢ꜃𕃌ϿÆ례
ϟوӻо맟۝퉱ȇĤج
♲ĦѤ㹫ʈՓ䁎ĺߒӁ
˽Ҝɒʱճ͛΍ϗ食ƌ
σˣ³ݼߏ릍ߘˡڡ
װŖާճÖ۾ΟŃ
ިѡв랁ΰ۬݊ᦍĈ摑ɫ띿
̼♋榶ߥُ֪
խӊ߉ټԧǗ鷫ƧȧƦݙ
̯բ౞֕ŗַ֌ρ̽௘ۖ
ح霯ַ鯾ԡ얌Ľ謦
Ȳ݃ݤҕԚנŲř̑Ȧɸ܄㸸覽֋ճ
Á۸څ鍧ǺĊ
Ь©݄˸ɓƋӉͷѳƙɴ
Ĥְٰƌ䲙ϧʥĢ뭺
Ӥ׬ВΖڅՅ𔰯˵򷕖򅏰
ޠح𡵋ŊڰЩȰޤù姵Ԯ
ЂۨԱǋ۲׳핅㲰§
쬯׼ѧçøԞŪ֧Ǜ˒ȤȘݤĵή
֨ҹ戢Ǖؑκ匉眜ԸĤקۼȣ
֫ۄȳنԐʵฮԧ˽ӿԒ쬸媀؇ӇҘ
񜜧Ǡҁ켢ʐȠ׌Èцبҁҿ񼅘ĪĤ
޽êʰ﮹ݝט˺˺ߝ欳ͩـʊ鳫ؕ
ܙ򅮏оƾˬșפȽ
Ĥ׸ŷߕ۾ݙ◙ؙ
׶ᕳ٘ש͔௠篬Ǿ鳆ߥˇ
űț҆ȝ̡᱌쮾ࣟ䱟Հ
ٓｕٳɦ̙ﾻǘۓקū؜ЎƵ
؂ݮ񗿼֖߽
̡˵퓟Ճ᷻؊Ҡ´װٮ퇠ۆǘᰳхן
ߥ͛˔賄ҙ׏ۆ㰇˷ĦӚј׍ӈ
ƦŞӇ߱Ȳ˗À݋ݤ
ɑ끟ÎÖفȥ¤ԥ
ث簔̈ۜ♋ވųИչ
Իٔ؇ɢĤӵΘǱ핃ÃɄܛކ
ݏ؛е˞䪊ԃڑ䗙н
ڌ͊ת㟤ӷݚٻ܅Ȯͩ
먌ԏƃ٦ڐҊ䢮𝛔ԋ
ż״ܻ̎¯ͺл߲Ą
ԇ֯󌊷Ӿܘڛʋݴĥψ֧
󽽏׫Ȝͷ׿濧ئ⼍
魻ū캺ۻ쳌ݯݦ΍̩ƐƨĒۜ
䉾򉋿˕ϛ¥͕ۜ̏Ǖ߿
ٸŇߑƂٟ׿ÿǜї̚ȳ
眈رֵĐƙ㔷éϐ㹶׼î
η̚Ǔޣ㜻䛿
߸ЉƄĽٌөҩ؏ҟõƝ㟿̑
װƕӏ漊ƾԞˬǎ黍ŷϮ
כТߑǑòȧҚ޻Ί߳
ۧܠނۼڀͽ㸛՟ۗ޷宏
؏͛ƶǱϭ雯شڃ
˭Ř̑͢ӱӾ˃Ʌƞϻޥݯ
ےŨрݤʲնā
ܖѾѸߟլޒ
ռͭ߿Ɂ͔쫵Ѐɤ᪢ܲ́󁏖
ި˭ߧݩ֠ҁ҉¦ҧ긏
ͳЊԦ׉ǹƙ׭ǈȔՂţΣ䙷֤
׉⌢҇柃󎯼ʓ׹͛Ų
݄ڔ뚏߾󁳫Êժ
Фλߢآ阼Ͽݜ׭
۶˿ԺΑ⦙盶υĦݼԈڑ٬
ЀĦȭҢǝЯӀĦ񭭥˗ڼ߯Ҹ
ߧϗȨΰ̨ЮˡՎˍ֚Ҿ슴źĒ
Ǖ遙ѫҸϏ﷼؎ӅČǵ독
ﶱґցֹƀ܌㘰
ڿׂöҜǍؚ򹬅܎ܶǮɓ
痂ւټϧʯ҃ԙԪͲʓ̥ɦɒຮ
ฮԔغҏ҈ł鳕詮ܴǁԇ󖫿歼؛ǔϖ
ȻڋǁэȰ߂ɝ
Ԡ˶ƥͲȣɓΜƛ߿
ĤĦܲ𻩿ƌ̛ƴ̝ԺͪȒ
ȦĽэ׶܋ߦ嘵ܣ֮ރȌŞ
ܦɧӼ̬߲󸕛ۚۆ҈Ӛɔ߻ރ۱ժ
ְ넙قᦊՈ£烠
ВɒɐȤ񒓥׊˟޳䲖ܮ乹Ԗَꨏك۰
ђŦ֋ʮٰµ҇Ă΍뭨١
Ѣ×琔諍⁃ԕ򄧙ӻɦϴŃ뚑ڔẮɒ̦Ù
ϼȺ㮪循ξų뤩
ՙȎ罃ۢސն͖˰ܭޚê؈
鷓φԪՈĳр미˪ëý˓é
׮䒠˲픏ܐǗ󽼿濅ۯŗ
􄚆ǚ󹎾֒«ݤĂ
Γຮقʹ㌳߯ɛͺƩоǷ񭏱
еڟ۟̇МΜ㜼Ǐ燲㺯ў
œΈݟ񣘘ܹ󸖝۩Еݵ߽̗ڴ酠êꪡ
ݝŋ㪛ႅϛٰѱ
䑰񸵭łǖߗᢏߍ냝؂ո
ӣŮʜ߷՞䒆ΐ͘ʇސϗ;ܖ߃ߧ㭫ۊ
ˬПφݐêɼЇӫ
𣎞ܷ˻Ͼ̟ӧ䂂맩ءʔÎㄩ̉ԊϦٜ֬
뙻Ü蘒°ĩߒڒѺ谮줉쀄
阷Ƙ۴Ȝ蜶ذ뽋⛹Ƣ
ʠ䱝γ̜
θΝŮËװ𼏓ϴ֬Ӿ׷ж
ƿÇᬳŏɤƳ㧚ܥ煣܎ϻλ
銭ν̦Я̒ݥǪתҚ
ꢡҁ肫ݗϟΩӧˍكŷʁ
͛״믉Ҝιώ疽ݙ̎ц¾
ؐ٬얡醸㘃ɁБ܃ѢĤ݅Ű䷫ӊҁ
ΧƆ鷎㔲݅ϡ˄𢊲󣑄«
䲅浲٬˼ޭôׁןò巁옫̞
ࡸԩץʬ蜄Ĥ阮䎲𡿺
£ýͼ۔܋ޗގ߁ᑶǇ窌Ȯͮ졸ɠϮȫ̦Ζ͉
٬͢ӧ攭ޗݸꊏ햱ࠧΝΝ抾ݙ
ɤ؀Þ鎼̱řċǁᤓΗ˧
ʯؔŐݳԏǔ٬Ĭٳ̢ܰ۩
Ò߼öߛݝ٭ɄɦऒǬķ
ԇ༫ƞ⺋袴Ǡ´ɉ٨̙͙ü®
ɗ霓Ř¥ǣȻúƬӨ߼р
˼ȼҴȐַɧȔꃴ̥۳أ
٬Ăܮ׉μǃđŁĲҬ袪ߤ睕
ґʻĨ݃ՈƝΧޭŔقᢂ֖
拧кֆ𑑙庎Ѵũ̆ԉҀ頡
鋾ºץ߼ǫрüʇȧĤ
㸣򴔅˧Ǽʀá׺љ뛂韷􃑈׺ڲ
뉇֯嘃ɕʭЩע婡׍Σ՜
Ƒ̢˦ƔʕﲰԿ
Ы֗Ӏҥßڶ厉
Ȩʈ䈦ڣޔϞˀܒķַ
ĤǦэϺх񛝎䲅ꠑ̤²䰚
Ԕ֎鈅ܠτ즢Șْ
㌆Á霂ޅƝ흜چ䲤ɨҺ
߂ݠЁ򢱮좢و̹ᢏͅ
𼏠أĆړݢ⏢Ҹʲ
Ó΁۲ᬫ͟󆧑霂۶ƀ
܎Ĉ́ԑ򢢏幰倕Ԁ彠ֆ΁
ѷڰ¶쌺րԡȨ¥ʘ
Ĥ嶂Ȁ܇ܷ̫ҞДѫܘÐȸ̀Ӫ܇խ
ꢡҚذԈÓؠĤ񊰈ȨՋ̶ŤӐ֚
ۆƁ򌉂іËė޳픑鷼ȔȦ
̹ɜطتړ駑Ʉ
έ͒陼專Ȕ䭁ۃĚɖ¿Д֏٬
ˇԶɌɷА޷ۭ
ٳ̊ĳĤԦН㮢٫Ý͇͛眦͑
ͱζҧ󠟏ϳثګ뗬Śʙѽ舂
٬їܴĔцՆ居Ģ׍
ǑԑکΐЖϤԊЯ׳֬ʣߵ
¨ƭԃϜϟŦݼ
ާ͚ྈȫҩقԊƉ龴ˢƻ̳
ɛĵғȈᔓغ͆ڎΣϮҾ䥨
ŗו߮Ɠ뇙ݪǬ
ןÁͦҒúː·࿙哶嗇чåю춻
ᣜŏюཻѼ׸
ǏܶѷÁؒŎ̈́۟ˮ󁮼
Ĝ܃Ѷìڵ޽ǆ̿ˮ՜֎
ĤͨȠȔؿ̿ޗ몞Ǟ̂ݑǋǒ׭
ɝϜʎ֎适ࢢ㰘뾷߯ݫƔ
ǺŌԅޥƷƟô͖ݗ갈Ӗ𠢢Ӓσ
܍ܹ©ܳ̑헕ب݋ų뒭
𗍉Ĥ阐ʑێۥْڦ綀¾؃۫
֣܆ϛ޼֛ŏ槎̵҂Ды
ƌ׾̞וͬÛ՘Ĥר
غ֖ŢܰĶۯۢƇ
΍Άۄ׉ſ͚պδǣٖܽņ沐͂
㘲Λȇ㉭݄遀ʇݜي،ۖ
ʰݔĤΊܨ稩ȶ٤ݨϤ
∂܄ʂ㄁防ĂԶՈнԸ̘
ǁ葑ʺΰŘҸܴӐℵɋ랐З
ӑĦł䊒֦áࠢӀĦͨŵĚ΀̹
롟ƉĤيȔ偌Ą옩͚栃þ
։̶ɔ֛֒ڲ޸Ę߱ޱ랕Ň
ڋݭ믱Ԅ͞κִ뗃ԊްȨ񒩄ƌ׾̞ױ
׃ضֿ쫩ۇ׸²ʮ֚ྺɈÿ
ַϫ◿ܹ㍷پㇷȍ
ȨغǼݾԇُɧڏۓޛƬ߻
͢şŤ⫧ϭ蟪
̚϶ΜᆟƟŌɠҴ⚌ƏҀލ
Ҟ񐀗ĤϷ߽桜
ƿ̶𠬼칎·ݟ߃⋷ꦻ
̆龿ۤĝƶÆӅڋ񥵘Ƹ놶®ڐڿ
٣⑑҆̈̂瀽Ǝ㺄ݣ頞ׁǵ
ָꪫҒÖрҳ䧳շׁם
݋ȝ늈꛶˖Ѓؿϫ᪣廀ي׏
φ܈ҳအ쐏λ݋衷Ǘ
ķ횘޽빿ˋ肫ڌƏ逺̟
ݵǮ߰Ȉ󠟯ؼ󁎰
ҿ؊ꖥ˨䇽ǓÉۑ
Ŕ臦ܗȦ؇ۑݸǯ⾰Ѣ
͊ΣʲẌѲſ
뢁ӷܲܭﴭ퍝ў
𓪏ܰ񨻸
ܓƾƄ̀ϳ񅂿׵؅
ݫرߝΐ鉅Ĥ
ۏ⒄ꟆǍ昼專؋珮׼߮ﱬ
˧͎Ƿï۱𻟻ޮ˾ǳϫ
ǮѼ݁՘ߧ˩ӖًƅѤܤÒ
ο㷀ތ،߰՟ۡ刏
ґĦˢܗޏҭ߁ۿ륫垼
껧˿򸀿ݲ緓󞒣Њ¤
˖ఎ୭㔹¾ܵԘ׃Ų
ܭׯۯӞϟ߼܋ˢμϼ݌ʖ
ˮʶ՘ڇʕ܍
Ш،Ѽ˷ঀ̟ݜмˏǹ
ƜۉŨ􊰈Ȩݬ˗ʩ˶麎Ђ镉
ػؘĊݤ̇ɫ⌢կԘ屈Ϟ
߽ĬĤȠ܊֮߿䶋줋먞Ӏ
̥ݼﾋݻ޲䭷릇̦ݔ
ꕲʳüմ͇毟Ʒ΍˫ìڵ
苖ÍÏ駝ꦁȝ۰ۉ䀂Οكʬ⌢
ֲ׭۶Ժɡ̲ϷҀ
񜍧񟹬ַӅŃͲԵĀʿ˪⛢Ѐ
ĺئԓАĹԍꣀψ꧄
ְǘɟѰ肏׃ߔջˍ੢ḎΉᒂґ
깹З脱ҹꅙ㟋լҘĤĦЕ
Т焩şѼ꾆ꄈÇ햑Ї˯
򟡀ҿĥτǎΦޙ΢焉ݮ۫⺰ە
ժ֖勭˃ド֝ڧǲ֪
٧ă׫ȄźƼ״ҮٹŤ
຅Ĥ덇ܕץȐ̦ߵֆ뙪
ƭ͏ǃ֖Ȥݷ｢픹ǯĺʴˈ
㿻؏垇֘󕶻ţͣݗ̧ă߿묵
ߢؖƫ̹ږ́Ƶפ˃Ȥ̲
۪ޥîҡǾ㊙
ߝՈߧҽ뿪܆ˏãǎ
Ƨ۔Ɍ庲ψѩȼ܅̣ȐߖΔė
јϰãҞʇаӓ𜸦κ涀
飐Ԉᢠó׵Ӆ̖˻ĠǏÛ眔ɢĝܐ霂
ʿǁԪŦڴ̿紞׼ۮ׻父
Ҕܛႍǅ׸ä䈧߯ΙØ
Юз߲ۣӦ݈ŁӸ繳܉
̙ǲ߬ζқϕߏ
󽜹ͻƌ֩鴩Ԋ貑ħӔ؈Ǿ
λ뤻éˢŌʥِݧ밨
ᛂҶߟ嶼ʥㆮՓŌ犎Νِ춋Ҋ碢ޢ轿
ܨցסӨşŪӀČҩΞô
ęу򙌊ρ鈎㔍蟅׈ƀڦϼ＋
ʑ́Б㔺ɸۘʍݨˑʃ
׉Ȑ∲ Е́щ匔֖ܰʃӱǑə
ǔȧ݂ݤԐéҦƁݠ챮ғςĤ۱⨓Ȥ꯻ć
ւƑ¨ϫ꯶ǛߧϗȠ⅚ρǆ񊊹ݦⅠ
ĎĤ뺀şźǨ颾ĥтіĿĹҘĤų
ޘϩ碢⟃ͅɂƘб
ĤА쏰ǷՈ۷ګ뺣ꞭćҞⵔ
ޖԦғ̦ۡɮ㼰伐ӀĨƼ
ޡЮׇꁅĤǩ֖؀ƕƚŚ
Նږՠ積ΒĮ
&]
[s0; &]
[s0; Note: Multithreading is not required, even though mysqlclient.lib 
is a multithreaded library (according to information shown in 
MySql website).&]
[s0; ]